local addonName, AB = ...; 
local _
local buttons = {}

local AdditionalBinds_EventFrame = CreateFrame("Frame")
AdditionalBinds_EventFrame:RegisterEvent("ADDON_LOADED")
AdditionalBinds_EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
AdditionalBinds_EventFrame:SetScript("OnEvent", function(self,event,...) self[event](self,event,...);end)


function AdditionalBinds_EventFrame:ADDON_LOADED(self, addon)
	if addon == addonName then
		_G["BINDING_HEADER_ADDITIONALBINDS"] = 'Additional Bindings'

		local playerClass, playerUpperClass, playerClassId = UnitClass("Player")
	
		_G["BINDING_NAME_CLICK StopCastAttack-Btn:LeftButton"] = "Stop Casting/Attacking"
		_G["BINDING_NAME_CLICK Dismount-Btn:LeftButton"] = "Dismount"
		_G["BINDING_NAME_CLICK CancelBoP-Btn:LeftButton"] = "Cancel Hand of Protection"
		_G["BINDING_NAME_CLICK FocusMouseover-Btn:LeftButton"] = "Focus Mouseover"
		_G["BINDING_NAME_CLICK SwapActionBars-Btn:LeftButton"] = "Swap Action Bars (Toggle)"
		
		for i = 1,5 do
			_G["BINDING_NAME_CLICK TargetArena"..i.."-Btn:LeftButton"] = "Target Arena "..i
			_G["BINDING_NAME_CLICK FocusArena"..i.."-Btn:LeftButton"] = "Focus Arena "..i
		end

		for i = 1,5 do
			x = i-1

			if x == 0 then
				_G["BINDING_NAME_CLICK TargetParty"..x.."-Btn:LeftButton"] = "Target Player (No Pet)"
			else
				_G["BINDING_NAME_CLICK TargetParty"..x.."-Btn:LeftButton"] = "Target Party "..x.." (No Pet)"
			end
		end


		_G["BINDING_NAME_CLICK TargetGargoyle-Btn:LeftButton"] = "Target Ebon Gargoyle"

		-- Druid
		_G["BINDING_NAME_CLICK CancelForms-Btn:LeftButton"] = "Cancel Forms"
		_G["BINDING_NAME_CLICK BearForm-Btn:LeftButton"] = "Bear Form"
		_G["BINDING_NAME_CLICK AquaticForm-Btn:LeftButton"] = "Aquatic Form"
		_G["BINDING_NAME_CLICK CatForm-Btn:LeftButton"] = "Cat Form"
		_G["BINDING_NAME_CLICK TravelForm-Btn:LeftButton"] = "Travel Form"
		_G["BINDING_NAME_CLICK MoonkinForm-Btn:LeftButton"] = "Moonkin Form"
		_G["BINDING_NAME_CLICK TreeOfLife-Btn:LeftButton"] = "Tree of Life"
		_G["BINDING_NAME_CLICK FlightForm-Btn:LeftButton"] = "Flight Form"
		_G["BINDING_NAME_CLICK NSHealingTouch-Btn:LeftButton"] = "Nature's Swiftness + Healing Touch"
		_G["BINDING_NAME_CLICK NSRegrowth-Btn:LeftButton"] = "Nature's Swiftness + Regrowth"
		_G["BINDING_NAME_CLICK NSCyclone-Btn:LeftButton"] = "Nature's Swiftness + Cyclone"
		_G["BINDING_NAME_CLICK NSHibernate-Btn:LeftButton"] = "Nature's Swiftness + Hibernate"
		_G["BINDING_NAME_CLICK NSWrath-Btn:LeftButton"] = "Nature's Swiftness + Cyclone"
		_G["BINDING_NAME_CLICK CatSkullBash-Btn:LeftButton"] = "Skull Bash (Cat Form)"
		_G["BINDING_NAME_CLICK BearSkullBash-Btn:LeftButton"] = "Skull Bash (Cat Form)"
		_G["BINDING_NAME_CLICK SkullBash1-Btn:LeftButton"] = "Skull Bash (Both - Prioritizing Cat Form)"
		_G["BINDING_NAME_CLICK SkullBash2-Btn:LeftButton"] = "Skull Bash (Both - Prioritizing Bear Form)"
		_G["BINDING_NAME_CLICK FaerieFire-Btn:LeftButton"] = "Faerie Fire (Normal / Feral)"
		_G["BINDING_NAME_CLICK FocusCyclone-Btn:LeftButton"] = "Focus Cyclone"
		_G["BINDING_NAME_CLICK FocusHibernate-Btn:LeftButton"] = "Focus Hibernate"
		_G["BINDING_NAME_CLICK FocusBash-Btn:LeftButton"] = "Focus Bash"
		_G["BINDING_NAME_CLICK FocusCatSkullBash-Btn:LeftButton"] = "Focus Skull Bash (Cat Form)"
		_G["BINDING_NAME_CLICK FocusBearSkullBash-Btn:LeftButton"] = "Focus Skull Bash (Bear Form)"
		_G["BINDING_NAME_CLICK FocusSkullBash1-Btn:LeftButton"] = "Focus Skull Bash (Both - Prioritizing Cat Form)"
		_G["BINDING_NAME_CLICK FocusSkullBash2-Btn:LeftButton"] = "Focus Skull Bash (Both - Prioritizing Bear Form)"
		_G["BINDING_NAME_CLICK FocusFaerieFire-Btn:LeftButton"] = "Focus Faerie Fire (Normal / Feral)"
		_G["BINDING_NAME_CLICK FocusEntanglingRoots-Btn:LeftButton"] = "Focus Entangling Roots"
		_G["BINDING_NAME_CLICK FocusSolarBeam-Btn:LeftButton"] = "Focus Solar Beam"
		_G["BINDING_NAME_CLICK FocusMoonfire-Btn:LeftButton"] = "Focus Moonfire"
		_G["BINDING_NAME_CLICK FocusInsectSwarm-Btn:LeftButton"] = "Focus Insect Swarm"
		_G["BINDING_NAME_CLICK MouseoverCyclone-Btn:LeftButton"] = "Mouseover Cyclone"
		_G["BINDING_NAME_CLICK MouseoverHibernate-Btn:LeftButton"] = "Mouseover Hibernate"
		_G["BINDING_NAME_CLICK MouseoverEntanglingRoots-Btn:LeftButton"] = "Mouseover Entangling Roots"
		_G["BINDING_NAME_CLICK MouseoverRebirth-Btn:LeftButton"] = "Mouseover Rebirth"
		_G["BINDING_NAME_CLICK MouseoverGrowl-Btn:LeftButton"] = "Mouseover Growl"
		_G["BINDING_NAME_CLICK MouseoverCatSkullBash-Btn:LeftButton"] = "Mouseover Skull Bash (Cat Form)"
		_G["BINDING_NAME_CLICK MouseoverBearSkullBash-Btn:LeftButton"] = "Mouseover Skull Bash (Bear Form)"
		_G["BINDING_NAME_CLICK MouseoverSkullBash1-Btn:LeftButton"] = "Mouseover Skull Bash (Both - Prioritizing Cat Form)"
		_G["BINDING_NAME_CLICK MouseoverSkullBash2-Btn:LeftButton"] = "Mouseover Skull Bash (Both - Prioritizing Bear Form)"

		for i = 1,5 do
			_G["BINDING_NAME_CLICK CycloneArena"..i.."-Btn:LeftButton"] = "Cyclone Arena "..i
			_G["BINDING_NAME_CLICK BashArena"..i.."-Btn:LeftButton"] = "Bash Arena "..i
			_G["BINDING_NAME_CLICK EntanglingRootsArena"..i.."-Btn:LeftButton"] = "Entangling Roots Arena "..i
			_G["BINDING_NAME_CLICK SolarBeamArena"..i.."-Btn:LeftButton"] = "Solar Beam  Arena "..i
			_G["BINDING_NAME_CLICK CatSkullBashArena"..i.."-Btn:LeftButton"] = "Skull Bash (Cat Form) "..i
			_G["BINDING_NAME_CLICK BearSkullBashArena"..i.."-Btn:LeftButton"] = "Skull Bash (Bear Form) Arena "..i
			_G["BINDING_NAME_CLICK SkullBash1Arena"..i.."-Btn:LeftButton"] = "Skull Bash (Both - Prioritizing Cat Form) Arena "..i
			_G["BINDING_NAME_CLICK SkullBash2Arena"..i.."-Btn:LeftButton"] = "Skull Bash (Both - Prioritizing Cat Form) Arena "..i
			_G["BINDING_NAME_CLICK FaerieFireArena"..i.."-Btn:LeftButton"] = "Faerie Fire Arena "..i
			_G["BINDING_NAME_CLICK HibernateArena"..i.."-Btn:LeftButton"] = "Hibernate Arena "..i
			_G["BINDING_NAME_CLICK HibernateArenaPet"..i.."-Btn:LeftButton"] = "Hibernate Arena Pet "..i
			_G["BINDING_NAME_CLICK SootheArena"..i.."-Btn:LeftButton"] = "Soothe Arena "..i
		end

		for i = 1,5 do
			x = i-1

			if x == 0 then
				_G["BINDING_NAME_CLICK RemoveCorruptionParty"..x.."-Btn:LeftButton"] = "Remove Corruption Player"
			else 
				_G["BINDING_NAME_CLICK RemoveCorruptionParty"..x.."-Btn:LeftButton"] = "Remove Corruption Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK HealingTouchParty"..x.."-Btn:LeftButton"] = "Healing Touch Player"
			else 
				_G["BINDING_NAME_CLICK HealingTouchParty"..x.."-Btn:LeftButton"] = "Healing Touch Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK RegrowthParty"..x.."-Btn:LeftButton"] = "Regrowth Player"
			else 
				_G["BINDING_NAME_CLICK RegrowthParty"..x.."-Btn:LeftButton"] = "Regrowth Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK RejuvenationParty"..x.."-Btn:LeftButton"] = "Rejuvenation Player"
			else 
				_G["BINDING_NAME_CLICK RejuvenationParty"..x.."-Btn:LeftButton"] = "Rejuvenation Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK LifebloomParty"..x.."-Btn:LeftButton"] = "Lifebloom Player"
			else 
				_G["BINDING_NAME_CLICK LifebloomParty"..x.."-Btn:LeftButton"] = "Lifebloom Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK InnervateParty"..x.."-Btn:LeftButton"] = "Innervate Player"
			else 
				_G["BINDING_NAME_CLICK InnervateParty"..x.."-Btn:LeftButton"] = "Innervate Party "..x
			end
		end


		-- Priest
		_G["BINDING_NAME_CLICK CancelShield-Btn:LeftButton"] = "Cancel Power Word: Shield"
		_G["BINDING_NAME_CLICK CancelLevitate-Btn:LeftButton"] = "Cancel Levitate"
		_G["BINDING_NAME_CLICK CancelChakra1-Btn:LeftButton"] = "Cancel Chakra"
		_G["BINDING_NAME_CLICK CancelChakra2-Btn:LeftButton"] = "Cancel Chakra: Serenity/Sanctuary"
		_G["BINDING_NAME_CLICK CancelDispersion-Btn:LeftButton"] = "Cancel Dispersion"
		_G["BINDING_NAME_CLICK ShackleGargoyle-Btn:LeftButton"] = "Shackle Undead Ebon Gargoyle"
		_G["BINDING_NAME_CLICK FocusDeath-Btn:LeftButton"] = "Focus Shadow Word: Death"
		_G["BINDING_NAME_CLICK FocusDispelMagic-Btn:LeftButton"] = "Focus Dispel Magic (Harm)"
		_G["BINDING_NAME_CLICK FocusPain-Btn:LeftButton"] = "Focus Shadow Word: Pain"
		_G["BINDING_NAME_CLICK FocusDevouring-Btn:LeftButton"] = "Focus Devouring Plague"
		_G["BINDING_NAME_CLICK FocusVampiricTouch-Btn:LeftButton"] = "Focus Vampiric Touch"
		_G["BINDING_NAME_CLICK FocusMindFlay-Btn:LeftButton"] = "Focus Mind Flay"
		_G["BINDING_NAME_CLICK FocusMindControl-Btn:LeftButton"] = "Focus Mind Control"
		_G["BINDING_NAME_CLICK FocusManaBurn-Btn:LeftButton"] = "Focus Mana Burn"
		_G["BINDING_NAME_CLICK FocusShackle-Btn:LeftButton"] = "Focus Shackle Undead"
		_G["BINDING_NAME_CLICK FocusSilence-Btn:LeftButton"] = "Focus Silence"
		_G["BINDING_NAME_CLICK FocusHorror-Btn:LeftButton"] = "Focus Psychic Horror"
		_G["BINDING_NAME_CLICK MouseoverDeath-Btn:LeftButton"] = "Mouseover Shadow Word: Death"
		_G["BINDING_NAME_CLICK MouseoverLeapOfFaith-Btn:LeftButton"] = "Mouseover Leap of Faith"
		_G["BINDING_NAME_CLICK MouseoverMindControl-Btn:LeftButton"] = "Mouseover Mind Control"
		_G["BINDING_NAME_CLICK MouseoverDispelMagic-Btn:LeftButton"] = "Mouseover Dispel Magic (Harm)"
		_G["BINDING_NAME_CLICK MouseoverShackle-Btn:LeftButton"] = "Mouseover Shackle Undead"
		_G["BINDING_NAME_CLICK MouseoverPSGS-Btn:LeftButton"] = "Mouseover Pain Suppression/Guardian Spirit"
		
		for i = 1,5 do
			_G["BINDING_NAME_CLICK DeathArena"..i.."-Btn:LeftButton"] = "Shadow Word: Death Arena "..i
			_G["BINDING_NAME_CLICK DispelMagicArena"..i.."-Btn:LeftButton"] = "Dispel Magic Arena "..i
			_G["BINDING_NAME_CLICK SilenceArena"..i.."-Btn:LeftButton"] = "Silence Arena "..i
			_G["BINDING_NAME_CLICK HorrorArena"..i.."-Btn:LeftButton"] = "Psychic Horror Arena "..i
			_G["BINDING_NAME_CLICK MindControlArena"..i.."-Btn:LeftButton"] = "Mind Control Arena "..i
			_G["BINDING_NAME_CLICK PainArena"..i.."-Btn:LeftButton"] = "Shadow Word: Pain Arena "..i
			_G["BINDING_NAME_CLICK ShadowfiendArena"..i.."-Btn:LeftButton"] = "Shadowfiend Arena "..i
			_G["BINDING_NAME_CLICK ShackleArena"..i.."-Btn:LeftButton"] = "Shackle Undead Arena "..i
			_G["BINDING_NAME_CLICK ShackleArenaPet"..i.."-Btn:LeftButton"] = "Shackle Undead Arena Pet "..i
		end


		for i = 1,5 do
			x = i-1

			if x == 0 then
				_G["BINDING_NAME_CLICK DispelMagicParty"..x.."-Btn:LeftButton"] = "Dispel Magic Player"
			else 
				_G["BINDING_NAME_CLICK DispelMagicParty"..x.."-Btn:LeftButton"] = "Dispel Magic Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK CureDiseaseParty"..x.."-Btn:LeftButton"] = "Cure Disease Player"
			else 
				_G["BINDING_NAME_CLICK CureDiseaseParty"..x.."-Btn:LeftButton"] = "Cure Disease Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK PSGSParty"..x.."-Btn:LeftButton"] = "Pain Suppression/Guardian Spirit Player"
			else 
				_G["BINDING_NAME_CLICK PSGSParty"..x.."-Btn:LeftButton"] = "Pain Suppression/Guardian Spirit Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK FearWardParty"..x.."-Btn:LeftButton"] = "Fear Ward Player"
			else 
				_G["BINDING_NAME_CLICK FearWardParty"..x.."-Btn:LeftButton"] = "Fear Ward Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK PowerInfusionParty"..x.."-Btn:LeftButton"] = "Power Infusion Player"
			else 
				_G["BINDING_NAME_CLICK PowerInfusionParty"..x.."-Btn:LeftButton"] = "Power Infusion Party "..x
			end

			if x ~= 0 then
				_G["BINDING_NAME_CLICK LeapOfFaithParty"..x.."-Btn:LeftButton"] = "Leap of Faith Party "..x
				_G["BINDING_NAME_CLICK MindSearParty"..x.."-Btn:LeftButton"] = "Mind Sear Party "..x
			end
		end


		-- Shaman
		_G["BINDING_NAME_CLICK CancelGhostWolf-Btn:LeftButton"] = "Cancel Ghost Wolf"
		_G["BINDING_NAME_CLICK CancelAir-Btn:LeftButton"] = "Cancel Air Totem"
		_G["BINDING_NAME_CLICK CancelWater-Btn:LeftButton"] = "Cancel Water Totem"
		_G["BINDING_NAME_CLICK CancelEarth-Btn:LeftButton"] = "Cancel Earth Totem"
		_G["BINDING_NAME_CLICK CancelFire-Btn:LeftButton"] = "Cancel Fire Totem"
		_G["BINDING_NAME_CLICK CancelTotems-Btn:LeftButton"] = "Cancel All Totems"
		_G["BINDING_NAME_CLICK Flametongue-Btn:LeftButton"] = "Flametongue Weapon"
		_G["BINDING_NAME_CLICK Windfury-Btn:LeftButton"] = "Windfury Weapon"
		_G["BINDING_NAME_CLICK Earthliving-Btn:LeftButton"] = "Earthliving Weapon"
		_G["BINDING_NAME_CLICK Frostbrand-Btn:LeftButton"] = "Frostbrand Weapon"
		_G["BINDING_NAME_CLICK Rockbiter-Btn:LeftButton"] = "Rockbiter Weapon"
		_G["BINDING_NAME_CLICK MouseoverHex-Btn:LeftButton"] = "Mouseover Hex"
		_G["BINDING_NAME_CLICK MouseoverWindShear-Btn:LeftButton"] = "Mouseover Wind Shear"
		_G["BINDING_NAME_CLICK MouseoverPurge-Btn:LeftButton"] = "Mouseover Wind Shear"
		_G["BINDING_NAME_CLICK MouseoverBindElemental-Btn:LeftButton"] = "Mouseover Bind Elemental"
		_G["BINDING_NAME_CLICK BindElementalWaterElemental-Btn:LeftButton"] = "Bind Elemental Water Elemental"
		_G["BINDING_NAME_CLICK NSGreaterHeal-Btn:LeftButton"] = "Nature's Swiftness + Greater Healing Wave"
		_G["BINDING_NAME_CLICK NSChainHeal-Btn:LeftButton"] = "Nature's Swiftness + Chain Heal"
		_G["BINDING_NAME_CLICK NSHex-Btn:LeftButton"] = "Nature's Swiftness + Hex"
		_G["BINDING_NAME_CLICK NSLightningBolt-Btn:LeftButton"] = "Nature's Swiftness + Lightning Bolt"
		_G["BINDING_NAME_CLICK NSChainLightning-Btn:LeftButton"] = "Nature's Swiftness + Chain Lightning"
		_G["BINDING_NAME_CLICK EMLavaBurst-Btn:LeftButton"] = "Elemental Mastery + Lava Burst"
		_G["BINDING_NAME_CLICK EMLightningBolt-Btn:LeftButton"] = "Elemental Mastery + Lightning Bolt"
		_G["BINDING_NAME_CLICK EMChainLightning-Btn:LeftButton"] = "Elemental Mastery + Chain Lightning"
		_G["BINDING_NAME_CLICK FocusWindShear-Btn:LeftButton"] = "Focus Wind Shear"
		_G["BINDING_NAME_CLICK FocusPurge-Btn:LeftButton"] = "Focus Purge"
		_G["BINDING_NAME_CLICK FocusHex-Btn:LeftButton"] = "Focus Hex"
		_G["BINDING_NAME_CLICK FocusNSHex-Btn:LeftButton"] = "Focus Nature's Swiftness + Hex"
		_G["BINDING_NAME_CLICK FocusFlameShock-Btn:LeftButton"] = "Focus Flame Shock"
		_G["BINDING_NAME_CLICK FocusFrostShock-Btn:LeftButton"] = "Focus Frost Shock"
		_G["BINDING_NAME_CLICK FocusEarthShock-Btn:LeftButton"] = "Focus Earth Shock"
		_G["BINDING_NAME_CLICK FocusBindElemental-Btn:LeftButton"] = "Focus Bind Elemental"
		_G["BINDING_NAME_CLICK FocusPetBash-Btn:LeftButton"] = "Focus Bash (Feral Spirit)"

		for i = 1,5 do
			_G["BINDING_NAME_CLICK WindShearArena"..i.."-Btn:LeftButton"] = "Wind Shear Arena "..i
			_G["BINDING_NAME_CLICK PurgeArena"..i.."-Btn:LeftButton"] = "Purge Arena "..i
			_G["BINDING_NAME_CLICK HexArena"..i.."-Btn:LeftButton"] = "Hex Arena "..i
			_G["BINDING_NAME_CLICK NSHexArena"..i.."-Btn:LeftButton"] = "Nature's Swiftness + Hex Arena "..i
			_G["BINDING_NAME_CLICK PetBashArena"..i.."-Btn:LeftButton"] = "Bash (Feral Spirit) Arena "..i
			_G["BINDING_NAME_CLICK BindElementalArenaPet"..i.."-Btn:LeftButton"] = "Bind Elemental Arena Pet "..i
		end

		for i = 1,5 do
			x = i-1

			if x == 0 then
				_G["BINDING_NAME_CLICK CleanseSpiritParty"..x.."-Btn:LeftButton"] = "Cleanse Spirit Player"
			else 
				_G["BINDING_NAME_CLICK CleanseSpiritParty"..x.."-Btn:LeftButton"] = "Cleanse Spirit Party "..x
			end
		end


		-- Paladin
		_G["BINDING_NAME_CLICK CancelDivineShield-Btn:LeftButton"] = "Cancel Divine Shield"
		_G["BINDING_NAME_CLICK CancelDivineShieldBoP-Btn:LeftButton"] = "Cancel Divine Shield + Hand of Protection"
		_G["BINDING_NAME_CLICK CancelDivinePlea-Btn:LeftButton"] = "Cancel Divine Plea"
		_G["BINDING_NAME_CLICK CancelRighteousFury-Btn:LeftButton"] = "Cancel Righteous Fury"
		_G["BINDING_NAME_CLICK DevotionAura-Btn:LeftButton"] = "Devotion Aura (Sticky)"
		_G["BINDING_NAME_CLICK RetributionAura-Btn:LeftButton"] = "Retribution Aura (Sticky)"
		_G["BINDING_NAME_CLICK ConcentrationAura-Btn:LeftButton"] = "Concentration Aura (Sticky)"
		_G["BINDING_NAME_CLICK ResistanceAura-Btn:LeftButton"] = "Resistance Aura (Sticky)"
		_G["BINDING_NAME_CLICK CrusaderAura-Btn:LeftButton"] = "Crusader Aura (Sticky)"
		_G["BINDING_NAME_CLICK TurnEvilGargoyle-Btn:LeftButton"] = "Turn Evil Ebon Gargoyle"
		_G["BINDING_NAME_CLICK FocusHoJ-Btn:LeftButton"] = "Focus Hammer of Justice"
		_G["BINDING_NAME_CLICK FocusRebuke-Btn:LeftButton"] = "Focus Rebuke"
		_G["BINDING_NAME_CLICK FocusRepentance-Btn:LeftButton"] = "Focus Repentance"
		_G["BINDING_NAME_CLICK FocusCrusaderStrike-Btn:LeftButton"] = "Focus Crusader Strike"
		_G["BINDING_NAME_CLICK FocusExorcism-Btn:LeftButton"] = "Focus Exorcism"
		_G["BINDING_NAME_CLICK FocusHammerOfWrath-Btn:LeftButton"] = "Focus Hammer of Wrath"
		_G["BINDING_NAME_CLICK FocusTurnEvil-Btn:LeftButton"] = "Focus Turn Evil"
		_G["BINDING_NAME_CLICK MouseoverCrusaderStrike-Btn:LeftButton"] = "Mouseover Crusader Strike"
		_G["BINDING_NAME_CLICK MouseoverLayOnHands-Btn:LeftButton"] = "Mouseover Lay on Hands"
		_G["BINDING_NAME_CLICK MouseoverHoJ-Btn:LeftButton"] = "Mouseover Hammer of Justice"
		_G["BINDING_NAME_CLICK MouseoverRepentance-Btn:LeftButton"] = "Mouseover Repentance"
		_G["BINDING_NAME_CLICK MouseoverJudgement-Btn:LeftButton"] = "Mouseover Judgement"
		_G["BINDING_NAME_CLICK MouseoverBoP-Btn:LeftButton"] = "Mouseover Hand of Protection"
		_G["BINDING_NAME_CLICK MouseoverSacrifice-Btn:LeftButton"] = "Mouseover Hand of Sacrifice"
		_G["BINDING_NAME_CLICK MouseoverSalvation-Btn:LeftButton"] = "Mouseover Hand of Salvation"
		_G["BINDING_NAME_CLICK MouseoverHammerOfWrath-Btn:LeftButton"] = "Mouseover Hammer of Wrath"
		_G["BINDING_NAME_CLICK MouseoverReckoning-Btn:LeftButton"] = "Mouseover Hand of Reckoning"
		_G["BINDING_NAME_CLICK MouseoverRighteousDefense-Btn:LeftButton"] = "Mouseover Righteous Defense"

		for i = 1,5 do
			_G["BINDING_NAME_CLICK HoJArena"..i.."-Btn:LeftButton"] = "Hammer of Justice Arena "..i
			_G["BINDING_NAME_CLICK RebukeArena"..i.."-Btn:LeftButton"] = "Rebuke Arena "..i
			_G["BINDING_NAME_CLICK RepentanceArena"..i.."-Btn:LeftButton"] = "Repentance Arena "..i
			_G["BINDING_NAME_CLICK ExorcismArena"..i.."-Btn:LeftButton"] = "Exorcism Arena "..i
			_G["BINDING_NAME_CLICK JudgementArena"..i.."-Btn:LeftButton"] = "Judgement Arena "..i
			_G["BINDING_NAME_CLICK HammerOfWrathArena"..i.."-Btn:LeftButton"] = "Hammer of Wrath Arena "..i
			_G["BINDING_NAME_CLICK TurnEvilArena"..i.."-Btn:LeftButton"] = "Turn Evil Arena "..i
			_G["BINDING_NAME_CLICK TurnEvilArenaPet"..i.."-Btn:LeftButton"] = "Turn Evil Arena Pet "..i
			_G["BINDING_NAME_CLICK TauntArena"..i.."-Btn:LeftButton"] = "Hand of Reckoning Arena "..i
			_G["BINDING_NAME_CLICK TauntArenaPet"..i.."-Btn:LeftButton"] = "Hand of Reckoning Arena Pet "..i
		end

		for i = 1,5 do
			x = i-1

			if x == 0 then
				_G["BINDING_NAME_CLICK CleanseParty"..x.."-Btn:LeftButton"] = "Cleanse Player"
			else 
				_G["BINDING_NAME_CLICK CleanseParty"..x.."-Btn:LeftButton"] = "Cleanse Party "..x
			end
			
			if x == 0 then
				_G["BINDING_NAME_CLICK FreedomParty"..x.."-Btn:LeftButton"] = "Hand of Freedom Player"
			else 
				_G["BINDING_NAME_CLICK FreedomParty"..x.."-Btn:LeftButton"] = "Hand of Freedom Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK BoPParty"..x.."-Btn:LeftButton"] = "Hand of Protection Player"
			else 
				_G["BINDING_NAME_CLICK BoPParty"..x.."-Btn:LeftButton"] = "Hand of Protection Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK SalvationParty"..x.."-Btn:LeftButton"] = "Hand of Salvation Player"
			else 
				_G["BINDING_NAME_CLICK SalvationParty"..x.."-Btn:LeftButton"] = "Hand of Salvation Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK WoGParty"..x.."-Btn:LeftButton"] = "Word of Glory Player"
			else 
				_G["BINDING_NAME_CLICK WoGParty"..x.."-Btn:LeftButton"] = "Word of Glory Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK BeaconParty"..x.."-Btn:LeftButton"] = "Beacon of Light Player"
			else 
				_G["BINDING_NAME_CLICK BeaconParty"..x.."-Btn:LeftButton"] = "Beacon of Light Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK LayOnHandsParty"..x.."-Btn:LeftButton"] = "Lay on Hands Player"
			else 
				_G["BINDING_NAME_CLICK LayOnHandsParty"..x.."-Btn:LeftButton"] = "Lay on Hands Party "..x
			end

			if x ~= 0 then
				_G["BINDING_NAME_CLICK SacrificeParty"..x.."-Btn:LeftButton"] = "Hand of Sacrifice Party "..x
				_G["BINDING_NAME_CLICK TauntParty"..x.."-Btn:LeftButton"] = "Righteous Defense Party "..x
			end
		end

		-- Mage
		_G["BINDING_NAME_CLICK CancelManaShield-Btn:LeftButton"] = "Cancel Mana Shield"
		_G["BINDING_NAME_CLICK CancelSlowFall-Btn:LeftButton"] = "Cancel Slow Fall"
		_G["BINDING_NAME_CLICK CancelBlock-Btn:LeftButton"] = "Cancel Ice Block"
		_G["BINDING_NAME_CLICK CancelSacrifice-Btn:LeftButton"] = "Cancel Hand of Sacrifice"
		_G["BINDING_NAME_CLICK FastBlock-Btn:LeftButton"] = "Fast Ice Block"
		_G["BINDING_NAME_CLICK FocusSheep-Btn:LeftButton"] = "Focus Polymorph"
		_G["BINDING_NAME_CLICK FocusCS-Btn:LeftButton"] = "Focus Counterspell"
		_G["BINDING_NAME_CLICK FocusLivingBomb-Btn:LeftButton"] = "Focus Living Bomb"
		_G["BINDING_NAME_CLICK FocusSlow-Btn:LeftButton"] = "Focus Slow"
		_G["BINDING_NAME_CLICK FocusFrostbolt-Btn:LeftButton"] = "Focus Frostbolt"
		_G["BINDING_NAME_CLICK FocusFireBlast-Btn:LeftButton"] = "Focus Fire Blast"
		_G["BINDING_NAME_CLICK FocusIceLance-Btn:LeftButton"] = "Focus Ice Lance"
		_G["BINDING_NAME_CLICK FocusSpellsteal-Btn:LeftButton"] = "Focus Spellsteal"
		_G["BINDING_NAME_CLICK MouseoverCS-Btn:LeftButton"] = "Mouseover Counterspell"
		_G["BINDING_NAME_CLICK MouseoverSheep-Btn:LeftButton"] = "Mouseover Polymorph"
		_G["BINDING_NAME_CLICK MouseoverRemoveCurse-Btn:LeftButton"] = "Mouseover Remove Curse"
		_G["BINDING_NAME_CLICK MouseoverFrostbolt-Btn:LeftButton"] = "Mouseover Frostbolt"
		_G["BINDING_NAME_CLICK PoMSheep-Btn:LeftButton"] = "Pressence of Mind + Polymorph"
		_G["BINDING_NAME_CLICK PoMFocusSheep-Btn:LeftButton"] = "Presence of Mind + Focus Polymorph"
		_G["BINDING_NAME_CLICK PoMRing-Btn:LeftButton"] = "Presence of Mind + Ring of Frost"
		_G["BINDING_NAME_CLICK PoMArcaneBlast-Btn:LeftButton"] = "Presence of Mind + Arcane Blast"
		_G["BINDING_NAME_CLICK PoMFrostbolt-Btn:LeftButton"] = "Presence of Mind + Frostbolt"

		for i = 1,5 do
			_G["BINDING_NAME_CLICK SheepArena"..i.."-Btn:LeftButton"] = "Polymorph Arena "..i
			_G["BINDING_NAME_CLICK CSArena"..i.."-Btn:LeftButton"] = "Counterspell Arena "..i
			_G["BINDING_NAME_CLICK SlowArena"..i.."-Btn:LeftButton"] = "Slow Arena "..i
			_G["BINDING_NAME_CLICK LivingBombArena"..i.."-Btn:LeftButton"] = "Living Bomb Arena "..i
			_G["BINDING_NAME_CLICK FrostboltArena"..i.."-Btn:LeftButton"] = "Frostbolt Arena "..i
			_G["BINDING_NAME_CLICK FireBlastArena"..i.."-Btn:LeftButton"] = "Fire Blast Arena "..i
			_G["BINDING_NAME_CLICK IceLanceArena"..i.."-Btn:LeftButton"] = "Ice Lance Arena "..i
			_G["BINDING_NAME_CLICK SpellstealArena"..i.."-Btn:LeftButton"] = "Spellsteal Arena "..i
		end

		for i = 1,5 do
			x = i-1

			if x == 0 then
				_G["BINDING_NAME_CLICK RemoveCurseParty"..x.."-Btn:LeftButton"] = "Remove Curse Player"
			else 
				_G["BINDING_NAME_CLICK RemoveCurseParty"..x.."-Btn:LeftButton"] = "Remove Curse Party "..x
			end
		end


		-- Warlock
		_G["BINDING_NAME_CLICK CancelFelstorm-Btn:LeftButton"] = "Cancel Felstorm"
		_G["BINDING_NAME_CLICK FocusLock-Btn:LeftButton"] = "Focus Spell Lock"
		_G["BINDING_NAME_CLICK FocusDevour-Btn:LeftButton"] = "Focus Devour Magic"
		_G["BINDING_NAME_CLICK FocusSeduce-Btn:LeftButton"] = "Focus Seduction"
		_G["BINDING_NAME_CLICK FocusAxeToss-Btn:LeftButton"] = "Focus Axe Toss"
		_G["BINDING_NAME_CLICK FocusPursuit-Btn:LeftButton"] = "Focus Pursuit"
		_G["BINDING_NAME_CLICK FocusUA-Btn:LeftButton"] = "Focus Unstable Affliction"
		_G["BINDING_NAME_CLICK FocusChaosBolt-Btn:LeftButton"] = "Focus Chaos Bolt"
		_G["BINDING_NAME_CLICK FocusCoil-Btn:LeftButton"] = "Focus Death Coil"
		_G["BINDING_NAME_CLICK FocusConflag-Btn:LeftButton"] = "Focus Conflagrate"
		_G["BINDING_NAME_CLICK FocusExhaust-Btn:LeftButton"] = "Focus Curse of Exhaustion"
		_G["BINDING_NAME_CLICK FocusTongues-Btn:LeftButton"] = "Focus Curse of Tongues"
		_G["BINDING_NAME_CLICK FocusSoulSwap-Btn:LeftButton"] = "Focus Soul Swap"
		_G["BINDING_NAME_CLICK FocusShadowburn-Btn:LeftButton"] = "Focus Shadowburn"
		_G["BINDING_NAME_CLICK FocusHavoc-Btn:LeftButton"] = "Focus Bane of Havoc"
		_G["BINDING_NAME_CLICK MouseoverFear-Btn:LeftButton"] = "Mouseover Fear"
		_G["BINDING_NAME_CLICK MouseoverLock-Btn:LeftButton"] = "Mouseover Spell Lock"
		_G["BINDING_NAME_CLICK MouseoverDevour-Btn:LeftButton"] = "Mouseover Devour Magic"
		_G["BINDING_NAME_CLICK MouseoverSeduce-Btn:LeftButton"] = "Mouseover Seduction"
		_G["BINDING_NAME_CLICK MouseoverAxeToss-Btn:LeftButton"] = "Mouseover Axe Toss"
		_G["BINDING_NAME_CLICK MouseoverSinge-Btn:LeftButton"] = "Mouseover Singe Magic"
		_G["BINDING_NAME_CLICK MouseoverExhaust-Btn:LeftButton"] = "Mouseover Curse of Exhaustion"
		_G["BINDING_NAME_CLICK MouseoverTongues-Btn:LeftButton"] = "Mouseover Curse of Tongues"
		_G["BINDING_NAME_CLICK MouseoverHavoc-Btn:LeftButton"] = "Mouseover Bane of Havoc"

		for i = 1,5 do
			_G["BINDING_NAME_CLICK FearArena"..i.."-Btn:LeftButton"] = "Fear Arena "..i
			_G["BINDING_NAME_CLICK CoilArena"..i.."-Btn:LeftButton"] = "Death Coil Arena "..i
			_G["BINDING_NAME_CLICK LockArena"..i.."-Btn:LeftButton"] = "Spell Lock Arena "..i
			_G["BINDING_NAME_CLICK DevourArena"..i.."-Btn:LeftButton"] = "Devour Magic Arena "..i
			_G["BINDING_NAME_CLICK SeduceArena"..i.."-Btn:LeftButton"] = "Seduction Arena "..i
			_G["BINDING_NAME_CLICK AxeTossArena"..i.."-Btn:LeftButton"] = "Axe Toss Arena "..i
			_G["BINDING_NAME_CLICK PursuitArena"..i.."-Btn:LeftButton"] = "Pursuit Arena "..i
			_G["BINDING_NAME_CLICK UAArena"..i.."-Btn:LeftButton"] = "Unstable Affliction Arena "..i
			_G["BINDING_NAME_CLICK ExhaustArena"..i.."-Btn:LeftButton"] = "Curse of Exhaustion Arena "..i
			_G["BINDING_NAME_CLICK TonguesArena"..i.."-Btn:LeftButton"] = "Curse of Tongues Arena "..i
			_G["BINDING_NAME_CLICK ShadowburnArena"..i.."-Btn:LeftButton"] = "Shadowburn Arena "..i
			_G["BINDING_NAME_CLICK ConflagArena"..i.."-Btn:LeftButton"] = "Conflagrate Arena "..i
			_G["BINDING_NAME_CLICK SoulSwapArena"..i.."-Btn:LeftButton"] = "Soul Swap Arena "..i
			_G["BINDING_NAME_CLICK HavocArena"..i.."-Btn:LeftButton"] = "Bane of Havoc Arena "..i
		end

		for i = 1,5 do
			x = i-1

			if x == 0 then
				_G["BINDING_NAME_CLICK SingeParty"..x.."-Btn:LeftButton"] = "Singe Magic Player"
			else 
				_G["BINDING_NAME_CLICK SingeParty"..x.."-Btn:LeftButton"] = "Singe Magic Party "..x
			end
		end


		-- Warrior
		_G["BINDING_NAME_CLICK CancelStorm-Btn:LeftButton"] = "Cancel Bladestorm"
		_G["BINDING_NAME_CLICK CancelReckDeathWish-Btn:LeftButton"] = "Cancel Recklessness/Death Wish"
		_G["BINDING_NAME_CLICK FocusCharge-Btn:LeftButton"] = "Focus Charge"
		_G["BINDING_NAME_CLICK FocusIntercept-Btn:LeftButton"] = "Focus Intercept"
		_G["BINDING_NAME_CLICK FocusChargeIntercept1-Btn:LeftButton"] = "Focus Charge/Intercept (Prioritize Charge)"
		_G["BINDING_NAME_CLICK FocusChargeIntercept2-Btn:LeftButton"] = "Focus Charge/Intercept (Prioritize Intercept)"
		_G["BINDING_NAME_CLICK FocusPummel-Btn:LeftButton"] = "Focus Pummel"
		_G["BINDING_NAME_CLICK FocusHamstring1-Btn:LeftButton"] = "Focus Hamstring (Prioritize Battle Stance)"
		_G["BINDING_NAME_CLICK FocusHamstring2-Btn:LeftButton"] = "Focus Hamstring (Prioritize Berserker Stance)"
		_G["BINDING_NAME_CLICK FocusHeroicThrow-Btn:LeftButton"] = "Focus Heroic Throw"
		_G["BINDING_NAME_CLICK FocusIntervene-Btn:LeftButton"] = "Focus Intervene"
		_G["BINDING_NAME_CLICK FocusIntimidatingShout-Btn:LeftButton"] = "Focus Intimidating Shout"
		_G["BINDING_NAME_CLICK FocusThrowdownConcussion-Btn:LeftButton"] = "Focus Throwdown/Concussion Blow"
		_G["BINDING_NAME_CLICK FocusDisarm-Btn:LeftButton"] = "Focus Disarm"
		_G["BINDING_NAME_CLICK MouseoverCharge-Btn:LeftButton"] = "Mouseover Charge"
		_G["BINDING_NAME_CLICK MouseoverIntercept-Btn:LeftButton"] = "Mouseover Intercept"
		_G["BINDING_NAME_CLICK MouseoverChargeIntercept1-Btn:LeftButton"] = "Mouseover Charge/Intercept (Prioritze Charge)"
		_G["BINDING_NAME_CLICK MouseoverChargeIntercept2-Btn:LeftButton"] = "Mouseover Charge/Intercept (Prioritze Intercept)"
		_G["BINDING_NAME_CLICK MouseoverIntervene-Btn:LeftButton"] = "Mouseover Intervene"
		_G["BINDING_NAME_CLICK MouseoverHeroicThrow-Btn:LeftButton"] = "Mouseover Heroic Throw"
		_G["BINDING_NAME_CLICK MouseoverPummel-Btn:LeftButton"] = "Mouseover Pummel"
		_G["BINDING_NAME_CLICK MouseoverIntimidatingShout-Btn:LeftButton"] = "Mouseover Intimidating Shout"
		_G["BINDING_NAME_CLICK MouseoverThrowdownConcussion-Btn:LeftButton"] = "Mouseover Throwdown/Concussion Blow"

		for i = 1,5 do
			_G["BINDING_NAME_CLICK ChargeArena"..i.."-Btn:LeftButton"] = "Charge Arena "..i
			_G["BINDING_NAME_CLICK InterceptArena"..i.."-Btn:LeftButton"] = "Intercept Arena "..i
			_G["BINDING_NAME_CLICK ChargeIntercept1Arena"..i.."-Btn:LeftButton"] = "Charge/Intercept Arena "..i.." (Prioritize Charge)"
			_G["BINDING_NAME_CLICK ChargeIntercept2Arena"..i.."-Btn:LeftButton"] = "Charge/Intercept Arena "..i.." (Prioritize Intercept)"
			_G["BINDING_NAME_CLICK Hamstring1Arena"..i.."-Btn:LeftButton"] = "Hamstring Arena "..i.." (Prioritize Battle Stance)"
			_G["BINDING_NAME_CLICK Hamstring2Arena"..i.."-Btn:LeftButton"] = "Hamstring Arena "..i.." (Prioritize Berserker Stance)"
			_G["BINDING_NAME_CLICK HeroicThrowArena"..i.."-Btn:LeftButton"] = "Heroic Throw Arena "..i
			_G["BINDING_NAME_CLICK PummelArena"..i.."-Btn:LeftButton"] = "Pummel Arena "..i
			_G["BINDING_NAME_CLICK DisarmArena"..i.."-Btn:LeftButton"] = "Disarm Arena "..i
			_G["BINDING_NAME_CLICK ThrowdownConcussionArena"..i.."-Btn:LeftButton"] = "Throwdown/Concussion Blow Arena "..i
			_G["BINDING_NAME_CLICK IntimidatingShoutArena"..i.."-Btn:LeftButton"] = "Intimidating Shout Arena "..i
		end
	
		for i = 1,5 do
			x = i-1

			if x ~= 0 then
				_G["BINDING_NAME_CLICK InterveneParty"..x.."-Btn:LeftButton"] = "Intervene Party "..x
			end
		end

		
		-- Death Knight
		_G["BINDING_NAME_CLICK PetAttackClaw-Btn:LeftButton"] = "Pet Attack + Claw"
		_G["BINDING_NAME_CLICK FocusPetAttackClaw-Btn:LeftButton"] = "Focus Pet Attack + Claw"
		_G["BINDING_NAME_CLICK CancelLichborne-Btn:LeftButton"] = "Cancel Lichborne"
		_G["BINDING_NAME_CLICK CancelUnholyFrenzy-Btn:LeftButton"] = "Cancel Unholy Frenzy"
		_G["BINDING_NAME_CLICK LichbornHeal-Btn:LeftButton"] = "Lichborne + Death Coil Player"
		_G["BINDING_NAME_CLICK GhoulHeal-Btn:LeftButton"] = "Death Coil Ghoul"
		_G["BINDING_NAME_CLICK RaiseDeadDeathPact-Btn:LeftButton"] = "Raise Dead + Death Pact"
		_G["BINDING_NAME_CLICK UnholyFrenzyGargoyle-Btn:LeftButton"] = "Unholy Frenzy Ebon Gargoyle"
		_G["BINDING_NAME_CLICK UnholyFrenzyGhoul-Btn:LeftButton"] = "Unholy Frenzy Ghoul"
		_G["BINDING_NAME_CLICK FocusDeathGrip-Btn:LeftButton"] = "Focus Death Grip"
		_G["BINDING_NAME_CLICK FocusMindFreeze-Btn:LeftButton"] = "Focus Mind Freeze"
		_G["BINDING_NAME_CLICK FocusChainsOfIce-Btn:LeftButton"] = "Focus Chains of Ice"
		_G["BINDING_NAME_CLICK FocusStrangulate-Btn:LeftButton"] = "Focus Strangulate"
		_G["BINDING_NAME_CLICK FocusDarkSim-Btn:LeftButton"] = "Focus Dark Simulacrum"
		_G["BINDING_NAME_CLICK FocusGnawPet-Btn:LeftButton"] = "Focus Gnaw"
		_G["BINDING_NAME_CLICK FocusLeapPet-Btn:LeftButton"] = "Focus Leap"
		_G["BINDING_NAME_CLICK FocusLeapGnawPet-Btn:LeftButton"] = "Focus Leap + Gnaw"
		_G["BINDING_NAME_CLICK MouseoverDeathGrip-Btn:LeftButton"] = "Mouseover Death Grip"
		_G["BINDING_NAME_CLICK MouseoverMindFreeze-Btn:LeftButton"] = "Mouseover Mind Freeze"
		_G["BINDING_NAME_CLICK MouseoverChainsOfIce-Btn:LeftButton"] = "Mouseover Chains of Ice"
		_G["BINDING_NAME_CLICK MouseoverStrangulate-Btn:LeftButton"] = "Mouseover Strangulate"
		_G["BINDING_NAME_CLICK MouseoverDarkSim-Btn:LeftButton"] = "Mouseover Dark Simulacrum"
		_G["BINDING_NAME_CLICK MouseoverUnholyFrenzy-Btn:LeftButton"] = "Mouseover Unholy Frenzy"
		_G["BINDING_NAME_CLICK MouseoverGnawPet-Btn:LeftButton"] = "Mouseover Gnaw"
		_G["BINDING_NAME_CLICK MouseoverLeapPet-Btn:LeftButton"] = "Mouseover Leap"
		_G["BINDING_NAME_CLICK MouseoverLeapGnawPet-Btn:LeftButton"] = "Mouseover Leap + Gnaw"

		for i = 1,5 do
			_G["BINDING_NAME_CLICK DeathGripArena"..i.."-Btn:LeftButton"] = "Death Grip Arena "..i
			_G["BINDING_NAME_CLICK MindFreezeArena"..i.."-Btn:LeftButton"] = "Mind Freeze Arena "..i
			_G["BINDING_NAME_CLICK ChainsOfIceArena"..i.."-Btn:LeftButton"] = "Chains of Ice Arena "..i
			_G["BINDING_NAME_CLICK StrangulateArena"..i.."-Btn:LeftButton"] = "Strangulate Arena "..i
			_G["BINDING_NAME_CLICK DarkSimArena"..i.."-Btn:LeftButton"] = "Dark Simulacrum Arena "..i
			_G["BINDING_NAME_CLICK GnawPetArena"..i.."-Btn:LeftButton"] = "Gnaw Arena "..i
			_G["BINDING_NAME_CLICK LeapPetArena"..i.."-Btn:LeftButton"] = "Leap Arena "..i
			_G["BINDING_NAME_CLICK LeapGnawPetArena"..i.."-Btn:LeftButton"] = "Leap + Gnaw Arena "..i
		end

		for i = 1,5 do
			x = i-1

			if x == 0 then
				_G["BINDING_NAME_CLICK UnholyFrenzyParty"..x.."-Btn:LeftButton"] = "Unholy Frenzy Player"
			else 
				_G["BINDING_NAME_CLICK UnholyFrenzyParty"..x.."-Btn:LeftButton"] = "Unholy Frenzy Party "..x
			end
		end


		-- Rogue
		_G["BINDING_NAME_CLICK CripplingPoisonMain-Btn:LeftButton"] = "Crippling Poison (Main-hand)"
		_G["BINDING_NAME_CLICK CripplingPoisonOff-Btn:LeftButton"] = "Crippling Poison (Off-hand)"
		_G["BINDING_NAME_CLICK WoundPoisonMain-Btn:LeftButton"] = "Wound Poison (Main-hand)"
		_G["BINDING_NAME_CLICK WoundPoisonOff-Btn:LeftButton"] = "Wound Poison (Off-hand)"
		_G["BINDING_NAME_CLICK MindNumbingPoisonMain-Btn:LeftButton"] = "Mind-Numbing Poison (Main-hand)"
		_G["BINDING_NAME_CLICK MindNumbingPoisonOff-Btn:LeftButton"] = "Mind-Numbing Poison (Off-hand)"
		_G["BINDING_NAME_CLICK DeadlyPoisonMain-Btn:LeftButton"] = "Deadly Poison (Main-hand)"
		_G["BINDING_NAME_CLICK DeadlyPoisonOff-Btn:LeftButton"] = "Deadly Poison (Off-hand)"
		_G["BINDING_NAME_CLICK InstantPoisonMain-Btn:LeftButton"] = "Instant Poison (Main-hand)"
		_G["BINDING_NAME_CLICK InstantPoisonOff-Btn:LeftButton"] = "Instant Poison (Off-hand)"
		_G["BINDING_NAME_CLICK PremedRecup-Btn:LeftButton"] = "Premeditation + Recuperate"
		_G["BINDING_NAME_CLICK PremedSlice-Btn:LeftButton"] = "Premeditation + Slice and Dice"
		_G["BINDING_NAME_CLICK RedirectKidney-Btn:LeftButton"] = "Redirect + Kidney Shot"
		_G["BINDING_NAME_CLICK FocusSap-Btn:LeftButton"] = "Focus Sap"
		_G["BINDING_NAME_CLICK FocusBlind-Btn:LeftButton"] = "Focus Blind"
		_G["BINDING_NAME_CLICK FocusKick-Btn:LeftButton"] = "Focus Kick"
		_G["BINDING_NAME_CLICK FocusDeadlyThrow-Btn:LeftButton"] = "Focus Deadly Throw"
		_G["BINDING_NAME_CLICK FocusCheapShot-Btn:LeftButton"] = "Focus Cheap Shot"
		_G["BINDING_NAME_CLICK FocusGarrote-Btn:LeftButton"] = "Focus Garrote"
		_G["BINDING_NAME_CLICK FocusKidney-Btn:LeftButton"] = "Focus Kidney Shot"
		_G["BINDING_NAME_CLICK FocusGouge-Btn:LeftButton"] = "Focus Gouge"
		_G["BINDING_NAME_CLICK FocusShiv-Btn:LeftButton"] = "Focus Shiv"
		_G["BINDING_NAME_CLICK FocusPremed-Btn:LeftButton"] = "Focus Premeditation"
		_G["BINDING_NAME_CLICK FocusPremedRecup-Btn:LeftButton"] = "Focus Premeditation + Recuperate"
		_G["BINDING_NAME_CLICK FocusPremedSlice-Btn:LeftButton"] = "Focus Premeditation + Slice and Dice"
		_G["BINDING_NAME_CLICK FocusRedirect-Btn:LeftButton"] = "Focus Redirect"
		_G["BINDING_NAME_CLICK FocusRedirectKidney-Btn:LeftButton"] = "Focus Redirect + Kidney Shot"
		_G["BINDING_NAME_CLICK FocusShadowstep-Btn:LeftButton"] = "Focus Shadowstep"
		_G["BINDING_NAME_CLICK FocusShadowstepKick-Btn:LeftButton"] = "Focus Shadowstep + Kick"
		_G["BINDING_NAME_CLICK FocusShadowstepKidney-Btn:LeftButton"] = "Focus Shadowstep + Kidney Shot"
		_G["BINDING_NAME_CLICK FocusDismantle-Btn:LeftButton"] = "Focus Dismantle"
		_G["BINDING_NAME_CLICK MouseoverTricks-Btn:LeftButton"] = "Mouseover Tricks of the Trade"
		_G["BINDING_NAME_CLICK MouseoverSap-Btn:LeftButton"] = "Mouseover Sap"
		_G["BINDING_NAME_CLICK MouseoverBlind-Btn:LeftButton"] = "Mouseover Blind"
		_G["BINDING_NAME_CLICK MouseoverKick-Btn:LeftButton"] = "Mouseover Kick"
		_G["BINDING_NAME_CLICK MouseoverDeadlyThrow-Btn:LeftButton"] = "Mouseover Deadly Throw"
		_G["BINDING_NAME_CLICK MouseoverGouge-Btn:LeftButton"] = "Mouseover Gouge"
		_G["BINDING_NAME_CLICK MouseoverShadowstep-Btn:LeftButton"] = "Mouseover Shadowstep"
		_G["BINDING_NAME_CLICK MouseoverShadowstepKick-Btn:LeftButton"] = "Mouseover Shadowstep + Kick"
		_G["BINDING_NAME_CLICK MouseoverShadowstepKidney-Btn:LeftButton"] = "Mouseover Shadowstep + Kidney Shot"
		_G["BINDING_NAME_CLICK MouseoverShiv-Btn:LeftButton"] = "Mouseover Shiv"

		for i = 1,5 do
			_G["BINDING_NAME_CLICK SapArena"..i.."-Btn:LeftButton"] = "Sap Arena "..i
			_G["BINDING_NAME_CLICK BlindArena"..i.."-Btn:LeftButton"] = "Blind Arena "..i
			_G["BINDING_NAME_CLICK KickArena"..i.."-Btn:LeftButton"] = "Kick Arena "..i
			_G["BINDING_NAME_CLICK DeadlyThrowArena"..i.."-Btn:LeftButton"] = "Deadly Throw Arena "..i
			_G["BINDING_NAME_CLICK CheapShotArena"..i.."-Btn:LeftButton"] = "Cheap Shot Arena "..i
			_G["BINDING_NAME_CLICK GarroteArena"..i.."-Btn:LeftButton"] = "Garrote Arena "..i
			_G["BINDING_NAME_CLICK KidneyArena"..i.."-Btn:LeftButton"] = "Kidney Shot Arena "..i
			_G["BINDING_NAME_CLICK GougeArena"..i.."-Btn:LeftButton"] = "Gouge Arena "..i
			_G["BINDING_NAME_CLICK ShivArena"..i.."-Btn:LeftButton"] = "Shiv Arena "..i
			_G["BINDING_NAME_CLICK PremedArena"..i.."-Btn:LeftButton"] = "Premeditation Arena "..i
			_G["BINDING_NAME_CLICK PremedRecupArena"..i.."-Btn:LeftButton"] = "Premeditation + Recup Arena "..i
			_G["BINDING_NAME_CLICK PremedSliceArena"..i.."-Btn:LeftButton"] = "Premeditation + Slice and Dice Arena "..i
			_G["BINDING_NAME_CLICK RedirectArena"..i.."-Btn:LeftButton"] = "Redirect Arena "..i
			_G["BINDING_NAME_CLICK RedirectKidneyArena"..i.."-Btn:LeftButton"] = "Redirect + Kidney Shot Arena "..i
			_G["BINDING_NAME_CLICK ShadowstepArena"..i.."-Btn:LeftButton"] = "Shadowstep Arena "..i
			_G["BINDING_NAME_CLICK ShadowstepKickArena"..i.."-Btn:LeftButton"] = "Shadowstep + Kick Arena "..i
			_G["BINDING_NAME_CLICK ShadowstepKidneyArena"..i.."-Btn:LeftButton"] = "Shadowstep + Kidney Shot Arena "..i
			_G["BINDING_NAME_CLICK DismantleArena"..i.."-Btn:LeftButton"] = "Dismantle Arena "..i
		end

		for i = 1,5 do
			x = i-1

			if x ~= 0 then
				_G["BINDING_NAME_CLICK TricksParty"..x.."-Btn:LeftButton"] = "Tricks of the Trade Party "..x
			end
		end

		
		
		-- Hunter
		_G["BINDING_NAME_CLICK CancelTrapLauncher-Btn:LeftButton"] = "Cancel Trap Launcher"
		_G["BINDING_NAME_CLICK AspectHawk-Btn:LeftButton"] = "Aspect of the Hawk (Sticky)"
		_G["BINDING_NAME_CLICK AspectCheetah-Btn:LeftButton"] = "Aspect of the Cheetah (Sticky)"
		_G["BINDING_NAME_CLICK AspectFox-Btn:LeftButton"] = "Aspect of the Fox (Sticky)"
		_G["BINDING_NAME_CLICK AspectPack-Btn:LeftButton"] = "Aspect of the Pack (Sticky)"
		_G["BINDING_NAME_CLICK AspectWild-Btn:LeftButton"] = "Aspect of the Wild (Sticky)"
		_G["BINDING_NAME_CLICK AbilitiesCCPet-Btn:LeftButton"] = "Crowd Control Pet Abilities (Disorient/Stun/Root/Disarm)"
		_G["BINDING_NAME_CLICK AbilitiesInterruptPet-Btn:LeftButton"] = "Interrupt/Knockback Pet Abilities"
		_G["BINDING_NAME_CLICK FocusScatter-Btn:LeftButton"] = "Focus Scatter Shot"
		_G["BINDING_NAME_CLICK FocusSilencingShot-Btn:LeftButton"] = "Focus Silencing Shot"
		_G["BINDING_NAME_CLICK FocusWyvern-Btn:LeftButton"] = "Wyvern Sting"
		_G["BINDING_NAME_CLICK FocusIntimidation-Btn:LeftButton"] = "Focus Intimidation"
		_G["BINDING_NAME_CLICK FocusSilencingShotWyvernIntimidation-Btn:LeftButton"] = "Silencing Shot/Wyvern Sting/Intimidation"
		_G["BINDING_NAME_CLICK FocusConcussive-Btn:LeftButton"] = "Focus Concussive Shot"
		_G["BINDING_NAME_CLICK FocusWingClip-Btn:LeftButton"] = "Focus Wing Clip"
		_G["BINDING_NAME_CLICK FocusAbilitiesCCPet-Btn:LeftButton"] = "Focus Crowd Control Pet Abilities (Disorient/Stun/Root/Disarm)"
		_G["BINDING_NAME_CLICK FocusAbilitiesInterruptPet-Btn:LeftButton"] = "Focus Interrupt/Knockback Pet Abilities"
		_G["BINDING_NAME_CLICK FocusMark-Btn:LeftButton"] = "Focus Hunter's Mark"
		_G["BINDING_NAME_CLICK FocusWidowVenom-Btn:LeftButton"] = "Focus Widow Venom"
		_G["BINDING_NAME_CLICK FocusTranq-Btn:LeftButton"] = "Focus Tranquilizing Shot"
		_G["BINDING_NAME_CLICK FocusScareBeast-Btn:LeftButton"] = "Focus Scare Beast"
		_G["BINDING_NAME_CLICK FocusKillShot-Btn:LeftButton"] = "Focus Kill Shot"
		_G["BINDING_NAME_CLICK FocusDistracting-Btn:LeftButton"] = "Focus Distracting Shot"
		_G["BINDING_NAME_CLICK FocusGrowlPet-Btn:LeftButton"] = "Focus Growl"
		_G["BINDING_NAME_CLICK MouseoverScatter-Btn:LeftButton"] = "Mouseover Scatter Shot"
		_G["BINDING_NAME_CLICK MouseoverSilencingShot-Btn:LeftButton"] = "Mouseover Silencing Shot"
		_G["BINDING_NAME_CLICK MouseoverWyvern-Btn:LeftButton"] = "Mouseover Wyvern Sting"
		_G["BINDING_NAME_CLICK MouseoverIntimidation-Btn:LeftButton"] = "Mouseover Intimidation"
		_G["BINDING_NAME_CLICK MouseoverSilencingShotWyvernIntimidation-Btn:LeftButton"] = "Mouseover Silencing Shot/Wyvern Sting/Intimidation"
		_G["BINDING_NAME_CLICK MouseoverConcussive-Btn:LeftButton"] = "Mouseover Concussive Shot"
		_G["BINDING_NAME_CLICK MouseoverWingClip-Btn:LeftButton"] = "Mouseover Wing Clip"
		_G["BINDING_NAME_CLICK MouseoverAbilitiesCCPet-Btn:LeftButton"] = "Mouseover Crowd Control Pet Abilities"
		_G["BINDING_NAME_CLICK MouseoverAbilitiesInterruptPet-Btn:LeftButton"] = "Mouseover Interrupt/Knockback Pet Abilities"
		_G["BINDING_NAME_CLICK MouseoverMark-Btn:LeftButton"] = "Mouseover Hunter's Mark"
		_G["BINDING_NAME_CLICK MouseoverWidowVenom-Btn:LeftButton"] = "Mouseover Widow Venom"
		_G["BINDING_NAME_CLICK MouseoverTranq-Btn:LeftButton"] = "Mouseover Tranquilizing Shot"
		_G["BINDING_NAME_CLICK MouseoverScareBeast-Btn:LeftButton"] = "Mouseover Scare Beast"
		_G["BINDING_NAME_CLICK MouseoverKillShot-Btn:LeftButton"] = "Mouseover Kill Shot"
		_G["BINDING_NAME_CLICK MouseoverMisdirection-Btn:LeftButton"] = "Mouseover Misdirection"
		_G["BINDING_NAME_CLICK MouseoverDistracting-Btn:LeftButton"] = "Mouseover Distracting Shot"
		_G["BINDING_NAME_CLICK MouseoverGrowlPet-Btn:LeftButton"] = "Mouseover Growl"
		_G["BINDING_NAME_CLICK MouseoverRoarOfSacrifice-Btn:LeftButton"] = "Mouseover Roar of Sacrifice"
		_G["BINDING_NAME_CLICK MouseoverPetIntervene-Btn:LeftButton"] = "Mouseover Intervene"
		_G["BINDING_NAME_CLICK MouseoverRoSPetIntervene-Btn:LeftButton"] = "Mouseover Roar of Sacrifice + Intervene"

		
		for i = 1,5 do
			_G["BINDING_NAME_CLICK ScatterArena"..i.."-Btn:LeftButton"] = "Scatter Shot Arena "..i
			_G["BINDING_NAME_CLICK SilencingShotArena"..i.."-Btn:LeftButton"] = "Silencing Shot Arena "..i
			_G["BINDING_NAME_CLICK WyvernArena"..i.."-Btn:LeftButton"] = "Wyvern Sting Arena "..i
			_G["BINDING_NAME_CLICK IntimidationArena"..i.."-Btn:LeftButton"] = "Intimidation Arena "..i
			_G["BINDING_NAME_CLICK SilencingShotWyvernIntimidationArena"..i.."-Btn:LeftButton"] = "Silencing Shot/Wyvern Sting/Intimidation Arena "..i
			_G["BINDING_NAME_CLICK AbilitiesCCPetArena"..i.."-Btn:LeftButton"] = "Crowd Control Pet Abilities Arena "..i
			_G["BINDING_NAME_CLICK AbilitiesInterruptPetArena"..i.."-Btn:LeftButton"] = "Interrupt/Knockback Pet Abilities Arena "..i
			_G["BINDING_NAME_CLICK ConcussiveArena"..i.."-Btn:LeftButton"] = "Concussive Shot Arena "..i
			_G["BINDING_NAME_CLICK MarkArena"..i.."-Btn:LeftButton"] = "Hunter's Mark Arena "..i
			_G["BINDING_NAME_CLICK TranqArena"..i.."-Btn:LeftButton"] = "Tranquilizing Shot Arena "..i
			_G["BINDING_NAME_CLICK ScareBeastArena"..i.."-Btn:LeftButton"] = "Scare Beast Arena "..i
			_G["BINDING_NAME_CLICK ScareBeastArenaPet"..i.."-Btn:LeftButton"] = "Scare Beast Arena Pet "..i
		end

		for i = 1,5 do
			x = i-1

			if x == 0 then
				_G["BINDING_NAME_CLICK MastersCallParty"..x.."-Btn:LeftButton"] = "Master's Call Player"
			else 
				_G["BINDING_NAME_CLICK MastersCallParty"..x.."-Btn:LeftButton"] = "Master's Call Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK RoarOfSacrificeParty"..x.."-Btn:LeftButton"] = "Roar of Sacrifice Player"
			else 
				_G["BINDING_NAME_CLICK RoarOfSacrificeParty"..x.."-Btn:LeftButton"] = "Roar of Sacrifice Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK PetInterveneParty"..x.."-Btn:LeftButton"] = "Intervene Player"
			else 
				_G["BINDING_NAME_CLICK PetInterveneParty"..x.."-Btn:LeftButton"] = "Intervene Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK SpiritMendParty"..x.."-Btn:LeftButton"] = "Spirit Mend Player"
			else 
				_G["BINDING_NAME_CLICK SpiritMendParty"..x.."-Btn:LeftButton"] = "Spirit Mend Party "..x
			end

			if x == 0 then
				_G["BINDING_NAME_CLICK AbilitiesPetParty"..x.."-Btn:LeftButton"] = "Roar of Sacrifice + Intervene + Spirit Mend Player"
			else 
				_G["BINDING_NAME_CLICK AbilitiesPetParty"..x.."-Btn:LeftButton"] = "Roar of Sacrifice + Intervene + Spirit Mend Party "..x
			end

			if x ~= 0 then
				_G["BINDING_NAME_CLICK MisdirectionParty"..x.."-Btn:LeftButton"] = "Misdirection Party"..x
			end
		end
		

	end
end

function AdditionalBinds_EventFrame:PLAYER_ENTERING_WORLD()

	buttons['StopCastAttack'] = CreateFrame("Button", "StopCastAttack-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['StopCastAttack']:SetAttribute("type", "macro")
	buttons['StopCastAttack']:RegisterForClicks("AnyDown")
	buttons['StopCastAttack']:SetAttribute("macrotext", "/stopcasting\n/stopattack")

	buttons['Dismount'] = CreateFrame("Button", "Dismount-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['Dismount']:SetAttribute("type", "macro")
	buttons['Dismount']:RegisterForClicks("AnyDown")
	buttons['Dismount']:SetAttribute("macrotext", "/dismount")

	buttons['CancelBoP'] = CreateFrame("Button", "CancelBoP-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelBoP']:SetAttribute("type", "macro")
	buttons['CancelBoP']:RegisterForClicks("AnyDown")
	buttons['CancelBoP']:SetAttribute("macrotext", "/cancelaura Hand of Protection")

	buttons['FocusMouseover'] = CreateFrame("Button", "FocusMouseover-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusMouseover']:SetAttribute("type", "macro")
	buttons['FocusMouseover']:RegisterForClicks("AnyDown")
	buttons['FocusMouseover']:SetAttribute("macrotext", "/focus [@mouseover]")

	buttons['SwapActionBars'] = CreateFrame("Button", "SwapActionBars-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['SwapActionBars']:SetAttribute("type", "macro")
	buttons['SwapActionBars']:RegisterForClicks("AnyDown")
	buttons['SwapActionBars']:SetAttribute("macrotext", "/swapactionbar 1 2")

	for i = 1,5 do
		buttons['TargetArena'..i] = CreateFrame("Button", "TargetArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['TargetArena'..i]:SetAttribute("type", "macro")
		buttons['TargetArena'..i]:RegisterForClicks("AnyDown")
		buttons['TargetArena'..i]:SetAttribute("macrotext", "/tar [@arena"..i.."]")
	
		buttons['FocusArena'..i] = CreateFrame("Button", "FocusArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['FocusArena'..i]:SetAttribute("type", "macro")
		buttons['FocusArena'..i]:RegisterForClicks("AnyDown")
		buttons['FocusArena'..i]:SetAttribute("macrotext", "/focus [@arena"..i.."]")
	end

	for i = 1,5 do
		x = i-1

		buttons['TargetParty'..x] = CreateFrame("Button", "TargetParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['TargetParty'..x]:SetAttribute("type", "macro")
		buttons['TargetParty'..x]:RegisterForClicks("AnyDown")

		if x == 0 then
			buttons['TargetParty'..x]:SetAttribute("macrotext", "/tar [@player]")
		else
			buttons['TargetParty'..x]:SetAttribute("macrotext", "/tar [@party"..x.."]")
		end
	end

	buttons['TargetGargoyle'] = CreateFrame("Button", "TargetGargoyle-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['TargetGargoyle']:SetAttribute("type", "macro")
	buttons['TargetGargoyle']:RegisterForClicks("AnyDown")
	buttons['TargetGargoyle']:SetAttribute("macrotext", "/tar Ebon Gargoyle")


	-- Druid
	buttons['CancelForms'] = CreateFrame("Button", "CancelForms-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelForms']:SetAttribute("type", "macro")
	buttons['CancelForms']:RegisterForClicks("AnyDown")
	buttons['CancelForms']:SetAttribute("macrotext", "/cancelaura Cat Form\n/cancelaura Bear Form\n/cancelaura Travel Form\n/cancelaura Aquatic Form\n/cancelaura Swift Flight Form\n/cancelaura Tree of Life\n/cancelaura Moonkin Form")
	
	buttons['BearForm'] = CreateFrame("Button", "BearForm-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['BearForm']:SetAttribute("type", "macro")
	buttons['BearForm']:RegisterForClicks("AnyDown")
	buttons['BearForm']:SetAttribute("macrotext", "/cast Bear Form")
	
	buttons['AquaticForm'] = CreateFrame("Button", "AquaticForm-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['AquaticForm']:SetAttribute("type", "macro")
	buttons['AquaticForm']:RegisterForClicks("AnyDown")
	buttons['AquaticForm']:SetAttribute("macrotext", "/cast Aquatic Form")

	buttons['CatForm'] = CreateFrame("Button", "CatForm-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CatForm']:SetAttribute("type", "macro")
	buttons['CatForm']:RegisterForClicks("AnyDown")
	buttons['CatForm']:SetAttribute("macrotext", "/cast Cat Form")

	buttons['TravelForm'] = CreateFrame("Button", "TravelForm-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['TravelForm']:SetAttribute("type", "macro")
	buttons['TravelForm']:RegisterForClicks("AnyDown")
	buttons['TravelForm']:SetAttribute("macrotext", "/cast Travel Form")

	buttons['MoonkinForm'] = CreateFrame("Button", "MoonkinForm-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MoonkinForm']:SetAttribute("type", "macro")
	buttons['MoonkinForm']:RegisterForClicks("AnyDown")
	buttons['MoonkinForm']:SetAttribute("macrotext", "/cast Moonkin Form")
	
	buttons['TreeOfLife'] = CreateFrame("Button", "TreeOfLife-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['TreeOfLife']:SetAttribute("type", "macro")
	buttons['TreeOfLife']:RegisterForClicks("AnyDown")
	buttons['TreeOfLife']:SetAttribute("macrotext", "/cast Tree of Life")

	buttons['FlightForm'] = CreateFrame("Button", "FlightForm-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FlightForm']:SetAttribute("type", "macro")
	buttons['FlightForm']:RegisterForClicks("AnyDown")
	buttons['FlightForm']:SetAttribute("macrotext", "/cast Flight Form\n/cast Swift Flight Form")

	buttons['NSHealingTouch'] = CreateFrame("Button", "NSHealingTouch-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['NSHealingTouch']:SetAttribute("type", "macro")
	buttons['NSHealingTouch']:RegisterForClicks("AnyDown")
	buttons['NSHealingTouch']:SetAttribute("macrotext", "/cast Nature's Swiftness\n/cast Healing Touch")

	buttons['NSRegrowth'] = CreateFrame("Button", "NSRegrowth-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['NSRegrowth']:SetAttribute("type", "macro")
	buttons['NSRegrowth']:RegisterForClicks("AnyDown")
	buttons['NSRegrowth']:SetAttribute("macrotext", "/cast Nature's Swiftness\n/cast Regrowth")

	buttons['NSCyclone'] = CreateFrame("Button", "NSCyclone-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['NSCyclone']:SetAttribute("type", "macro")
	buttons['NSCyclone']:RegisterForClicks("AnyDown")
	buttons['NSCyclone']:SetAttribute("macrotext", "/cast Nature's Swiftness\n/cast Cyclone")

	buttons['NSHibernate'] = CreateFrame("Button", "NSHibernate-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['NSHibernate']:SetAttribute("type", "macro")
	buttons['NSHibernate']:RegisterForClicks("AnyDown")
	buttons['NSHibernate']:SetAttribute("macrotext", "/cast Nature's Swiftness\n/cast Hibernate")

	buttons['NSWrath'] = CreateFrame("Button", "NSWrath-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['NSWrath']:SetAttribute("type", "macro")
	buttons['NSWrath']:RegisterForClicks("AnyDown")
	buttons['NSWrath']:SetAttribute("macrotext", "/cast Nature's Swiftness\n/cast Wrath")

	buttons['CatSkullBash'] = CreateFrame("Button", "CatSkullBash-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CatSkullBash']:SetAttribute("type", "macro")
	buttons['CatSkullBash']:RegisterForClicks("AnyDown")
	buttons['CatSkullBash']:SetAttribute("macrotext", "/cast [nostance:3] Cat Form\n/cast Skull Bash(Cat Form)")

	buttons['BearSkullBash'] = CreateFrame("Button", "BearSkullBash-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['BearSkullBash']:SetAttribute("type", "macro")
	buttons['BearSkullBash']:RegisterForClicks("AnyDown")
	buttons['BearSkullBash']:SetAttribute("macrotext", "/cast [nostance:1] Bear Form\n/cast Skull Bash(Bear Form)")

	buttons['SkullBash1'] = CreateFrame("Button", "SkullBash1-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['SkullBash1']:SetAttribute("type", "macro")
	buttons['SkullBash1']:RegisterForClicks("AnyDown")
	buttons['SkullBash1']:SetAttribute("macrotext", "/cast [nostance] Cat Form; [stance:2] Cat Form; [stance:4] Cat Form; [stance:5] Cat Form; [stance:6] Cat Form;\n/cast [stance:1] Skull Bash(Bear Form)\n/cast [stance:3] Skull Bash(Cat Form)")

	buttons['SkullBash2'] = CreateFrame("Button", "SkullBash2-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['SkullBash2']:SetAttribute("type", "macro")
	buttons['SkullBash2']:RegisterForClicks("AnyDown")
	buttons['SkullBash2']:SetAttribute("macrotext", "/cast [nostance] Bear Form; [stance:2] Bear Form; [stance:4] Bear Form; [stance:5] Bear Form; [stance:6] Bear Form;\n/cast [stance:1] Skull Bash(Bear Form)\n/cast [stance:3] Skull Bash(Cat Form)")

	buttons['FaerieFire'] = CreateFrame("Button", "FaerieFire-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FaerieFire']:SetAttribute("type", "macro")
	buttons['FaerieFire']:RegisterForClicks("AnyDown")
	buttons['FaerieFire']:SetAttribute("macrotext", "/cast [nostance] Faerie Fire; [stance:1] Faerie Fire (Feral); [stance:2] Faerie Fire; [stance:3] Faerie Fire (Feral); [stance:4] Faerie Fire; [stance:5] Faerie Fire; [stance:6] Faerie Fire;")
	
	buttons['FocusCyclone'] = CreateFrame("Button", "FocusCyclone-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusCyclone']:SetAttribute("type", "macro")
	buttons['FocusCyclone']:RegisterForClicks("AnyDown")
	buttons['FocusCyclone']:SetAttribute("macrotext", "/cast [@focus] Cyclone")
	
	buttons['FocusHibernate'] = CreateFrame("Button", "FocusHibernate-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusHibernate']:SetAttribute("type", "macro")
	buttons['FocusHibernate']:RegisterForClicks("AnyDown")
	buttons['FocusHibernate']:SetAttribute("macrotext", "/cast [@focus] Hibernate")

	buttons['FocusBash'] = CreateFrame("Button", "FocusBash-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusBash']:SetAttribute("type", "macro")
	buttons['FocusBash']:RegisterForClicks("AnyDown")
	buttons['FocusBash']:SetAttribute("macrotext", "/cast [nostance:1] Bear Form\n/cast [@focus] Bash")

	buttons['FocusCatSkullBash'] = CreateFrame("Button", "FocusCatSkullBash-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusCatSkullBash']:SetAttribute("type", "macro")
	buttons['FocusCatSkullBash']:RegisterForClicks("AnyDown")
	buttons['FocusCatSkullBash']:SetAttribute("macrotext", "/cast [nostance:3] Cat Form\n/cast [@focus] Skull Bash(Cat Form)")

	buttons['FocusBearSkullBash'] = CreateFrame("Button", "FocusBearSkullBash-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusBearSkullBash']:SetAttribute("type", "macro")
	buttons['FocusBearSkullBash']:RegisterForClicks("AnyDown")
	buttons['FocusBearSkullBash']:SetAttribute("macrotext", "/cast [nostance:1] Bear Form\n/cast [@focus] Skull Bash(Bear Form)")

	buttons['FocusSkullBash1'] = CreateFrame("Button", "FocusSkullBash1-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusSkullBash1']:SetAttribute("type", "macro")
	buttons['FocusSkullBash1']:RegisterForClicks("AnyDown")
	buttons['FocusSkullBash1']:SetAttribute("macrotext", "/cast [nostance] Cat Form; [stance:2] Cat Form; [stance:4] Cat Form; [stance:5] Cat Form; [stance:6] Cat Form;\n/cast [stance:1,@focus] Skull Bash(Bear Form)\n/cast [stance:3,@focus] Skull Bash(Cat Form)")

	buttons['FocusSkullBash2'] = CreateFrame("Button", "FocusSkullBash2-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusSkullBash2']:SetAttribute("type", "macro")
	buttons['FocusSkullBash2']:RegisterForClicks("AnyDown")
	buttons['FocusSkullBash2']:SetAttribute("macrotext", "/cast [nostance] Bear Form; [stance:2] Bear Form; [stance:4] Bear Form; [stance:5] Bear Form; [stance:6] Bear Form;\n/cast [stance:1,@focus] Skull Bash(Bear Form)\n/cast [stance:3,@focus] Skull Bash(Cat Form)")
	
	buttons['FocusFaerieFire'] = CreateFrame("Button", "FocusFaerieFire-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusFaerieFire']:SetAttribute("type", "macro")
	buttons['FocusFaerieFire']:RegisterForClicks("AnyDown")
	buttons['FocusFaerieFire']:SetAttribute("macrotext", "/cast [@focus,nostance] Faerie Fire; [@focus,stance:1] Faerie Fire (Feral); [@focus,stance:2] Faerie Fire; [@focus,stance:3] Faerie Fire (Feral); [@focus,stance:4] Faerie Fire; [@focus,stance:5] Faerie Fire; [@focus,stance:6] Faerie Fire;")
	
	buttons['FocusEntanglingRoots'] = CreateFrame("Button", "FocusEntanglingRoots-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusEntanglingRoots']:SetAttribute("type", "macro")
	buttons['FocusEntanglingRoots']:RegisterForClicks("AnyDown")
	buttons['FocusEntanglingRoots']:SetAttribute("macrotext", "/cast [@focus] Entangling Roots")

	buttons['FocusSolarBeam'] = CreateFrame("Button", "FocusSolarBeam-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusSolarBeam']:SetAttribute("type", "macro")
	buttons['FocusSolarBeam']:RegisterForClicks("AnyDown")
	buttons['FocusSolarBeam']:SetAttribute("macrotext", "/cast [@focus] Solar Beam")
	
	buttons['FocusMoonfire'] = CreateFrame("Button", "FocusMoonfire-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusMoonfire']:SetAttribute("type", "macro")
	buttons['FocusMoonfire']:RegisterForClicks("AnyDown")
	buttons['FocusMoonfire']:SetAttribute("macrotext", "/cast [@focus] Moonfire")

	buttons['FocusInsectSwarm'] = CreateFrame("Button", "FocusInsectSwarm-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusInsectSwarm']:SetAttribute("type", "macro")
	buttons['FocusInsectSwarm']:RegisterForClicks("AnyDown")
	buttons['FocusInsectSwarm']:SetAttribute("macrotext", "/cast [@focus] Insect Swarm")

	buttons['MouseoverCyclone'] = CreateFrame("Button", "MouseoverCyclone-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverCyclone']:SetAttribute("type", "macro")
	buttons['MouseoverCyclone']:RegisterForClicks("AnyDown")
	buttons['MouseoverCyclone']:SetAttribute("macrotext", "/cast [@mouseover] Cyclone")

	buttons['MouseoverHibernate'] = CreateFrame("Button", "MouseoverHibernate-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverHibernate']:SetAttribute("type", "macro")
	buttons['MouseoverHibernate']:RegisterForClicks("AnyDown")
	buttons['MouseoverHibernate']:SetAttribute("macrotext", "/cast [@mouseover] Hibernate")

	buttons['MouseoverEntanglingRoots'] = CreateFrame("Button", "MouseoverEntanglingRoots-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverEntanglingRoots']:SetAttribute("type", "macro")
	buttons['MouseoverEntanglingRoots']:RegisterForClicks("AnyDown")
	buttons['MouseoverEntanglingRoots']:SetAttribute("macrotext", "/cast [@mouseover] Entangling Roots")

	buttons['MouseoverRebirth'] = CreateFrame("Button", "MouseoverRebirth-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverRebirth']:SetAttribute("type", "macro")
	buttons['MouseoverRebirth']:RegisterForClicks("AnyDown")
	buttons['MouseoverRebirth']:SetAttribute("macrotext", "/cast [@mouseover] Rebirth")

	buttons['MouseoverGrowl'] = CreateFrame("Button", "MouseoverGrowl-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverGrowl']:SetAttribute("type", "macro")
	buttons['MouseoverGrowl']:RegisterForClicks("AnyDown")
	buttons['MouseoverGrowl']:SetAttribute("macrotext", "/cast [nostance:1] Bear Form\n/cast [@mouseover] Growl")

	buttons['MouseoverCatSkullBash'] = CreateFrame("Button", "MouseoverCatSkullBash-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverCatSkullBash']:SetAttribute("type", "macro")
	buttons['MouseoverCatSkullBash']:RegisterForClicks("AnyDown")
	buttons['MouseoverCatSkullBash']:SetAttribute("macrotext", "/cast [nostance:3] Cat Form\n/cast [@mouseover] Skull Bash(Cat Form)")

	buttons['MouseoverBearSkullBash'] = CreateFrame("Button", "MouseoverBearSkullBash-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverBearSkullBash']:SetAttribute("type", "macro")
	buttons['MouseoverBearSkullBash']:RegisterForClicks("AnyDown")
	buttons['MouseoverBearSkullBash']:SetAttribute("macrotext", "/cast [nostance:1] Bear Form\n/cast [@mouseover] Skull Bash(Bear Form)")

	buttons['MouseoverSkullBash1'] = CreateFrame("Button", "MouseoverSkullBash1-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverSkullBash1']:SetAttribute("type", "macro")
	buttons['MouseoverSkullBash1']:RegisterForClicks("AnyDown")
	buttons['MouseoverSkullBash1']:SetAttribute("macrotext", "/cast [nostance] Cat Form; [stance:2] Cat Form; [stance:4] Cat Form; [stance:5] Cat Form; [stance:6] Cat Form;\n/cast [stance:1,@mouseover] Skull Bash(Bear Form)\n/cast [stance:3,@mouseover] Skull Bash(Cat Form)")

	buttons['MouseoverSkullBash2'] = CreateFrame("Button", "MouseoverSkullBash2-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverSkullBash2']:SetAttribute("type", "macro")
	buttons['MouseoverSkullBash2']:RegisterForClicks("AnyDown")
	buttons['MouseoverSkullBash2']:SetAttribute("macrotext", "/cast [nostance] Bear Form; [stance:2] Bear Form; [stance:4] Bear Form; [stance:5] Bear Form; [stance:6] Bear Form;\n/cast [stance:1,@mouseover] Skull Bash(Bear Form)\n/cast [stance:3,@mouseover] Skull Bash(Cat Form)")
	

	for i = 1,5 do
		buttons['CycloneArena'..i] = CreateFrame("Button", "CycloneArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['CycloneArena'..i]:SetAttribute("type", "macro")
		buttons['CycloneArena'..i]:RegisterForClicks("AnyDown")
		buttons['CycloneArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Cyclone")

		buttons['BashArena'..i] = CreateFrame("Button", "BashArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['BashArena'..i]:SetAttribute("type", "macro")
		buttons['BashArena'..i]:RegisterForClicks("AnyDown")
		buttons['BashArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Bash")

		buttons['HibernateArena'..i] = CreateFrame("Button", "HibernateArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['HibernateArena'..i]:SetAttribute("type", "macro")
		buttons['HibernateArena'..i]:RegisterForClicks("AnyDown")
		buttons['HibernateArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Hibernate")

		buttons['HibernateArenaPet'..i] = CreateFrame("Button", "HibernateArenaPet"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['HibernateArenaPet'..i]:SetAttribute("type", "macro")
		buttons['HibernateArenaPet'..i]:RegisterForClicks("AnyDown")
		buttons['HibernateArenaPet'..i]:SetAttribute("macrotext", "/cast [@arenapet"..i.."] Hibernate")

		buttons['EntanglingRootsArena'..i] = CreateFrame("Button", "EntanglingRootsArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['EntanglingRootsArena'..i]:SetAttribute("type", "macro")
		buttons['EntanglingRootsArena'..i]:RegisterForClicks("AnyDown")
		buttons['EntanglingRootsArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Entangling Roots")

		buttons['SolarBeamArena'..i] = CreateFrame("Button", "SolarBeamArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SolarBeamArena'..i]:SetAttribute("type", "macro")
		buttons['SolarBeamArena'..i]:RegisterForClicks("AnyDown")
		buttons['SolarBeamArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Solar Beam")

		buttons['CatSkullBashArena'..i] = CreateFrame("Button", "CatSkullBashArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['CatSkullBashArena'..i]:SetAttribute("type", "macro")
		buttons['CatSkullBashArena'..i]:RegisterForClicks("AnyDown")
		buttons['CatSkullBashArena'..i]:SetAttribute("macrotext", "/cast [nostance:3] Cat Form\n/cast [@arena"..i.."] Skull Bash(Cat Form)")

		buttons['BearSkullBashArena'..i] = CreateFrame("Button", "BearSkullBashArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['BearSkullBashArena'..i]:SetAttribute("type", "macro")
		buttons['BearSkullBashArena'..i]:RegisterForClicks("AnyDown")
		buttons['BearSkullBashArena'..i]:SetAttribute("macrotext", "/cast [nostance:1] Bear Form\n/cast [@arena"..i.."] Skull Bash(Bear Form)")

		buttons['SkullBash1Arena'..i] = CreateFrame("Button", "SkullBash1Arena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SkullBash1Arena'..i]:SetAttribute("type", "macro")
		buttons['SkullBash1Arena'..i]:RegisterForClicks("AnyDown")
		buttons['SkullBash1Arena'..i]:SetAttribute("macrotext", "/cast [nostance] Cat Form; [stance:2] Cat Form; [stance:4] Cat Form; [stance:5] Cat Form; [stance:6] Cat Form;\n/cast [stance:1,@arena"..i.."] Skull Bash(Bear Form)\n/cast [stance:3,@arena"..i.."] Skull Bash(Cat Form)")

		buttons['SkullBash2Arena'..i] = CreateFrame("Button", "SkullBash2Arena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SkullBash2Arena'..i]:SetAttribute("type", "macro")
		buttons['SkullBash2Arena'..i]:RegisterForClicks("AnyDown")
		buttons['SkullBash2Arena'..i]:SetAttribute("macrotext", "/cast [nostance] Bear Form; [stance:2] Bear Form; [stance:4] Bear Form; [stance:5] Bear Form; [stance:6] Bear Form;\n/cast [stance:1,@arena"..i.."] Skull Bash(Bear Form)\n/cast [stance:3,@arena"..i.."] Skull Bash(Cat Form)")

		buttons['FaerieFireArena'..i] = CreateFrame("Button", "FaerieFireArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['FaerieFireArena'..i]:SetAttribute("type", "macro")
		buttons['FaerieFireArena'..i]:RegisterForClicks("AnyDown")
		buttons['FaerieFireArena'..i]:SetAttribute("macrotext", "/cast [nostance,@arena"..i.."] Faerie Fire; [stance:1,@arena"..i.."] Faerie Fire (Feral); [stance:2,@arena"..i.."] Faerie Fire; [stance:3,@arena"..i.."] Faerie Fire (Feral); [stance:4,@arena"..i.."] Faerie Fire; [stance:5,@arena"..i.."] Faerie Fire; [stance:6,@arena"..i.."] Faerie Fire;")

		buttons['SootheArena'..i] = CreateFrame("Button", "SootheArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SootheArena'..i]:SetAttribute("type", "macro")
		buttons['SootheArena'..i]:RegisterForClicks("AnyDown")
		buttons['SootheArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Soothe")
	end

	for i = 1,5 do
		x = i-1

		buttons['RemoveCorruptionParty'..x] = CreateFrame("Button", "RemoveCorruptionParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['RemoveCorruptionParty'..x]:SetAttribute("type", "macro")
		buttons['RemoveCorruptionParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['RemoveCorruptionParty'..x]:SetAttribute("macrotext", "/cast [@player] Remove Corruption")
		else
			buttons['RemoveCorruptionParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Remove Corruption")
		end

		buttons['HealingTouchParty'..x] = CreateFrame("Button", "HealingTouchParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['HealingTouchParty'..x]:SetAttribute("type", "macro")
		buttons['HealingTouchParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['HealingTouchParty'..x]:SetAttribute("macrotext", "/cast [@player] Healing Touch")
		else
			buttons['HealingTouchParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Healing Touch")
		end

		buttons['RegrowthParty'..x] = CreateFrame("Button", "RegrowthParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['RegrowthParty'..x]:SetAttribute("type", "macro")
		buttons['RegrowthParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['RegrowthParty'..x]:SetAttribute("macrotext", "/cast [@player] Regrowth")
		else
			buttons['RegrowthParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Regrowth")
		end

		buttons['RevjuvenationParty'..x] = CreateFrame("Button", "RevjuvenationParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['RevjuvenationParty'..x]:SetAttribute("type", "macro")
		buttons['RevjuvenationParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['RevjuvenationParty'..x]:SetAttribute("macrotext", "/cast [@player] Rejuvenation")
		else
			buttons['RevjuvenationParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Rejuvenation")
		end

		buttons['LifebloomParty'..x] = CreateFrame("Button", "LifebloomParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['LifebloomParty'..x]:SetAttribute("type", "macro")
		buttons['LifebloomParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['LifebloomParty'..x]:SetAttribute("macrotext", "/cast [@player] Lifebloom")
		else
			buttons['LifebloomParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Lifebloom")
		end

		buttons['InnervateParty'..x] = CreateFrame("Button", "InnervateParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['InnervateParty'..x]:SetAttribute("type", "macro")
		buttons['InnervateParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['InnervateParty'..x]:SetAttribute("macrotext", "/cast [@player] Innervate")
		else
			buttons['InnervateParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Innervate")
		end
	end


	-- Priest
	buttons['CancelShield'] = CreateFrame("Button", "CancelShield-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelShield']:SetAttribute("type", "macro")
	buttons['CancelShield']:RegisterForClicks("AnyDown")
	buttons['CancelShield']:SetAttribute("macrotext", "/cancelaura Power Word: Shield")

	buttons['CancelLevitate'] = CreateFrame("Button", "CancelLevitate-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelLevitate']:SetAttribute("type", "macro")
	buttons['CancelLevitate']:RegisterForClicks("AnyDown")
	buttons['CancelLevitate']:SetAttribute("macrotext", "/cancelaura Levitate")

	buttons['CancelChakra1'] = CreateFrame("Button", "CancelChakra1-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelChakra1']:SetAttribute("type", "macro")
	buttons['CancelChakra1']:RegisterForClicks("AnyDown")
	buttons['CancelChakra1']:SetAttribute("macrotext", "/cancelaura Chakra")

	buttons['CancelChakra2'] = CreateFrame("Button", "CancelChakra2-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelChakra2']:SetAttribute("type", "macro")
	buttons['CancelChakra2']:RegisterForClicks("AnyDown")
	buttons['CancelChakra2']:SetAttribute("macrotext", "/cancelaura Chakra: Serenity\n/cancelaura Chakra: Sanctuary")

	buttons['CancelDispersion'] = CreateFrame("Button", "CancelDispersion-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelDispersion']:SetAttribute("type", "macro")
	buttons['CancelDispersion']:RegisterForClicks("AnyDown")
	buttons['CancelDispersion']:SetAttribute("macrotext", "/cancelaura Dispersion")

	buttons['ShackleGargoyle'] = CreateFrame("Button", "ShackleGargoyle-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['ShackleGargoyle']:SetAttribute("type", "macro")
	buttons['ShackleGargoyle']:RegisterForClicks("AnyDown")
	buttons['ShackleGargoyle']:SetAttribute("macrotext", "/cast [@Ebon Gargoyle] Shadow Word: Death")

	buttons['FocusDeath'] = CreateFrame("Button", "FocusDeath-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusDeath']:SetAttribute("type", "macro")
	buttons['FocusDeath']:RegisterForClicks("AnyDown")
	buttons['FocusDeath']:SetAttribute("macrotext", "/cast [@focus] Shadow Word: Death")
	
	buttons['FocusDispelMagic'] = CreateFrame("Button", "FocusDispelMagic-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusDispelMagic']:SetAttribute("type", "macro")
	buttons['FocusDispelMagic']:RegisterForClicks("AnyDown")
	buttons['FocusDispelMagic']:SetAttribute("macrotext", "/cast [@focus,harm] Dispel Magic")

	buttons['FocusPain'] = CreateFrame("Button", "FocusPain-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusPain']:SetAttribute("type", "macro")
	buttons['FocusPain']:RegisterForClicks("AnyDown")
	buttons['FocusPain']:SetAttribute("macrotext", "/cast [@focus] Shadow Word: Pain")

	buttons['FocusDevouring'] = CreateFrame("Button", "FocusDevouring-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusDevouring']:SetAttribute("type", "macro")
	buttons['FocusDevouring']:RegisterForClicks("AnyDown")
	buttons['FocusDevouring']:SetAttribute("macrotext", "/cast [@focus] Devouring Plague")

	buttons['FocusVampiricTouch'] = CreateFrame("Button", "FocusVampiricTouch-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusVampiricTouch']:SetAttribute("type", "macro")
	buttons['FocusVampiricTouch']:RegisterForClicks("AnyDown")
	buttons['FocusVampiricTouch']:SetAttribute("macrotext", "/cast [@focus] Vampiric Touch")

	buttons['FocusMindFlay'] = CreateFrame("Button", "FocusMindFlay-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusMindFlay']:SetAttribute("type", "macro")
	buttons['FocusMindFlay']:RegisterForClicks("AnyDown")
	buttons['FocusMindFlay']:SetAttribute("macrotext", "/cast [@focus] Mind Flay")

	buttons['FocusMindControl'] = CreateFrame("Button", "FocusMindControl-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusMindControl']:SetAttribute("type", "macro")
	buttons['FocusMindControl']:RegisterForClicks("AnyDown")
	buttons['FocusMindControl']:SetAttribute("macrotext", "/cast [@focus] Mind Control")

	buttons['FocusManaBurn'] = CreateFrame("Button", "FocusManaBurn-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusManaBurn']:SetAttribute("type", "macro")
	buttons['FocusManaBurn']:RegisterForClicks("AnyDown")
	buttons['FocusManaBurn']:SetAttribute("macrotext", "/cast [@focus] Mana Burn")
	
	buttons['FocusShackle'] = CreateFrame("Button", "FocusShackle-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusShackle']:SetAttribute("type", "macro")
	buttons['FocusShackle']:RegisterForClicks("AnyDown")
	buttons['FocusShackle']:SetAttribute("macrotext", "/cast [@focus] Shackle Undead")

	buttons['FocusSilence'] = CreateFrame("Button", "FocusSilence-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusSilence']:SetAttribute("type", "macro")
	buttons['FocusSilence']:RegisterForClicks("AnyDown")
	buttons['FocusSilence']:SetAttribute("macrotext", "/cast [@focus] Silence")

	buttons['FocusHorror'] = CreateFrame("Button", "FocusHorror-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusHorror']:SetAttribute("type", "macro")
	buttons['FocusHorror']:RegisterForClicks("AnyDown")
	buttons['FocusHorror']:SetAttribute("macrotext", "/cast [@focus] Psychic Horror")

	buttons['MouseoverDeath'] = CreateFrame("Button", "MouseoverDeath-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverDeath']:SetAttribute("type", "macro")
	buttons['MouseoverDeath']:RegisterForClicks("AnyDown")
	buttons['MouseoverDeath']:SetAttribute("macrotext", "/cast [@mouseover] Shadow Word: Death")

	buttons['MouseoverLeapOfFaith'] = CreateFrame("Button", "MouseoverLeapOfFaith-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverLeapOfFaith']:SetAttribute("type", "macro")
	buttons['MouseoverLeapOfFaith']:RegisterForClicks("AnyDown")
	buttons['MouseoverLeapOfFaith']:SetAttribute("macrotext", "/cast [@mouseover] Leap of Faith")
	
	buttons['MouseoverMindControl'] = CreateFrame("Button", "MouseoverMindControl-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverMindControl']:SetAttribute("type", "macro")
	buttons['MouseoverMindControl']:RegisterForClicks("AnyDown")
	buttons['MouseoverMindControl']:SetAttribute("macrotext", "/cast [@mouseover] Mind Control")
	
	buttons['MouseoverDispelMagic'] = CreateFrame("Button", "MouseoverDispelMagic-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverDispelMagic']:SetAttribute("type", "macro")
	buttons['MouseoverDispelMagic']:RegisterForClicks("AnyDown")
	buttons['MouseoverDispelMagic']:SetAttribute("macrotext", "/cast [@mouseover,harm] Dispel Magic")

	buttons['MouseoverShackle'] = CreateFrame("Button", "MouseoverShackle-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverShackle']:SetAttribute("type", "macro")
	buttons['MouseoverShackle']:RegisterForClicks("AnyDown")
	buttons['MouseoverShackle']:SetAttribute("macrotext", "/cast [@mouseover] Shackle Undead")

	buttons['MouseoverPSGS'] = CreateFrame("Button", "MouseoverPSGS-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverPSGS']:SetAttribute("type", "macro")
	buttons['MouseoverPSGS']:RegisterForClicks("AnyDown")
	buttons['MouseoverPSGS']:SetAttribute("macrotext", "/cast [@mouseover] Pain Suppression\n/cast [@mouseover] Guardian Spirit")


	for i = 1,5 do
		buttons['DeathArena'..i] = CreateFrame("Button", "DeathArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['DeathArena'..i]:SetAttribute("type", "macro")
		buttons['DeathArena'..i]:RegisterForClicks("AnyDown")
		buttons['DeathArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Shadow Word: Death")

		buttons['DispelMagicArena'..i] = CreateFrame("Button", "DispelMagicArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['DispelMagicArena'..i]:SetAttribute("type", "macro")
		buttons['DispelMagicArena'..i]:RegisterForClicks("AnyDown")
		buttons['DispelMagicArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i..",harm] Dispel Magic")

		buttons['SilenceArena'..i] = CreateFrame("Button", "SilenceArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SilenceArena'..i]:SetAttribute("type", "macro")
		buttons['SilenceArena'..i]:RegisterForClicks("AnyDown")
		buttons['SilenceArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Silence")

		buttons['HorrorArena'..i] = CreateFrame("Button", "HorrorArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['HorrorArena'..i]:SetAttribute("type", "macro")
		buttons['HorrorArena'..i]:RegisterForClicks("AnyDown")
		buttons['HorrorArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Psychic Horror")

		buttons['MindControlArena'..i] = CreateFrame("Button", "MindControlArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['MindControlArena'..i]:SetAttribute("type", "macro")
		buttons['MindControlArena'..i]:RegisterForClicks("AnyDown")
		buttons['MindControlArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Mind Control")

		buttons['PainArena'..i] = CreateFrame("Button", "PainArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['PainArena'..i]:SetAttribute("type", "macro")
		buttons['PainArena'..i]:RegisterForClicks("AnyDown")
		buttons['PainArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Shadow Word: Pain")

		buttons['ShadowfiendArena'..i] = CreateFrame("Button", "ShadowfiendArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ShadowfiendArena'..i]:SetAttribute("type", "macro")
		buttons['ShadowfiendArena'..i]:RegisterForClicks("AnyDown")
		buttons['ShadowfiendArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Shadowfiend")

		buttons['ShackleArena'..i] = CreateFrame("Button", "ShackleArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ShackleArena'..i]:SetAttribute("type", "macro")
		buttons['ShackleArena'..i]:RegisterForClicks("AnyDown")
		buttons['ShackleArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Shackle Undead")

		buttons['ShackleArenaPet'..i] = CreateFrame("Button", "ShackleArenaPet"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ShackleArenaPet'..i]:SetAttribute("type", "macro")
		buttons['ShackleArenaPet'..i]:RegisterForClicks("AnyDown")
		buttons['ShackleArenaPet'..i]:SetAttribute("macrotext", "/cast [@arenapet"..i.."] Shackle Undead")
	end

	for i = 1,5 do
		x = i-1

		buttons['DispelMagicParty'..x] = CreateFrame("Button", "DispelMagicParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['DispelMagicParty'..x]:SetAttribute("type", "macro")
		buttons['DispelMagicParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['DispelMagicParty'..x]:SetAttribute("macrotext", "/cast [@player,noharm] Dispel Magic")
		else
			buttons['DispelMagicParty'..x]:SetAttribute("macrotext", "/cast [@party"..x..",noharm] Dispel Magic")
		end

		buttons['CureDiseaseParty'..x] = CreateFrame("Button", "DispelMagicParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['CureDiseaseParty'..x]:SetAttribute("type", "macro")
		buttons['CureDiseaseParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['CureDiseaseParty'..x]:SetAttribute("macrotext", "/cast [@player] Cure Disease")
		else
			buttons['CureDiseaseParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Cure Disease")
		end

		buttons['PSGSParty'..x] = CreateFrame("Button", "PSGSParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['PSGSParty'..x]:SetAttribute("type", "macro")
		buttons['PSGSParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['PSGSParty'..x]:SetAttribute("macrotext", "/cast [@player] Pain Suppression\n/cast [@player] Guardian Spirit")
		else
			buttons['PSGSParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Pain Suppression\n/cast [@party"..x.."] Guardian Spirit")
		end

		buttons['FearWardParty'..x] = CreateFrame("Button", "FearWardParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['FearWardParty'..x]:SetAttribute("type", "macro")
		buttons['FearWardParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['FearWardParty'..x]:SetAttribute("macrotext", "/cast [@player] Fear Ward")
		else
			buttons['FearWardParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Fear Ward")
		end

		buttons['PowerInfusionParty'..x] = CreateFrame("Button", "PowerInfusionParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['PowerInfusionParty'..x]:SetAttribute("type", "macro")
		buttons['PowerInfusionParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['PowerInfusionParty'..x]:SetAttribute("macrotext", "/cast [@player] Power Infusion")
		else
			buttons['PowerInfusionParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Power Infusion")
		end

		if x ~= 0 then
			buttons['LeapOfFaithParty'..x] = CreateFrame("Button", "LeapOfFaithParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
			buttons['LeapOfFaithParty'..x]:SetAttribute("type", "macro")
			buttons['LeapOfFaithParty'..x]:RegisterForClicks("AnyDown")
			buttons['LeapOfFaithParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Leap of Faith")

			buttons['MindSearParty'..x] = CreateFrame("Button", "MindSearParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
			buttons['MindSearParty'..x]:SetAttribute("type", "macro")
			buttons['MindSearParty'..x]:RegisterForClicks("AnyDown")
			buttons['MindSearParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Mind Sear")
		end
	end


	-- Shaman
	buttons['CancelGhostWolf'] = CreateFrame("Button", "CancelGhostWolf-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelGhostWolf']:SetAttribute("type", "macro")
	buttons['CancelGhostWolf']:RegisterForClicks("AnyDown")
	buttons['CancelGhostWolf']:SetAttribute("macrotext", "/cancelaura Ghost Wolf")

	buttons['CancelAir'] = CreateFrame("Button", "CancelAir-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelAir']:SetAttribute("type", "macro")
	buttons['CancelAir']:RegisterForClicks("AnyDown")
	buttons['CancelAir']:SetAttribute("macrotext", "/click TotemFrameTotem1 RightButton")

	buttons['CancelWater'] = CreateFrame("Button", "CancelWater-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelWater']:SetAttribute("type", "macro")
	buttons['CancelWater']:RegisterForClicks("AnyDown")
	buttons['CancelWater']:SetAttribute("macrotext", "/click TotemFrameTotem2 RightButton")

	buttons['CancelEarth'] = CreateFrame("Button", "CancelEarth-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelEarth']:SetAttribute("type", "macro")
	buttons['CancelEarth']:RegisterForClicks("AnyDown")
	buttons['CancelEarth']:SetAttribute("macrotext", "/click TotemFrameTotem3 RightButton")

	buttons['CancelFire'] = CreateFrame("Button", "CancelFire-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelFire']:SetAttribute("type", "macro")
	buttons['CancelFire']:RegisterForClicks("AnyDown")
	buttons['CancelFire']:SetAttribute("macrotext", "/click TotemFrameTotem4 RightButton")

	buttons['CancelTotems'] = CreateFrame("Button", "CancelTotems-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelTotems']:SetAttribute("type", "macro")
	buttons['CancelTotems']:RegisterForClicks("AnyDown")
	buttons['CancelTotems']:SetAttribute("macrotext", "/click TotemFrameTotem1 RightButton\n/click TotemFrameTotem2 RightButton\n/click TotemFrameTotem3 RightButton\n/click TotemFrameTotem4 RightButton")

	buttons['Flametongue'] = CreateFrame("Button", "Flametongue-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['Flametongue']:SetAttribute("type", "macro")
	buttons['Flametongue']:RegisterForClicks("AnyDown")
	buttons['Flametongue']:SetAttribute("macrotext", "/cast Flametongue Weapon")

	buttons['Flametongue'] = CreateFrame("Button", "Flametongue-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['Flametongue']:SetAttribute("type", "macro")
	buttons['Flametongue']:RegisterForClicks("AnyDown")
	buttons['Flametongue']:SetAttribute("macrotext", "/cast Flametongue Weapon")
	
	buttons['Windfury'] = CreateFrame("Button", "Windfury-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['Windfury']:SetAttribute("type", "macro")
	buttons['Windfury']:RegisterForClicks("AnyDown")
	buttons['Windfury']:SetAttribute("macrotext", "/cast Windfury Weapon")

	buttons['Earthliving'] = CreateFrame("Button", "Earthliving-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['Earthliving']:SetAttribute("type", "macro")
	buttons['Earthliving']:RegisterForClicks("AnyDown")
	buttons['Earthliving']:SetAttribute("macrotext", "/cast Earthliving Weapon")

	buttons['Frostbrand'] = CreateFrame("Button", "Frostbrand-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['Frostbrand']:SetAttribute("type", "macro")
	buttons['Frostbrand']:RegisterForClicks("AnyDown")
	buttons['Frostbrand']:SetAttribute("macrotext", "/cast Frostbrand Weapon")

	buttons['Rockbiter'] = CreateFrame("Button", "Rockbiter-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['Rockbiter']:SetAttribute("type", "macro")
	buttons['Rockbiter']:RegisterForClicks("AnyDown")
	buttons['Rockbiter']:SetAttribute("macrotext", "/cast Rockbiter Weapon")

	buttons['MouseoverWindShear'] = CreateFrame("Button", "MouseoverWindShear-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverWindShear']:SetAttribute("type", "macro")
	buttons['MouseoverWindShear']:RegisterForClicks("AnyDown")
	buttons['MouseoverWindShear']:SetAttribute("macrotext", "/cast [@mouseover] Wind Shear")

	buttons['MouseoverPurge'] = CreateFrame("Button", "MouseoverPurge-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverPurge']:SetAttribute("type", "macro")
	buttons['MouseoverPurge']:RegisterForClicks("AnyDown")
	buttons['MouseoverPurge']:SetAttribute("macrotext", "/cast [@mouseover] Purge")

	buttons['MouseoverHex'] = CreateFrame("Button", "MouseoverHex-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverHex']:SetAttribute("type", "macro")
	buttons['MouseoverHex']:RegisterForClicks("AnyDown")
	buttons['MouseoverHex']:SetAttribute("macrotext", "/cast [@mouseover] Hex")

	buttons['MouseoverBindElemental'] = CreateFrame("Button", "MouseoverBindElemental-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverBindElemental']:SetAttribute("type", "macro")
	buttons['MouseoverBindElemental']:RegisterForClicks("AnyDown")
	buttons['MouseoverBindElemental']:SetAttribute("macrotext", "/cast [@mouseover] Bind Elemental")

	buttons['BindElementalWaterElemental'] = CreateFrame("Button", "BindElementalWaterElemental-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['BindElementalWaterElemental']:SetAttribute("type", "macro")
	buttons['BindElementalWaterElemental']:RegisterForClicks("AnyDown")
	buttons['BindElementalWaterElemental']:SetAttribute("macrotext", "/cast [@Water Elemental] Bind Elemental")

	buttons['NSGreaterHeal'] = CreateFrame("Button", "NSGreaterHeal-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['NSGreaterHeal']:SetAttribute("type", "macro")
	buttons['NSGreaterHeal']:RegisterForClicks("AnyDown")
	buttons['NSGreaterHeal']:SetAttribute("macrotext", "/cast Nature's Swiftness\n/cast Greater Healing Wave")

	buttons['NSChainHeal'] = CreateFrame("Button", "NSChainHeal-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['NSChainHeal']:SetAttribute("type", "macro")
	buttons['NSChainHeal']:RegisterForClicks("AnyDown")
	buttons['NSChainHeal']:SetAttribute("macrotext", "/cast Nature's Swiftness\n/cast Chain Heal")

	buttons['NSHex'] = CreateFrame("Button", "NSHex-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['NSHex']:SetAttribute("type", "macro")
	buttons['NSHex']:RegisterForClicks("AnyDown")
	buttons['NSHex']:SetAttribute("macrotext", "/cast Nature's Swiftness\n/cast Hex")

	buttons['NSLightningBolt'] = CreateFrame("Button", "NSLightningBolt-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['NSLightningBolt']:SetAttribute("type", "macro")
	buttons['NSLightningBolt']:RegisterForClicks("AnyDown")
	buttons['NSLightningBolt']:SetAttribute("macrotext", "/cast Nature's Swiftness\n/cast Lightning Bolt")
	
	buttons['NSChainLightning'] = CreateFrame("Button", "NSChainLightning-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['NSChainLightning']:SetAttribute("type", "macro")
	buttons['NSChainLightning']:RegisterForClicks("AnyDown")
	buttons['NSChainLightning']:SetAttribute("macrotext", "/cast Nature's Swiftness\n/cast Chain Lightning")

	buttons['EMLavaBurst'] = CreateFrame("Button", "EMLavaBurst-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['EMLavaBurst']:SetAttribute("type", "macro")
	buttons['EMLavaBurst']:RegisterForClicks("AnyDown")
	buttons['EMLavaBurst']:SetAttribute("macrotext", "/cast Elemental Mastery\n/cast Lava Burst")

	buttons['EMLightningBolt'] = CreateFrame("Button", "EMLightningBolt-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['EMLightningBolt']:SetAttribute("type", "macro")
	buttons['EMLightningBolt']:RegisterForClicks("AnyDown")
	buttons['EMLightningBolt']:SetAttribute("macrotext", "/cast Elemental Mastery\n/cast Lightning Bolt")

	buttons['EMChainLightning'] = CreateFrame("Button", "EMChainLightning-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['EMChainLightning']:SetAttribute("type", "macro")
	buttons['EMChainLightning']:RegisterForClicks("AnyDown")
	buttons['EMChainLightning']:SetAttribute("macrotext", "/cast Elemental Mastery\n/cast Chain Lightning")

	buttons['FocusWindShear'] = CreateFrame("Button", "FocusWindShear-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusWindShear']:SetAttribute("type", "macro")
	buttons['FocusWindShear']:RegisterForClicks("AnyDown")
	buttons['FocusWindShear']:SetAttribute("macrotext", "/cast [@focus] Wind Shear")

	buttons['FocusPurge'] = CreateFrame("Button", "FocusPurge-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusPurge']:SetAttribute("type", "macro")
	buttons['FocusPurge']:RegisterForClicks("AnyDown")
	buttons['FocusPurge']:SetAttribute("macrotext", "/cast [@focus] Purge")

	buttons['FocusHex'] = CreateFrame("Button", "FocusHex-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusHex']:SetAttribute("type", "macro")
	buttons['FocusHex']:RegisterForClicks("AnyDown")
	buttons['FocusHex']:SetAttribute("macrotext", "/cast [@focus] Hex")

	buttons['FocusNSHex'] = CreateFrame("Button", "FocusNSHex-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusNSHex']:SetAttribute("type", "macro")
	buttons['FocusNSHex']:RegisterForClicks("AnyDown")
	buttons['FocusNSHex']:SetAttribute("macrotext", "/cast Nature's Swiftness\n/cast [@focus] Hex")

	buttons['FocusFlameShock'] = CreateFrame("Button", "FocusFlameShock-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusFlameShock']:SetAttribute("type", "macro")
	buttons['FocusFlameShock']:RegisterForClicks("AnyDown")
	buttons['FocusFlameShock']:SetAttribute("macrotext", "/cast [@focus] Flame Shock")

	buttons['FocusFrostShock'] = CreateFrame("Button", "FocusFrostShock-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusFrostShock']:SetAttribute("type", "macro")
	buttons['FocusFrostShock']:RegisterForClicks("AnyDown")
	buttons['FocusFrostShock']:SetAttribute("macrotext", "/cast [@focus] Frost Shock")

	buttons['FocusEarthShock'] = CreateFrame("Button", "FocusEarthShock-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusEarthShock']:SetAttribute("type", "macro")
	buttons['FocusEarthShock']:RegisterForClicks("AnyDown")
	buttons['FocusEarthShock']:SetAttribute("macrotext", "/cast [@focus] Earth Shock")

	buttons['FocusBindElemental'] = CreateFrame("Button", "FocusBindElemental-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusBindElemental']:SetAttribute("type", "macro")
	buttons['FocusBindElemental']:RegisterForClicks("AnyDown")
	buttons['FocusBindElemental']:SetAttribute("macrotext", "/cast [@focus] Bind Elemental")

	buttons['FocusPetBash'] = CreateFrame("Button", "FocusPetBash-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusPetBash']:SetAttribute("type", "macro")
	buttons['FocusPetBash']:RegisterForClicks("AnyDown")
	buttons['FocusPetBash']:SetAttribute("macrotext", "/cast [@focus] Bash")

	for i = 1,5 do
		buttons['WindShearArena'..i] = CreateFrame("Button", "WindShearArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['WindShearArena'..i]:SetAttribute("type", "macro")
		buttons['WindShearArena'..i]:RegisterForClicks("AnyDown")
		buttons['WindShearArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Wind Shear")

		buttons['PurgeArena'..i] = CreateFrame("Button", "PurgeArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['PurgeArena'..i]:SetAttribute("type", "macro")
		buttons['PurgeArena'..i]:RegisterForClicks("AnyDown")
		buttons['PurgeArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Purge")

		buttons['HexArena'..i] = CreateFrame("Button", "HexArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['HexArena'..i]:SetAttribute("type", "macro")
		buttons['HexArena'..i]:RegisterForClicks("AnyDown")
		buttons['HexArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Hex")

		buttons['NSHexArena'..i] = CreateFrame("Button", "NSHexArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['NSHexArena'..i]:SetAttribute("type", "macro")
		buttons['NSHexArena'..i]:RegisterForClicks("AnyDown")
		buttons['NSHexArena'..i]:SetAttribute("macrotext", "/cast Ancestral Swiftness\n/cast [@arena"..i.."] Hex")

		buttons['FlameShockArena'..i] = CreateFrame("Button", "FlameShockArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['FlameShockArena'..i]:SetAttribute("type", "macro")
		buttons['FlameShockArena'..i]:RegisterForClicks("AnyDown")
		buttons['FlameShockArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Flame Shock")

		buttons['FrostShockArena'..i] = CreateFrame("Button", "FrostShockArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['FrostShockArena'..i]:SetAttribute("type", "macro")
		buttons['FrostShockArena'..i]:RegisterForClicks("AnyDown")
		buttons['FrostShockArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Frost Shock")

		buttons['EarthShockArena'..i] = CreateFrame("Button", "EarthShockArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['EarthShockArena'..i]:SetAttribute("type", "macro")
		buttons['EarthShockArena'..i]:RegisterForClicks("AnyDown")
		buttons['EarthShockArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Earth Shock")

		buttons['PetBashArena'..i] = CreateFrame("Button", "PetBashArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['PetBashArena'..i]:SetAttribute("type", "macro")
		buttons['PetBashArena'..i]:RegisterForClicks("AnyDown")
		buttons['PetBashArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Bash")

		buttons['BindElementalArenaPet'..i] = CreateFrame("Button", "BindElementalArenaPet"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['BindElementalArenaPet'..i]:SetAttribute("type", "macro")
		buttons['BindElementalArenaPet'..i]:RegisterForClicks("AnyDown")
		buttons['BindElementalArenaPet'..i]:SetAttribute("macrotext", "/cast [@arenapet"..i.."] Bind Elemental")
	end

	for i = 1,5 do
		x = i-1

		buttons['CleanseSpiritParty'..x] = CreateFrame("Button", "CleanseSpiritParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['CleanseSpiritParty'..x]:SetAttribute("type", "macro")
		buttons['CleanseSpiritParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['CleanseSpiritParty'..x]:SetAttribute("macrotext", "/cast [@player] Cleanse Spirit")
		else
			buttons['CleanseSpiritParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Cleanse Spirit")
		end
	end


	-- Paladin
	buttons['CancelDivineShield'] = CreateFrame("Button", "CancelDivineShield-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelDivineShield']:SetAttribute("type", "macro")
	buttons['CancelDivineShield']:RegisterForClicks("AnyDown")
	buttons['CancelDivineShield']:SetAttribute("macrotext", "/cancelaura Divine Shield")

	buttons['CancelDivineShieldBoP'] = CreateFrame("Button", "CancelDivineShieldBoP-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelDivineShieldBoP']:SetAttribute("type", "macro")
	buttons['CancelDivineShieldBoP']:RegisterForClicks("AnyDown")
	buttons['CancelDivineShieldBoP']:SetAttribute("macrotext", "/cancelaura Divine Shield\n/cancelaura Hand of Protection")

	buttons['CancelDivinePlea'] = CreateFrame("Button", "CancelDivinePlea-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelDivinePlea']:SetAttribute("type", "macro")
	buttons['CancelDivinePlea']:RegisterForClicks("AnyDown")
	buttons['CancelDivinePlea']:SetAttribute("macrotext", "/cancelaura Divine Plea")

	buttons['CancelRighteousFury'] = CreateFrame("Button", "CancelRighteousFury-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelRighteousFury']:SetAttribute("type", "macro")
	buttons['CancelRighteousFury']:RegisterForClicks("AnyDown")
	buttons['CancelRighteousFury']:SetAttribute("macrotext", "/cancelaura Righteous Fury")

	buttons['DevotionAura'] = CreateFrame("Button", "DevotionAura-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['DevotionAura']:SetAttribute("type", "macro")
	buttons['DevotionAura']:RegisterForClicks("AnyDown")
	buttons['DevotionAura']:SetAttribute("macrotext", "/cast !Devotion Aura")

	buttons['RetributionAura'] = CreateFrame("Button", "RetributionAura-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['RetributionAura']:SetAttribute("type", "macro")
	buttons['RetributionAura']:RegisterForClicks("AnyDown")
	buttons['RetributionAura']:SetAttribute("macrotext", "/cast !Retribution Aura")

	buttons['ConcentrationAura'] = CreateFrame("Button", "ConcentrationAura-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['ConcentrationAura']:SetAttribute("type", "macro")
	buttons['ConcentrationAura']:RegisterForClicks("AnyDown")
	buttons['ConcentrationAura']:SetAttribute("macrotext", "/cast !Concentration Aura")

	buttons['ResistanceAura'] = CreateFrame("Button", "ResistanceAura-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['ResistanceAura']:SetAttribute("type", "macro")
	buttons['ResistanceAura']:RegisterForClicks("AnyDown")
	buttons['ResistanceAura']:SetAttribute("macrotext", "/cast !Resistance Aura")

	buttons['CrusaderAura'] = CreateFrame("Button", "CrusaderAura-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CrusaderAura']:SetAttribute("type", "macro")
	buttons['CrusaderAura']:RegisterForClicks("AnyDown")
	buttons['CrusaderAura']:SetAttribute("macrotext", "/cast !Crusader Aura")

	buttons['TurnEvilGargoyle'] = CreateFrame("Button", "TurnEvilGargoyle-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['TurnEvilGargoyle']:SetAttribute("type", "macro")
	buttons['TurnEvilGargoyle']:RegisterForClicks("AnyDown")
	buttons['TurnEvilGargoyle']:SetAttribute("macrotext", "/cast [@Ebon Gargoyle] Turn Evil")

	buttons['FocusHoJ'] = CreateFrame("Button", "FocusHoJ-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusHoJ']:SetAttribute("type", "macro")
	buttons['FocusHoJ']:RegisterForClicks("AnyDown")
	buttons['FocusHoJ']:SetAttribute("macrotext", "/cast [@focus] Hammer of Justice")

	buttons['FocusRebuke'] = CreateFrame("Button", "FocusRebuke-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusRebuke']:SetAttribute("type", "macro")
	buttons['FocusRebuke']:RegisterForClicks("AnyDown")
	buttons['FocusRebuke']:SetAttribute("macrotext", "/cast [@focus] Rebuke")

	buttons['FocusRepentance'] = CreateFrame("Button", "FocusRepentance-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusRepentance']:SetAttribute("type", "macro")
	buttons['FocusRepentance']:RegisterForClicks("AnyDown")
	buttons['FocusRepentance']:SetAttribute("macrotext", "/cast [@focus] Repentance")

	buttons['FocusCrusaderStrike'] = CreateFrame("Button", "FocusCrusaderStrike-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusCrusaderStrike']:SetAttribute("type", "macro")
	buttons['FocusCrusaderStrike']:RegisterForClicks("AnyDown")
	buttons['FocusCrusaderStrike']:SetAttribute("macrotext", "/cast [@focus] Crusader Strike")

	buttons['FocusExorcism'] = CreateFrame("Button", "FocusExorcism-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusExorcism']:SetAttribute("type", "macro")
	buttons['FocusExorcism']:RegisterForClicks("AnyDown")
	buttons['FocusExorcism']:SetAttribute("macrotext", "/cast [@focus] Exorcism")

	buttons['FocusHammerOfWrath'] = CreateFrame("Button", "FocusHammerOfWrath-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusHammerOfWrath']:SetAttribute("type", "macro")
	buttons['FocusHammerOfWrath']:RegisterForClicks("AnyDown")
	buttons['FocusHammerOfWrath']:SetAttribute("macrotext", "/cast [@focus] Hammer of Wrath")

	buttons['FocusTurnEvil'] = CreateFrame("Button", "FocusTurnEvil-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusTurnEvil']:SetAttribute("type", "macro")
	buttons['FocusTurnEvil']:RegisterForClicks("AnyDown")
	buttons['FocusTurnEvil']:SetAttribute("macrotext", "/cast [@focus] Turn Evil")

	buttons['MouseoverCrusaderStrike'] = CreateFrame("Button", "MouseoverCrusaderStrike-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverCrusaderStrike']:SetAttribute("type", "macro")
	buttons['MouseoverCrusaderStrike']:RegisterForClicks("AnyDown")
	buttons['MouseoverCrusaderStrike']:SetAttribute("macrotext", "/cast [@mouseover] Crusader Strike")

	buttons['MouseoverLayOnHands'] = CreateFrame("Button", "MouseoverLayOnHands-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverLayOnHands']:SetAttribute("type", "macro")
	buttons['MouseoverLayOnHands']:RegisterForClicks("AnyDown")
	buttons['MouseoverLayOnHands']:SetAttribute("macrotext", "/cast [@mouseover] Lay on Hands")

	buttons['MouseoverHoJ'] = CreateFrame("Button", "MouseoverHoJ-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverHoJ']:SetAttribute("type", "macro")
	buttons['MouseoverHoJ']:RegisterForClicks("AnyDown")
	buttons['MouseoverHoJ']:SetAttribute("macrotext", "/cast [@mouseover] Hammer of Justice")

	buttons['MouseoverRepentance'] = CreateFrame("Button", "MouseoverRepentance-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverRepentance']:SetAttribute("type", "macro")
	buttons['MouseoverRepentance']:RegisterForClicks("AnyDown")
	buttons['MouseoverRepentance']:SetAttribute("macrotext", "/cast [@mouseover] Repentance")

	buttons['MouseoverJudgement'] = CreateFrame("Button", "MouseoverJudgement-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverJudgement']:SetAttribute("type", "macro")
	buttons['MouseoverJudgement']:RegisterForClicks("AnyDown")
	buttons['MouseoverJudgement']:SetAttribute("macrotext", "/cast [@mouseover] Judgement")

	buttons['MouseoverBoP'] = CreateFrame("Button", "MouseoverBoP-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverBoP']:SetAttribute("type", "macro")
	buttons['MouseoverBoP']:RegisterForClicks("AnyDown")
	buttons['MouseoverBoP']:SetAttribute("macrotext", "/cast [@mouseover] Hand of Protection")

	buttons['MouseoverSacrifice'] = CreateFrame("Button", "MouseoverSacrifice-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverSacrifice']:SetAttribute("type", "macro")
	buttons['MouseoverSacrifice']:RegisterForClicks("AnyDown")
	buttons['MouseoverSacrifice']:SetAttribute("macrotext", "/cast [@mouseover] Hand of Sacrifice")

	buttons['MouseoverSalvation'] = CreateFrame("Button", "MouseoverSalvation-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverSalvation']:SetAttribute("type", "macro")
	buttons['MouseoverSalvation']:RegisterForClicks("AnyDown")
	buttons['MouseoverSalvation']:SetAttribute("macrotext", "/cast [@mouseover] Hand of Salvation")

	buttons['MouseoverHammerOfWrath'] = CreateFrame("Button", "MouseoverHammerOfWrath-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverHammerOfWrath']:SetAttribute("type", "macro")
	buttons['MouseoverHammerOfWrath']:RegisterForClicks("AnyDown")
	buttons['MouseoverHammerOfWrath']:SetAttribute("macrotext", "/cast [@mouseover] Hammer of Wrath")

	buttons['MouseoverReckoning'] = CreateFrame("Button", "MouseoverReckoning-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverReckoning']:SetAttribute("type", "macro")
	buttons['MouseoverReckoning']:RegisterForClicks("AnyDown")
	buttons['MouseoverReckoning']:SetAttribute("macrotext", "/cast [@mouseover] Hand of Reckoning")

	buttons['MouseoverRighteousDefense'] = CreateFrame("Button", "MouseoverRighteousDefense-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverRighteousDefense']:SetAttribute("type", "macro")
	buttons['MouseoverRighteousDefense']:RegisterForClicks("AnyDown")
	buttons['MouseoverRighteousDefense']:SetAttribute("macrotext", "/cast [@mouseover] Righteous Defense")
	
	for i = 1,5 do
		buttons['HoJArena'..i] = CreateFrame("Button", "HoJArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['HoJArena'..i]:SetAttribute("type", "macro")
		buttons['HoJArena'..i]:RegisterForClicks("AnyDown")
		buttons['HoJArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Hammer of Justice")

		buttons['RebukeArena'..i] = CreateFrame("Button", "RebukeArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['RebukeArena'..i]:SetAttribute("type", "macro")
		buttons['RebukeArena'..i]:RegisterForClicks("AnyDown")
		buttons['RebukeArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Rebuke")

		buttons['RepentanceArena'..i] = CreateFrame("Button", "RepentanceArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['RepentanceArena'..i]:SetAttribute("type", "macro")
		buttons['RepentanceArena'..i]:RegisterForClicks("AnyDown")
		buttons['RepentanceArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Repentance")
		
		buttons['ExorcismArena'..i] = CreateFrame("Button", "ExorcismArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ExorcismArena'..i]:SetAttribute("type", "macro")
		buttons['ExorcismArena'..i]:RegisterForClicks("AnyDown")
		buttons['ExorcismArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Exorcism")

		buttons['JudgementArena'..i] = CreateFrame("Button", "JudgementArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['JudgementArena'..i]:SetAttribute("type", "macro")
		buttons['JudgementArena'..i]:RegisterForClicks("AnyDown")
		buttons['JudgementArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Judgement")

		buttons['HammerOfWrathArena'..i] = CreateFrame("Button", "HammerOfWrathArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['HammerOfWrathArena'..i]:SetAttribute("type", "macro")
		buttons['HammerOfWrathArena'..i]:RegisterForClicks("AnyDown")
		buttons['HammerOfWrathArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Hammer of Wrath")

		buttons['TurnEvilArena'..i] = CreateFrame("Button", "TurnEvilArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['TurnEvilArena'..i]:SetAttribute("type", "macro")
		buttons['TurnEvilArena'..i]:RegisterForClicks("AnyDown")
		buttons['TurnEvilArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Turn Evil")
		
		buttons['TurnEvilArenaPet'..i] = CreateFrame("Button", "TurnEvilArenaPet"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['TurnEvilArenaPet'..i]:SetAttribute("type", "macro")
		buttons['TurnEvilArenaPet'..i]:RegisterForClicks("AnyDown")
		buttons['TurnEvilArenaPet'..i]:SetAttribute("macrotext", "/cast [@arenapet"..i.."] Turn Evil")

		buttons['TauntArena'..i] = CreateFrame("Button", "TauntArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['TauntArena'..i]:SetAttribute("type", "macro")
		buttons['TauntArena'..i]:RegisterForClicks("AnyDown")
		buttons['TauntArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Hand of Reckoning")

		buttons['TauntArenaPet'..i] = CreateFrame("Button", "TauntArenaPet"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['TauntArenaPet'..i]:SetAttribute("type", "macro")
		buttons['TauntArenaPet'..i]:RegisterForClicks("AnyDown")
		buttons['TauntArenaPet'..i]:SetAttribute("macrotext", "/cast [@arenapet"..i.."] Hand of Reckoning")
	end
	
	for i = 1,5 do
		x = i-1

		buttons['CleanseParty'..x] = CreateFrame("Button", "CleanseParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['CleanseParty'..x]:SetAttribute("type", "macro")
		buttons['CleanseParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['CleanseParty'..x]:SetAttribute("macrotext", "/cast [@player] Cleanse")
		else
			buttons['CleanseParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Cleanse")
		end

		buttons['FreedomParty'..x] = CreateFrame("Button", "FreedomParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['FreedomParty'..x]:SetAttribute("type", "macro")
		buttons['FreedomParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['FreedomParty'..x]:SetAttribute("macrotext", "/cast [@player] Hand of Freedom")
		else
			buttons['FreedomParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Hand of Freedom")
		end

		buttons['FreedomParty'..x] = CreateFrame("Button", "FreedomParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['FreedomParty'..x]:SetAttribute("type", "macro")
		buttons['FreedomParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['FreedomParty'..x]:SetAttribute("macrotext", "/cast [@player] Hand of Freedom")
		else
			buttons['FreedomParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Hand of Freedom")
		end

		buttons['BoPParty'..x] = CreateFrame("Button", "BoPParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['BoPParty'..x]:SetAttribute("type", "macro")
		buttons['BoPParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['BoPParty'..x]:SetAttribute("macrotext", "/cast [@player] Hand of Protection")
		else
			buttons['BoPParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Hand of Protection")
		end

		buttons['SalvationParty'..x] = CreateFrame("Button", "SalvationParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SalvationParty'..x]:SetAttribute("type", "macro")
		buttons['SalvationParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['SalvationParty'..x]:SetAttribute("macrotext", "/cast [@player] Hand of Salvation")
		else
			buttons['SalvationParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Hand of Salvation")
		end

		buttons['WoGParty'..x] = CreateFrame("Button", "WoGParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['WoGParty'..x]:SetAttribute("type", "macro")
		buttons['WoGParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['WoGParty'..x]:SetAttribute("macrotext", "/cast [@player] Word of Glory")
		else
			buttons['WoGParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Word of Glory")
		end

		buttons['BeaconParty'..x] = CreateFrame("Button", "BeaconParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['BeaconParty'..x]:SetAttribute("type", "macro")
		buttons['BeaconParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['BeaconParty'..x]:SetAttribute("macrotext", "/cast [@player] Beacon of Light")
		else
			buttons['BeaconParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Beacon of Light")
		end

		buttons['BeaconParty'..x] = CreateFrame("Button", "BeaconParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['BeaconParty'..x]:SetAttribute("type", "macro")
		buttons['BeaconParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['BeaconParty'..x]:SetAttribute("macrotext", "/cast [@player] Beacon of Light")
		else
			buttons['BeaconParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Beacon of Light")
		end

		buttons['LayOnHandsParty'..x] = CreateFrame("Button", "LayOnHandsParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['LayOnHandsParty'..x]:SetAttribute("type", "macro")
		buttons['LayOnHandsParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['LayOnHandsParty'..x]:SetAttribute("macrotext", "/cast [@player] Lay on Hands")
		else
			buttons['LayOnHandsParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Lay on Hands")
		end

		if x ~= 0 then
			buttons['SacrificeParty'..x] = CreateFrame("Button", "SacrificeParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
			buttons['SacrificeParty'..x]:SetAttribute("type", "macro")
			buttons['SacrificeParty'..x]:RegisterForClicks("AnyDown")
			buttons['SacrificeParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Hand of Sacrifice")

			buttons['TauntParty'..x] = CreateFrame("Button", "TauntParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
			buttons['TauntParty'..x]:SetAttribute("type", "macro")
			buttons['TauntParty'..x]:RegisterForClicks("AnyDown")
			buttons['TauntParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Righteous Defense")
	
		end
	end

	-- Mage
	buttons['CancelManaShield'] = CreateFrame("Button", "CancelManaShield-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelManaShield']:SetAttribute("type", "macro")
	buttons['CancelManaShield']:RegisterForClicks("AnyDown")
	buttons['CancelManaShield']:SetAttribute("macrotext", "/cancelaura Mana Shield")

	buttons['CancelSlowFall'] = CreateFrame("Button", "CancelSlowFall-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelSlowFall']:SetAttribute("type", "macro")
	buttons['CancelSlowFall']:RegisterForClicks("AnyDown")
	buttons['CancelSlowFall']:SetAttribute("macrotext", "/cancelaura Slow Fall")

	buttons['CancelBlock'] = CreateFrame("Button", "CancelBlock-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelBlock']:SetAttribute("type", "macro")
	buttons['CancelBlock']:RegisterForClicks("AnyDown")
	buttons['CancelBlock']:SetAttribute("macrotext", "/cancelaura Ice Block")

	buttons['CancelSacrifice'] = CreateFrame("Button", "CancelSacrifice-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelSacrifice']:SetAttribute("type", "macro")
	buttons['CancelSacrifice']:RegisterForClicks("AnyDown")
	buttons['CancelSacrifice']:SetAttribute("macrotext", "/cancelaura Hand of Sacrifice")

	buttons['FastBlock'] = CreateFrame("Button", "FastBlock-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FastBlock']:SetAttribute("type", "macro")
	buttons['FastBlock']:RegisterForClicks("AnyDown")
	buttons['FastBlock']:SetAttribute("macrotext", "/cast Ice Block\n/cancelaura Ice Block")

	buttons['FocusSheep'] = CreateFrame("Button", "FocusSheep-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusSheep']:SetAttribute("type", "macro")
	buttons['FocusSheep']:RegisterForClicks("AnyDown")
	buttons['FocusSheep']:SetAttribute("macrotext", "/cast [@focus] Polymorph")

	buttons['FocusCS'] = CreateFrame("Button", "FocusCS-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusCS']:SetAttribute("type", "macro")
	buttons['FocusCS']:RegisterForClicks("AnyDown")
	buttons['FocusCS']:SetAttribute("macrotext", "/cast [@focus] Counterspell")

	buttons['FocusLivingBomb'] = CreateFrame("Button", "FocusLivingBomb-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusLivingBomb']:SetAttribute("type", "macro")
	buttons['FocusLivingBomb']:RegisterForClicks("AnyDown")
	buttons['FocusLivingBomb']:SetAttribute("macrotext", "/cast [@focus] Living Bomb")

	buttons['FocusSlow'] = CreateFrame("Button", "FocusSlow-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusSlow']:SetAttribute("type", "macro")
	buttons['FocusSlow']:RegisterForClicks("AnyDown")
	buttons['FocusSlow']:SetAttribute("macrotext", "/cast [@focus] Slow")

	buttons['FocusFrostbolt'] = CreateFrame("Button", "FocusFrostbolt-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusFrostbolt']:SetAttribute("type", "macro")
	buttons['FocusFrostbolt']:RegisterForClicks("AnyDown")
	buttons['FocusFrostbolt']:SetAttribute("macrotext", "/cast [@focus] Frostbolt")
	
	buttons['FocusFireBlast'] = CreateFrame("Button", "FocusFireBlast-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusFireBlast']:SetAttribute("type", "macro")
	buttons['FocusFireBlast']:RegisterForClicks("AnyDown")
	buttons['FocusFireBlast']:SetAttribute("macrotext", "/cast [@focus] FireBlast")

	buttons['FocusIceLance'] = CreateFrame("Button", "FocusIceLance-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusIceLance']:SetAttribute("type", "macro")
	buttons['FocusIceLance']:RegisterForClicks("AnyDown")
	buttons['FocusIceLance']:SetAttribute("macrotext", "/cast [@focus] Ice Lance")
	
	buttons['FocusSpellsteal'] = CreateFrame("Button", "FocusSpellsteal-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusSpellsteal']:SetAttribute("type", "macro")
	buttons['FocusSpellsteal']:RegisterForClicks("AnyDown")
	buttons['FocusSpellsteal']:SetAttribute("macrotext", "/cast [@focus] Spellsteal")

	buttons['MouseoverCS'] = CreateFrame("Button", "MouseoverCS-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverCS']:SetAttribute("type", "macro")
	buttons['MouseoverCS']:RegisterForClicks("AnyDown")
	buttons['MouseoverCS']:SetAttribute("macrotext", "/cast [@mouseover] Counterspell")

	buttons['MouseoverSheep'] = CreateFrame("Button", "MouseoverSheep-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverSheep']:SetAttribute("type", "macro")
	buttons['MouseoverSheep']:RegisterForClicks("AnyDown")
	buttons['MouseoverSheep']:SetAttribute("macrotext", "/cast [@mouseover] Polymorph")

	buttons['MouseoverRemoveCurse'] = CreateFrame("Button", "MouseoverRemoveCurse-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverRemoveCurse']:SetAttribute("type", "macro")
	buttons['MouseoverRemoveCurse']:RegisterForClicks("AnyDown")
	buttons['MouseoverRemoveCurse']:SetAttribute("macrotext", "/cast [@mouseover] Remove Curse")

	buttons['MouseoverFrostbolt'] = CreateFrame("Button", "MouseoverFrostbolt-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverFrostbolt']:SetAttribute("type", "macro")
	buttons['MouseoverFrostbolt']:RegisterForClicks("AnyDown")
	buttons['MouseoverFrostbolt']:SetAttribute("macrotext", "/cast [@mouseover] Frostbolt")

	buttons['PoMSheep'] = CreateFrame("Button", "PoMSheep-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['PoMSheep']:SetAttribute("type", "macro")
	buttons['PoMSheep']:RegisterForClicks("AnyDown")
	buttons['PoMSheep']:SetAttribute("macrotext", "/cast Presence of Mind\n/cast Polymorph")

	buttons['PoMFocusSheep'] = CreateFrame("Button", "PoMFocusSheep-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['PoMFocusSheep']:SetAttribute("type", "macro")
	buttons['PoMFocusSheep']:RegisterForClicks("AnyDown")
	buttons['PoMFocusSheep']:SetAttribute("macrotext", "/cast Presence of Mind\n/cast [@focus] Polymorph")

	buttons['PoMRing'] = CreateFrame("Button", "PoMRing-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['PoMRing']:SetAttribute("type", "macro")
	buttons['PoMRing']:RegisterForClicks("AnyDown")
	buttons['PoMRing']:SetAttribute("macrotext", "/cast Presence of Mind\n/cast Ring of Frost")

	buttons['PoMArcaneBlast'] = CreateFrame("Button", "PoMArcaneBlast-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['PoMArcaneBlast']:SetAttribute("type", "macro")
	buttons['PoMArcaneBlast']:RegisterForClicks("AnyDown")
	buttons['PoMArcaneBlast']:SetAttribute("macrotext", "/cast Presence of Mind\n/cast Arcane Blast")

	buttons['PoMFrostbolt'] = CreateFrame("Button", "PoMFrostbolt-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['PoMFrostbolt']:SetAttribute("type", "macro")
	buttons['PoMFrostbolt']:RegisterForClicks("AnyDown")
	buttons['PoMFrostbolt']:SetAttribute("macrotext", "/cast Presence of Mind\n/cast Frostbolt")

	for i = 1,5 do
		buttons['SheepArena'..i] = CreateFrame("Button", "SheepArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SheepArena'..i]:SetAttribute("type", "macro")
		buttons['SheepArena'..i]:RegisterForClicks("AnyDown")
		buttons['SheepArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Polymorph")

		buttons['CSArena'..i] = CreateFrame("Button", "CSArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['CSArena'..i]:SetAttribute("type", "macro")
		buttons['CSArena'..i]:RegisterForClicks("AnyDown")
		buttons['CSArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Counterspell")

		buttons['SlowArena'..i] = CreateFrame("Button", "SlowArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SlowArena'..i]:SetAttribute("type", "macro")
		buttons['SlowArena'..i]:RegisterForClicks("AnyDown")
		buttons['SlowArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Slow")

		buttons['LivingBombArena'..i] = CreateFrame("Button", "LivingBombArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['LivingBombArena'..i]:SetAttribute("type", "macro")
		buttons['LivingBombArena'..i]:RegisterForClicks("AnyDown")
		buttons['LivingBombArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Living Bomb")

		buttons['FrostboltArena'..i] = CreateFrame("Button", "FrostboltArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['FrostboltArena'..i]:SetAttribute("type", "macro")
		buttons['FrostboltArena'..i]:RegisterForClicks("AnyDown")
		buttons['FrostboltArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Frostbolt")

		buttons['FireBlastArena'..i] = CreateFrame("Button", "FireBlastArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['FireBlastArena'..i]:SetAttribute("type", "macro")
		buttons['FireBlastArena'..i]:RegisterForClicks("AnyDown")
		buttons['FireBlastArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Fire Blast")

		buttons['IceLanceArena'..i] = CreateFrame("Button", "IceLanceArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['IceLanceArena'..i]:SetAttribute("type", "macro")
		buttons['IceLanceArena'..i]:RegisterForClicks("AnyDown")
		buttons['IceLanceArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Ice Lance")

		buttons['SpellstealArena'..i] = CreateFrame("Button", "SpellstealArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SpellstealArena'..i]:SetAttribute("type", "macro")
		buttons['SpellstealArena'..i]:RegisterForClicks("AnyDown")
		buttons['SpellstealArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Spellsteal")
	end

	for i = 1,5 do
		x = i-1

		buttons['RemoveCurseParty'..x] = CreateFrame("Button", "RemoveCurseParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['RemoveCurseParty'..x]:SetAttribute("type", "macro")
		buttons['RemoveCurseParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['RemoveCurseParty'..x]:SetAttribute("macrotext", "/cast [@player] Remove Curse")
		else
			buttons['RemoveCurseParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Remove Curse")
		end
	end

	-- Warlock
	buttons['CancelFelstorm'] = CreateFrame("Button", "CancelFelstorm-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelFelstorm']:SetAttribute("type", "macro")
	buttons['CancelFelstorm']:RegisterForClicks("AnyDown")
	buttons['CancelFelstorm']:SetAttribute("macrotext", "/cancelaura Felstorm")

	buttons['FocusLock'] = CreateFrame("Button", "FocusLock-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusLock']:SetAttribute("type", "macro")
	buttons['FocusLock']:RegisterForClicks("AnyDown")
	buttons['FocusLock']:SetAttribute("macrotext", "/cast [@focus] Spell Lock")

	buttons['FocusDevour'] = CreateFrame("Button", "FocusDevour-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusDevour']:SetAttribute("type", "macro")
	buttons['FocusDevour']:RegisterForClicks("AnyDown")
	buttons['FocusDevour']:SetAttribute("macrotext", "/cast [@focus] Devour Magic")

	buttons['FocusSeduce'] = CreateFrame("Button", "FocusSeduce-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusSeduce']:SetAttribute("type", "macro")
	buttons['FocusSeduce']:RegisterForClicks("AnyDown")
	buttons['FocusSeduce']:SetAttribute("macrotext", "/cast [@focus] Seduction")

	buttons['FocusAxeToss'] = CreateFrame("Button", "FocusAxeToss-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusAxeToss']:SetAttribute("type", "macro")
	buttons['FocusAxeToss']:RegisterForClicks("AnyDown")
	buttons['FocusAxeToss']:SetAttribute("macrotext", "/cast [@focus] Axe Toss")

	buttons['FocusPursuit'] = CreateFrame("Button", "FocusPursuit-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusPursuit']:SetAttribute("type", "macro")
	buttons['FocusPursuit']:RegisterForClicks("AnyDown")
	buttons['FocusPursuit']:SetAttribute("macrotext", "/cast [@focus] Pursuit")

	buttons['FocusUA'] = CreateFrame("Button", "FocusUA-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusUA']:SetAttribute("type", "macro")
	buttons['FocusUA']:RegisterForClicks("AnyDown")
	buttons['FocusUA']:SetAttribute("macrotext", "/cast [@focus] Unstable Affliction")

	buttons['FocusChaosBolt'] = CreateFrame("Button", "FocusChaosBolt-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusChaosBolt']:SetAttribute("type", "macro")
	buttons['FocusChaosBolt']:RegisterForClicks("AnyDown")
	buttons['FocusChaosBolt']:SetAttribute("macrotext", "/cast [@focus] Chaos Bolt")

	buttons['FocusCoil'] = CreateFrame("Button", "FocusCoil-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusCoil']:SetAttribute("type", "macro")
	buttons['FocusCoil']:RegisterForClicks("AnyDown")
	buttons['FocusCoil']:SetAttribute("macrotext", "/cast [@focus] Death Coil")

	buttons['FocusExhaust'] = CreateFrame("Button", "FocusExhaust-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusExhaust']:SetAttribute("type", "macro")
	buttons['FocusExhaust']:RegisterForClicks("AnyDown")
	buttons['FocusExhaust']:SetAttribute("macrotext", "/cast [@focus] Curse of Exhaustion")

	buttons['FocusTongues'] = CreateFrame("Button", "FocusTongues-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusTongues']:SetAttribute("type", "macro")
	buttons['FocusTongues']:RegisterForClicks("AnyDown")
	buttons['FocusTongues']:SetAttribute("macrotext", "/cast [@focus] Curse of Tongues")

	buttons['FocusSoulSwap'] = CreateFrame("Button", "FocusSoulSwap-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusSoulSwap']:SetAttribute("type", "macro")
	buttons['FocusSoulSwap']:RegisterForClicks("AnyDown")
	buttons['FocusSoulSwap']:SetAttribute("macrotext", "/cast [@focus] Soul Swap")

	buttons['FocusShadowburn'] = CreateFrame("Button", "FocusShadowburn-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusShadowburn']:SetAttribute("type", "macro")
	buttons['FocusShadowburn']:RegisterForClicks("AnyDown")
	buttons['FocusShadowburn']:SetAttribute("macrotext", "/cast [@focus] Shadowburn")

	buttons['FocusHavoc'] = CreateFrame("Button", "FocusHavoc-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusHavoc']:SetAttribute("type", "macro")
	buttons['FocusHavoc']:RegisterForClicks("AnyDown")
	buttons['FocusHavoc']:SetAttribute("macrotext", "/cast [@focus] Bane of Havoc")

	buttons['MouseoverFear'] = CreateFrame("Button", "MouseoverFear-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverFear']:SetAttribute("type", "macro")
	buttons['MouseoverFear']:RegisterForClicks("AnyDown")
	buttons['MouseoverFear']:SetAttribute("macrotext", "/cast [@mouseover] Fear")

	buttons['MouseoverLock'] = CreateFrame("Button", "MouseoverLock-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverLock']:SetAttribute("type", "macro")
	buttons['MouseoverLock']:RegisterForClicks("AnyDown")
	buttons['MouseoverLock']:SetAttribute("macrotext", "/cast [@mouseover] Spell Lock")

	buttons['MouseoverDevour'] = CreateFrame("Button", "MouseoverDevour-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverDevour']:SetAttribute("type", "macro")
	buttons['MouseoverDevour']:RegisterForClicks("AnyDown")
	buttons['MouseoverDevour']:SetAttribute("macrotext", "/cast [@mouseover] Devour Magic")

	buttons['MouseoverSeduce'] = CreateFrame("Button", "MouseoverSeduce-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverSeduce']:SetAttribute("type", "macro")
	buttons['MouseoverSeduce']:RegisterForClicks("AnyDown")
	buttons['MouseoverSeduce']:SetAttribute("macrotext", "/cast [@mouseover] Seduction")

	buttons['MouseoverAxeToss'] = CreateFrame("Button", "MouseoverAxeToss-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverAxeToss']:SetAttribute("type", "macro")
	buttons['MouseoverAxeToss']:RegisterForClicks("AnyDown")
	buttons['MouseoverAxeToss']:SetAttribute("macrotext", "/cast [@mouseover] Axe Toss")

	buttons['MouseoverSinge'] = CreateFrame("Button", "MouseoverSinge-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverSinge']:SetAttribute("type", "macro")
	buttons['MouseoverSinge']:RegisterForClicks("AnyDown")
	buttons['MouseoverSinge']:SetAttribute("macrotext", "/cast [@mouseover] Singe Magic")

	buttons['MouseoverExhaust'] = CreateFrame("Button", "MouseoverExhaust-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverExhaust']:SetAttribute("type", "macro")
	buttons['MouseoverExhaust']:RegisterForClicks("AnyDown")
	buttons['MouseoverExhaust']:SetAttribute("macrotext", "/cast [@mouseover] Curse of Exhaustion")

	buttons['MouseoverTongues'] = CreateFrame("Button", "MouseoverTongues-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverTongues']:SetAttribute("type", "macro")
	buttons['MouseoverTongues']:RegisterForClicks("AnyDown")
	buttons['MouseoverTongues']:SetAttribute("macrotext", "/cast [@mouseover] Curse of Tongues")

	buttons['MouseoverHavoc'] = CreateFrame("Button", "MouseoverHavoc-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverHavoc']:SetAttribute("type", "macro")
	buttons['MouseoverHavoc']:RegisterForClicks("AnyDown")
	buttons['MouseoverHavoc']:SetAttribute("macrotext", "/cast [@mouseover] Bane of Havoc")

	for i = 1,5 do
		buttons['FearArena'..i] = CreateFrame("Button", "FearArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['FearArena'..i]:SetAttribute("type", "macro")
		buttons['FearArena'..i]:RegisterForClicks("AnyDown")
		buttons['FearArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Fear")

		buttons['CoilArena'..i] = CreateFrame("Button", "CoilArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['CoilArena'..i]:SetAttribute("type", "macro")
		buttons['CoilArena'..i]:RegisterForClicks("AnyDown")
		buttons['CoilArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Death Coil")

		buttons['LockArena'..i] = CreateFrame("Button", "LockArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['LockArena'..i]:SetAttribute("type", "macro")
		buttons['LockArena'..i]:RegisterForClicks("AnyDown")
		buttons['LockArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Spell Lock")

		buttons['DevourArena'..i] = CreateFrame("Button", "DevourArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['DevourArena'..i]:SetAttribute("type", "macro")
		buttons['DevourArena'..i]:RegisterForClicks("AnyDown")
		buttons['DevourArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Devour Magic")

		buttons['SeduceArena'..i] = CreateFrame("Button", "SeduceArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SeduceArena'..i]:SetAttribute("type", "macro")
		buttons['SeduceArena'..i]:RegisterForClicks("AnyDown")
		buttons['SeduceArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Seduction")

		buttons['AxeTossArena'..i] = CreateFrame("Button", "AxeTossArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['AxeTossArena'..i]:SetAttribute("type", "macro")
		buttons['AxeTossArena'..i]:RegisterForClicks("AnyDown")
		buttons['AxeTossArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Axe Toss")

		buttons['PursuitArena'..i] = CreateFrame("Button", "PursuitArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['PursuitArena'..i]:SetAttribute("type", "macro")
		buttons['PursuitArena'..i]:RegisterForClicks("AnyDown")
		buttons['PursuitArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Pursuit")

		buttons['UAArena'..i] = CreateFrame("Button", "UAArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['UAArena'..i]:SetAttribute("type", "macro")
		buttons['UAArena'..i]:RegisterForClicks("AnyDown")
		buttons['UAArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Unstable Affliction")

		buttons['ExhaustArena'..i] = CreateFrame("Button", "ExhaustArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ExhaustArena'..i]:SetAttribute("type", "macro")
		buttons['ExhaustArena'..i]:RegisterForClicks("AnyDown")
		buttons['ExhaustArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Curse of Exhaustion")

		buttons['TonguesArena'..i] = CreateFrame("Button", "TonguesArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['TonguesArena'..i]:SetAttribute("type", "macro")
		buttons['TonguesArena'..i]:RegisterForClicks("AnyDown")
		buttons['TonguesArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Curse of Tongues")

		buttons['ShadowburnArena'..i] = CreateFrame("Button", "ShadowburnArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ShadowburnArena'..i]:SetAttribute("type", "macro")
		buttons['ShadowburnArena'..i]:RegisterForClicks("AnyDown")
		buttons['ShadowburnArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Shadowburn")

		buttons['ConflagArena'..i] = CreateFrame("Button", "ConflagArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ConflagArena'..i]:SetAttribute("type", "macro")
		buttons['ConflagArena'..i]:RegisterForClicks("AnyDown")
		buttons['ConflagArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Conflagrate")

		buttons['SoulSwapArena'..i] = CreateFrame("Button", "SoulSwapArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SoulSwapArena'..i]:SetAttribute("type", "macro")
		buttons['SoulSwapArena'..i]:RegisterForClicks("AnyDown")
		buttons['SoulSwapArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Soul Swap")

		buttons['HavocArena'..i] = CreateFrame("Button", "HavocArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['HavocArena'..i]:SetAttribute("type", "macro")
		buttons['HavocArena'..i]:RegisterForClicks("AnyDown")
		buttons['HavocArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Bane of Havoc")
	end

	for i = 1,5 do
		x = i-1

		buttons['SingeParty'..x] = CreateFrame("Button", "SingeParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SingeParty'..x]:SetAttribute("type", "macro")
		buttons['SingeParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['SingeParty'..x]:SetAttribute("macrotext", "/cast [@player] Singe Magic")
		else
			buttons['SingeParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Singe Magic")
		end
	end


	-- Warrior
	buttons['CancelStorm'] = CreateFrame("Button", "CancelStorm-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelStorm']:SetAttribute("type", "macro")
	buttons['CancelStorm']:RegisterForClicks("AnyDown")
	buttons['CancelStorm']:SetAttribute("macrotext", "/cancelaura Bladestorm")

	buttons['CancelReckDeathWish'] = CreateFrame("Button", "CancelReck-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelReckDeathWish']:SetAttribute("type", "macro")
	buttons['CancelReckDeathWish']:RegisterForClicks("AnyDown")
	buttons['CancelReckDeathWish']:SetAttribute("macrotext", "/cancelaura Recklessness\n/cancelaura Death Wish")

	buttons['FocusCharge'] = CreateFrame("Button", "FocusCharge-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusCharge']:SetAttribute("type", "macro")
	buttons['FocusCharge']:RegisterForClicks("AnyDown")
	buttons['FocusCharge']:SetAttribute("macrotext", "/cast [nostance:1] Battle Stance\n/cast [@focus] Charge")

	buttons['FocusIntercept'] = CreateFrame("Button", "FocusIntercept-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusIntercept']:SetAttribute("type", "macro")
	buttons['FocusIntercept']:RegisterForClicks("AnyDown")
	buttons['FocusIntercept']:SetAttribute("macrotext", "/cast [nostance:3] Berserker Stance\n/cast [@focus] Intercept")

	buttons['FocusChargeIntercept1'] = CreateFrame("Button", "FocusChargeIntercept1-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusChargeIntercept1']:SetAttribute("type", "macro")
	buttons['FocusChargeIntercept1']:RegisterForClicks("AnyDown")
	buttons['FocusChargeIntercept1']:SetAttribute("macrotext", "/cast [stance:2] Battle Stance\n/cast [stance:1,@focus] Charge\n/cast [@stance:3,@focus] Intercept")

	buttons['FocusChargeIntercept2'] = CreateFrame("Button", "FocusChargeIntercept2-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusChargeIntercept2']:SetAttribute("type", "macro")
	buttons['FocusChargeIntercept2']:RegisterForClicks("AnyDown")
	buttons['FocusChargeIntercept2']:SetAttribute("macrotext", "/cast [stance:2] Berserker Stance\n/cast [stance:1,@focus] Charge\n/cast [@stance:3,@focus] Intercept")

	buttons['FocusPummel'] = CreateFrame("Button", "FocusPummel-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusPummel']:SetAttribute("type", "macro")
	buttons['FocusPummel']:RegisterForClicks("AnyDown")
	buttons['FocusPummel']:SetAttribute("macrotext", "/cast [@focus] Pummel")

	buttons['FocusHamstring1'] = CreateFrame("Button", "FocusHamstring1-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusHamstring1']:SetAttribute("type", "macro")
	buttons['FocusHamstring1']:RegisterForClicks("AnyDown")
	buttons['FocusHamstring1']:SetAttribute("macrotext", "/cast [@stance:2] Battle Stance\n/cast [@focus] Hamstring")

	buttons['FocusHamstring2'] = CreateFrame("Button", "FocusHamstring2-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusHamstring2']:SetAttribute("type", "macro")
	buttons['FocusHamstring2']:RegisterForClicks("AnyDown")
	buttons['FocusHamstring2']:SetAttribute("macrotext", "/cast [@stance:2] Berserker Stance\n/cast [@focus] Hamstring")

	buttons['FocusHeroicThrow'] = CreateFrame("Button", "FocusHeroicThrow-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusHeroicThrow']:SetAttribute("type", "macro")
	buttons['FocusHeroicThrow']:RegisterForClicks("AnyDown")
	buttons['FocusHeroicThrow']:SetAttribute("macrotext", "/cast [@focus] Heroic Throw")

	buttons['FocusIntervene'] = CreateFrame("Button", "FocusIntervene-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusIntervene']:SetAttribute("type", "macro")
	buttons['FocusIntervene']:RegisterForClicks("AnyDown")
	buttons['FocusIntervene']:SetAttribute("macrotext", "/cast [nostance:2] Defensive Stance\n/cast [@focus] Intervene")

	buttons['FocusIntimidatingShout'] = CreateFrame("Button", "FocusIntimidatingShout-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusIntimidatingShout']:SetAttribute("type", "macro")
	buttons['FocusIntimidatingShout']:RegisterForClicks("AnyDown")
	buttons['FocusIntimidatingShout']:SetAttribute("macrotext", "/cast [@focus] Intimidating Shout")

	buttons['FocusThrowdownConcussion'] = CreateFrame("Button", "FocusThrowdownConcussion-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusThrowdownConcussion']:SetAttribute("type", "macro")
	buttons['FocusThrowdownConcussion']:RegisterForClicks("AnyDown")
	buttons['FocusThrowdownConcussion']:SetAttribute("macrotext", "/cast [@focus] Throwdown\n/cast [@focus] Concussion Blow")

	buttons['FocusDisarm'] = CreateFrame("Button", "FocusDisarm-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusDisarm']:SetAttribute("type", "macro")
	buttons['FocusDisarm']:RegisterForClicks("AnyDown")
	buttons['FocusDisarm']:SetAttribute("macrotext", "/cast [nostance:2] Defensive Stance\n/cast [@focus] Disarm")

	buttons['MouseoverCharge'] = CreateFrame("Button", "MouseoverCharge-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverCharge']:SetAttribute("type", "macro")
	buttons['MouseoverCharge']:RegisterForClicks("AnyDown")
	buttons['MouseoverCharge']:SetAttribute("macrotext", "/cast [nostance:1] Battle Stance\n/cast [@mouseover] Charge")

	buttons['MouseoverIntercept'] = CreateFrame("Button", "MouseoverIntercept-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverIntercept']:SetAttribute("type", "macro")
	buttons['MouseoverIntercept']:RegisterForClicks("AnyDown")
	buttons['MouseoverIntercept']:SetAttribute("macrotext", "/cast [nostance:3] Berserker Stance\n/cast [@mouseover] Intercept")

	buttons['MouseoverChargeIntercept1'] = CreateFrame("Button", "MouseoverChargeIntercept1-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverChargeIntercept1']:SetAttribute("type", "macro")
	buttons['MouseoverChargeIntercept1']:RegisterForClicks("AnyDown")
	buttons['MouseoverChargeIntercept1']:SetAttribute("macrotext", "/cast [stance:2] Battle Stance\n/cast [stance:1,@mouseover] Charge\n/cast [stance:3,@mouseover] Intercept")

	buttons['MouseoverChargeIntercept2'] = CreateFrame("Button", "MouseoverChargeIntercept2-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverChargeIntercept2']:SetAttribute("type", "macro")
	buttons['MouseoverChargeIntercept2']:RegisterForClicks("AnyDown")
	buttons['MouseoverChargeIntercept2']:SetAttribute("macrotext", "/cast [stance:2] Berserker Stance\n/cast [stance:1,@mouseover] Charge\n/cast [stance:3,@mouseover] Intercept")

	buttons['MouseoverIntervene'] = CreateFrame("Button", "MouseoverIntervene-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverIntervene']:SetAttribute("type", "macro")
	buttons['MouseoverIntervene']:RegisterForClicks("AnyDown")
	buttons['MouseoverIntervene']:SetAttribute("macrotext", "/cast [nostance:2] Defensive Stance\n/cast [@mouseover] Intervene")

	buttons['MouseoverHeroicThrow'] = CreateFrame("Button", "MouseoverHeroicThrow-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverHeroicThrow']:SetAttribute("type", "macro")
	buttons['MouseoverHeroicThrow']:RegisterForClicks("AnyDown")
	buttons['MouseoverHeroicThrow']:SetAttribute("macrotext", "/cast [@mouseover] Heroic Throw")

	buttons['MouseoverPummel'] = CreateFrame("Button", "MouseoverPummel-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverPummel']:SetAttribute("type", "macro")
	buttons['MouseoverPummel']:RegisterForClicks("AnyDown")
	buttons['MouseoverPummel']:SetAttribute("macrotext", "/cast [@mouseover] Pummel")

	buttons['MouseoverIntimidatingShout'] = CreateFrame("Button", "MouseoverIntimidatingShout-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverIntimidatingShout']:SetAttribute("type", "macro")
	buttons['MouseoverIntimidatingShout']:RegisterForClicks("AnyDown")
	buttons['MouseoverIntimidatingShout']:SetAttribute("macrotext", "/cast [@mouseover] Intimidating Shout")

	buttons['MouseoverThrowdownConcussion'] = CreateFrame("Button", "MouseoverThrowdownConcussion-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverThrowdownConcussion']:SetAttribute("type", "macro")
	buttons['MouseoverThrowdownConcussion']:RegisterForClicks("AnyDown")
	buttons['MouseoverThrowdownConcussion']:SetAttribute("macrotext", "/cast [@mouseover] Throwdown\n/cast [@mouseover] Concussion Blow")

	for i = 1,5 do
		buttons['ChargeArena'..i] = CreateFrame("Button", "ChargeArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ChargeArena'..i]:SetAttribute("type", "macro")
		buttons['ChargeArena'..i]:RegisterForClicks("AnyDown")
		buttons['ChargeArena'..i]:SetAttribute("macrotext", "/cast [nostance:1] Battle Stance\n/cast [@arena"..i.."] Charge")

		buttons['InterceptArena'..i] = CreateFrame("Button", "InterceptArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['InterceptArena'..i]:SetAttribute("type", "macro")
		buttons['InterceptArena'..i]:RegisterForClicks("AnyDown")
		buttons['InterceptArena'..i]:SetAttribute("macrotext", "/cast [nostance:3] Berserker Stance\n/cast [@arena"..i.."] Intercept")

		buttons['ChargeIntercept1Arena'..i] = CreateFrame("Button", "ChargeIntercept1Arena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ChargeIntercept1Arena'..i]:SetAttribute("type", "macro")
		buttons['ChargeIntercept1Arena'..i]:RegisterForClicks("AnyDown")
		buttons['ChargeIntercept1Arena'..i]:SetAttribute("macrotext", "/cast [stance:2] Battle Stance\n/cast [stance:1,@arena"..i.."] Charge\n/cast [stance:3,@arena"..i.."] Intercept")

		buttons['ChargeIntercept2Arena'..i] = CreateFrame("Button", "ChargeIntercept2Arena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ChargeIntercept2Arena'..i]:SetAttribute("type", "macro")
		buttons['ChargeIntercept2Arena'..i]:RegisterForClicks("AnyDown")
		buttons['ChargeIntercept2Arena'..i]:SetAttribute("macrotext", "/cast [stance:2] Berserker Stance\n/cast [stance:1,@arena"..i.."] Charge\n/cast [stance:3,@arena"..i.."] Intercept")

		buttons['Hamstring1Arena'..i] = CreateFrame("Button", "Hamstring1Arena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['Hamstring1Arena'..i]:SetAttribute("type", "macro")
		buttons['Hamstring1Arena'..i]:RegisterForClicks("AnyDown")
		buttons['Hamstring1Arena'..i]:SetAttribute("macrotext", "/cast [stance:2] Battle Stance\n/cast [@arena"..i.."] Hamstring")

		buttons['Hamstring2Arena'..i] = CreateFrame("Button", "Hamstring2Arena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['Hamstring2Arena'..i]:SetAttribute("type", "macro")
		buttons['Hamstring2Arena'..i]:RegisterForClicks("AnyDown")
		buttons['Hamstring2Arena'..i]:SetAttribute("macrotext", "/cast [stance:2] Berserker Stance\n/cast [@arena"..i.."] Hamstring")

		buttons['HeroicThrowArena'..i] = CreateFrame("Button", "HeroicThrowArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['HeroicThrowArena'..i]:SetAttribute("type", "macro")
		buttons['HeroicThrowArena'..i]:RegisterForClicks("AnyDown")
		buttons['HeroicThrowArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Heroic Throw")

		buttons['PummelArena'..i] = CreateFrame("Button", "PummelArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['PummelArena'..i]:SetAttribute("type", "macro")
		buttons['PummelArena'..i]:RegisterForClicks("AnyDown")
		buttons['PummelArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Pummel")

		buttons['DisarmArena'..i] = CreateFrame("Button", "DisarmArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['DisarmArena'..i]:SetAttribute("type", "macro")
		buttons['DisarmArena'..i]:RegisterForClicks("AnyDown")
		buttons['DisarmArena'..i]:SetAttribute("macrotext", "/cast [nostance:2] Defensive Stance\n/cast [@arena"..i.."] Disarm")

		buttons['ThrowdownConcussionArena'..i] = CreateFrame("Button", "ThrowdownConcussionArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ThrowdownConcussionArena'..i]:SetAttribute("type", "macro")
		buttons['ThrowdownConcussionArena'..i]:RegisterForClicks("AnyDown")
		buttons['ThrowdownConcussionArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Throwdown\n/cast [@arena"..i.."] Concussion Blow")

		buttons['IntimidatingShoutArena'..i] = CreateFrame("Button", "IntimidatingShoutArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['IntimidatingShoutArena'..i]:SetAttribute("type", "macro")
		buttons['IntimidatingShoutArena'..i]:RegisterForClicks("AnyDown")
		buttons['IntimidatingShoutArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Intimidating Shout")
	end

	for i = 1,5 do
		x = i-1

		if x ~= 0 then
			buttons['InterveneParty'..x] = CreateFrame("Button", "InterveneParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
			buttons['InterveneParty'..x]:SetAttribute("type", "macro")
			buttons['InterveneParty'..x]:RegisterForClicks("AnyDown")
			buttons['InterveneParty'..x]:SetAttribute("macrotext", "/cast [nostance:2] Defensive Stance\n/cast [@party"..x.."] Intervene")
		end
	end

	-- Death Knight
	buttons['PetAttackClaw'] = CreateFrame("Button", "PetAttackClaw-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['PetAttackClaw']:SetAttribute("type", "macro")
	buttons['PetAttackClaw']:RegisterForClicks("AnyDown")
	buttons['PetAttackClaw']:SetAttribute("macrotext", "/petattack\n/cast Claw")
	
	buttons['FocusPetAttackClaw'] = CreateFrame("Button", "FocusPetAttackClaw-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusPetAttackClaw']:SetAttribute("type", "macro")
	buttons['FocusPetAttackClaw']:RegisterForClicks("AnyDown")
	buttons['FocusPetAttackClaw']:SetAttribute("macrotext", "/petattack [@focus]\n/cast [@focus] Claw")

	buttons['CancelLichborne'] = CreateFrame("Button", "CancelLichborne-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelLichborne']:SetAttribute("type", "macro")
	buttons['CancelLichborne']:RegisterForClicks("AnyDown")
	buttons['CancelLichborne']:SetAttribute("macrotext", "/cancelaura Lichborne")

	buttons['CancelUnholyFrenzy'] = CreateFrame("Button", "CancelUnholyFrenzy-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelUnholyFrenzy']:SetAttribute("type", "macro")
	buttons['CancelUnholyFrenzy']:RegisterForClicks("AnyDown")
	buttons['CancelUnholyFrenzy']:SetAttribute("macrotext", "/cancelaura Unholy Frenzy")

	buttons['LichbornHeal'] = CreateFrame("Button", "LichbornHeal-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['LichbornHeal']:SetAttribute("type", "macro")
	buttons['LichbornHeal']:RegisterForClicks("AnyDown")
	buttons['LichbornHeal']:SetAttribute("macrotext", "/cast Lichborne\n/cast [@player] Death Coil")

	buttons['GhoulHeal'] = CreateFrame("Button", "GhoulHeal-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['GhoulHeal']:SetAttribute("type", "macro")
	buttons['GhoulHeal']:RegisterForClicks("AnyDown")
	buttons['GhoulHeal']:SetAttribute("macrotext", "/cast [@pet] Death Coil")

	buttons['RaiseDeadDeathPact'] = CreateFrame("Button", "RaiseDeadDeathPact-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['RaiseDeadDeathPact']:SetAttribute("type", "macro")
	buttons['RaiseDeadDeathPact']:RegisterForClicks("AnyDown")
	buttons['RaiseDeadDeathPact']:SetAttribute("macrotext", "/cast Raise Dead\n/cast Death Pact")

	buttons['UnholyFrenzyGargoyle'] = CreateFrame("Button", "UnholyFrenzyGargoyle-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['UnholyFrenzyGargoyle']:SetAttribute("type", "macro")
	buttons['UnholyFrenzyGargoyle']:RegisterForClicks("AnyDown")
	buttons['UnholyFrenzyGargoyle']:SetAttribute("macrotext", "/cast [@Ebon Gargoyle,noharm,exist] Unholy Frenzy")

	buttons['UnholyFrenzyGhoul'] = CreateFrame("Button", "UnholyFrenzyGhoul-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['UnholyFrenzyGhoul']:SetAttribute("type", "macro")
	buttons['UnholyFrenzyGhoul']:RegisterForClicks("AnyDown")
	buttons['UnholyFrenzyGhoul']:SetAttribute("macrotext", "/cast [@pet,noharm,exist] Unholy Frenzy")

	buttons['FocusDeathGrip'] = CreateFrame("Button", "FocusDeathGrip-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusDeathGrip']:SetAttribute("type", "macro")
	buttons['FocusDeathGrip']:RegisterForClicks("AnyDown")
	buttons['FocusDeathGrip']:SetAttribute("macrotext", "/cast [@focus] Death Grip")

	buttons['FocusMindFreeze'] = CreateFrame("Button", "FocusMindFreeze-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusMindFreeze']:SetAttribute("type", "macro")
	buttons['FocusMindFreeze']:RegisterForClicks("AnyDown")
	buttons['FocusMindFreeze']:SetAttribute("macrotext", "/cast [@focus] Mind Freeze")

	buttons['FocusStrangulate'] = CreateFrame("Button", "FocusStrangulate-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusStrangulate']:SetAttribute("type", "macro")
	buttons['FocusStrangulate']:RegisterForClicks("AnyDown")
	buttons['FocusStrangulate']:SetAttribute("macrotext", "/cast [@focus] Strangulate")

	buttons['FocusDarkSim'] = CreateFrame("Button", "FocusDarkSim-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusDarkSim']:SetAttribute("type", "macro")
	buttons['FocusDarkSim']:RegisterForClicks("AnyDown")
	buttons['FocusDarkSim']:SetAttribute("macrotext", "/cast [@focus] Dark Simulacrum")

	buttons['FocusGnawPet'] = CreateFrame("Button", "FocusGnawPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusGnawPet']:SetAttribute("type", "macro")
	buttons['FocusGnawPet']:RegisterForClicks("AnyDown")
	buttons['FocusGnawPet']:SetAttribute("macrotext", "/cast [@focus] Gnaw")

	buttons['FocusLeapPet'] = CreateFrame("Button", "FocusLeapPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusLeapPet']:SetAttribute("type", "macro")
	buttons['FocusLeapPet']:RegisterForClicks("AnyDown")
	buttons['FocusLeapPet']:SetAttribute("macrotext", "/cast [@focus] Leap")

	buttons['FocusLeapGnawPet'] = CreateFrame("Button", "FocusLeapGnawPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusLeapGnawPet']:SetAttribute("type", "macro")
	buttons['FocusLeapGnawPet']:RegisterForClicks("AnyDown")
	buttons['FocusLeapGnawPet']:SetAttribute("macrotext", "/cast [@focus] Leap\n/cast [@focus] Gnaw")

	buttons['MouseoverDeathGrip'] = CreateFrame("Button", "MouseoverDeathGrip-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverDeathGrip']:SetAttribute("type", "macro")
	buttons['MouseoverDeathGrip']:RegisterForClicks("AnyDown")
	buttons['MouseoverDeathGrip']:SetAttribute("macrotext", "/cast [@mouseover] Death Grip")

	buttons['MouseoverMindFreeze'] = CreateFrame("Button", "MouseoverMindFreeze-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverMindFreeze']:SetAttribute("type", "macro")
	buttons['MouseoverMindFreeze']:RegisterForClicks("AnyDown")
	buttons['MouseoverMindFreeze']:SetAttribute("macrotext", "/cast [@mouseover] Mind Freeze")

	buttons['MouseoverChainsOfIce'] = CreateFrame("Button", "MouseoverChainsOfIce-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverChainsOfIce']:SetAttribute("type", "macro")
	buttons['MouseoverChainsOfIce']:RegisterForClicks("AnyDown")
	buttons['MouseoverChainsOfIce']:SetAttribute("macrotext", "/cast [@mouseover] Chains of Ice")

	buttons['MouseoverStrangulate'] = CreateFrame("Button", "MouseoverStrangulate-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverStrangulate']:SetAttribute("type", "macro")
	buttons['MouseoverStrangulate']:RegisterForClicks("AnyDown")
	buttons['MouseoverStrangulate']:SetAttribute("macrotext", "/cast [@mouseover] Strangulate")

	buttons['MouseoverDarkSim'] = CreateFrame("Button", "MouseoverDarkSim-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverDarkSim']:SetAttribute("type", "macro")
	buttons['MouseoverDarkSim']:RegisterForClicks("AnyDown")
	buttons['MouseoverDarkSim']:SetAttribute("macrotext", "/cast [@mouseover] Dark Simulacrum")

	buttons['MouseoverUnholyFrenzy'] = CreateFrame("Button", "MouseoverUnholyFrenzy-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverUnholyFrenzy']:SetAttribute("type", "macro")
	buttons['MouseoverUnholyFrenzy']:RegisterForClicks("AnyDown")
	buttons['MouseoverUnholyFrenzy']:SetAttribute("macrotext", "/cast [@mouseover,noharm,exist] Unholy Frenzy")

	buttons['MouseoverGnawPet'] = CreateFrame("Button", "MouseoverGnawPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverGnawPet']:SetAttribute("type", "macro")
	buttons['MouseoverGnawPet']:RegisterForClicks("AnyDown")
	buttons['MouseoverGnawPet']:SetAttribute("macrotext", "/cast [@mouseover] Gnaw")

	buttons['MouseoverLeapPet'] = CreateFrame("Button", "MouseoverLeapPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverLeapPet']:SetAttribute("type", "macro")
	buttons['MouseoverLeapPet']:RegisterForClicks("AnyDown")
	buttons['MouseoverLeapPet']:SetAttribute("macrotext", "/cast [@mouseover] Leap")

	buttons['MouseoverLeapGnawPet'] = CreateFrame("Button", "MouseoverLeapGnawPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverLeapGnawPet']:SetAttribute("type", "macro")
	buttons['MouseoverLeapGnawPet']:RegisterForClicks("AnyDown")
	buttons['MouseoverLeapGnawPet']:SetAttribute("macrotext", "/cast [@mouseover] Leap\n/cast [@mouseover] Gnaw")

	for i = 1,5 do
		buttons['DeathGripArena'..i] = CreateFrame("Button", "DeathGripArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['DeathGripArena'..i]:SetAttribute("type", "macro")
		buttons['DeathGripArena'..i]:RegisterForClicks("AnyDown")
		buttons['DeathGripArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Death Grip")

		buttons['MindFreezeArena'..i] = CreateFrame("Button", "MindFreezeArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['MindFreezeArena'..i]:SetAttribute("type", "macro")
		buttons['MindFreezeArena'..i]:RegisterForClicks("AnyDown")
		buttons['MindFreezeArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Mind Freeze")

		buttons['ChainsOfIceArena'..i] = CreateFrame("Button", "ChainsOfIceArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ChainsOfIceArena'..i]:SetAttribute("type", "macro")
		buttons['ChainsOfIceArena'..i]:RegisterForClicks("AnyDown")
		buttons['ChainsOfIceArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Chains of Ice")

		buttons['StrangulateArena'..i] = CreateFrame("Button", "StrangulateArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['StrangulateArena'..i]:SetAttribute("type", "macro")
		buttons['StrangulateArena'..i]:RegisterForClicks("AnyDown")
		buttons['StrangulateArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Strangulate")

		buttons['DarkSimArena'..i] = CreateFrame("Button", "DarkSimArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['DarkSimArena'..i]:SetAttribute("type", "macro")
		buttons['DarkSimArena'..i]:RegisterForClicks("AnyDown")
		buttons['DarkSimArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Dark Simulacrum")

		buttons['GnawPetArena'..i] = CreateFrame("Button", "GnawPetArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['GnawPetArena'..i]:SetAttribute("type", "macro")
		buttons['GnawPetArena'..i]:RegisterForClicks("AnyDown")
		buttons['GnawPetArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Gnaw")

		buttons['LeapPetArena'..i] = CreateFrame("Button", "LeapPetArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['LeapPetArena'..i]:SetAttribute("type", "macro")
		buttons['LeapPetArena'..i]:RegisterForClicks("AnyDown")
		buttons['LeapPetArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Leap")

		buttons['LeapGnawPetArena'..i] = CreateFrame("Button", "LeapGnawPetArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['LeapGnawPetArena'..i]:SetAttribute("type", "macro")
		buttons['LeapGnawPetArena'..i]:RegisterForClicks("AnyDown")
		buttons['LeapGnawPetArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Leap\n/cast [@arena"..i.."] Gnaw")
	end

	for i = 1,5 do
		x = i-1

		buttons['UnholyFrenzyParty'..x] = CreateFrame("Button", "UnholyFrenzyParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['UnholyFrenzyParty'..x]:SetAttribute("type", "macro")
		buttons['UnholyFrenzyParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['UnholyFrenzyParty'..x]:SetAttribute("macrotext", "/cast [@player] Unholy Frenzy")
		else
			buttons['UnholyFrenzyParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Unholy Frenzy")
		end
	end


	-- Rogue
	buttons['CripplingPoisonMain'] = CreateFrame("Button", "CripplingPoisonMain-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CripplingPoisonMain']:SetAttribute("type", "macro")
	buttons['CripplingPoisonMain']:RegisterForClicks("AnyDown")
	buttons['CripplingPoisonMain']:SetAttribute("macrotext", "/cast Crippling Poison\n/use [btn:1] 16\n/click StaticPopup1Button1")

	buttons['CripplingPoisonOff'] = CreateFrame("Button", "CripplingPoisonOff-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CripplingPoisonOff']:SetAttribute("type", "macro")
	buttons['CripplingPoisonOff']:RegisterForClicks("AnyDown")
	buttons['CripplingPoisonOff']:SetAttribute("macrotext", "/cast Crippling Poison\n/use [btn:1] 17\n/click StaticPopup1Button1")

	buttons['WoundPoisonMain'] = CreateFrame("Button", "WoundPoisonMain-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['WoundPoisonMain']:SetAttribute("type", "macro")
	buttons['WoundPoisonMain']:RegisterForClicks("AnyDown")
	buttons['WoundPoisonMain']:SetAttribute("macrotext", "/cast Wound Poison\n/use [btn:1] 16\n/click StaticPopup1Button1")

	buttons['WoundPoisonOff'] = CreateFrame("Button", "WoundPoisonOff-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['WoundPoisonOff']:SetAttribute("type", "macro")
	buttons['WoundPoisonOff']:RegisterForClicks("AnyDown")
	buttons['WoundPoisonOff']:SetAttribute("macrotext", "/cast Wound Poison\n/use [btn:1] 17\n/click StaticPopup1Button1")

	buttons['MindNumbingPoisonMain'] = CreateFrame("Button", "MindNumbingPoisonMain-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MindNumbingPoisonMain']:SetAttribute("type", "macro")
	buttons['MindNumbingPoisonMain']:RegisterForClicks("AnyDown")
	buttons['MindNumbingPoisonMain']:SetAttribute("macrotext", "/cast MindNumbing Poison\n/use [btn:1] 16\n/click StaticPopup1Button1")

	buttons['MindNumbingPoisonOff'] = CreateFrame("Button", "MindNumbingPoisonOff-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MindNumbingPoisonOff']:SetAttribute("type", "macro")
	buttons['MindNumbingPoisonOff']:RegisterForClicks("AnyDown")
	buttons['MindNumbingPoisonOff']:SetAttribute("macrotext", "/cast Mind-Numbing Poison\n/use [btn:1] 17\n/click StaticPopup1Button1")

	buttons['DeadlyPoisonMain'] = CreateFrame("Button", "DeadlyPoisonMain-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['DeadlyPoisonMain']:SetAttribute("type", "macro")
	buttons['DeadlyPoisonMain']:RegisterForClicks("AnyDown")
	buttons['DeadlyPoisonMain']:SetAttribute("macrotext", "/cast Deadly Poison\n/use [btn:1] 16\n/click StaticPopup1Button1")

	buttons['DeadlyPoisonOff'] = CreateFrame("Button", "DeadlyPoisonOff-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['DeadlyPoisonOff']:SetAttribute("type", "macro")
	buttons['DeadlyPoisonOff']:RegisterForClicks("AnyDown")
	buttons['DeadlyPoisonOff']:SetAttribute("macrotext", "/cast Deadly Poison\n/use [btn:1] 17\n/click StaticPopup1Button1")

	buttons['InstantPoisonMain'] = CreateFrame("Button", "InstantPoisonMain-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['InstantPoisonMain']:SetAttribute("type", "macro")
	buttons['InstantPoisonMain']:RegisterForClicks("AnyDown")
	buttons['InstantPoisonMain']:SetAttribute("macrotext", "/cast Instant Poison\n/use [btn:1] 16\n/click StaticPopup1Button1")

	buttons['InstantPoisonOff'] = CreateFrame("Button", "InstantPoisonOff-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['InstantPoisonOff']:SetAttribute("type", "macro")
	buttons['InstantPoisonOff']:RegisterForClicks("AnyDown")
	buttons['InstantPoisonOff']:SetAttribute("macrotext", "/cast Instant Poison\n/use [btn:1] 17\n/click StaticPopup1Button1")

	buttons['PremedRecup'] = CreateFrame("Button", "PremedRecup-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['PremedRecup']:SetAttribute("type", "macro")
	buttons['PremedRecup']:RegisterForClicks("AnyDown")
	buttons['PremedRecup']:SetAttribute("macrotext", "/cast Premeditation\n/cast Recuperate")

	buttons['PremedSlice'] = CreateFrame("Button", "PremedSlice-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['PremedSlice']:SetAttribute("type", "macro")
	buttons['PremedSlice']:RegisterForClicks("AnyDown")
	buttons['PremedSlice']:SetAttribute("macrotext", "/cast Premeditation\n/cast Slice and Dice")

	buttons['RedirectKidney'] = CreateFrame("Button", "RedirectKidney-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['RedirectKidney']:SetAttribute("type", "macro")
	buttons['RedirectKidney']:RegisterForClicks("AnyDown")
	buttons['RedirectKidney']:SetAttribute("macrotext", "/cast Redirect\n/cast Kidney Shot")

	buttons['FocusSap'] = CreateFrame("Button", "FocusSap-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusSap']:SetAttribute("type", "macro")
	buttons['FocusSap']:RegisterForClicks("AnyDown")
	buttons['FocusSap']:SetAttribute("macrotext", "/cast [@focus] Sap")

	buttons['FocusBlind'] = CreateFrame("Button", "FocusBlind-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusBlind']:SetAttribute("type", "macro")
	buttons['FocusBlind']:RegisterForClicks("AnyDown")
	buttons['FocusBlind']:SetAttribute("macrotext", "/cast [@focus] Blind")

	buttons['FocusKick'] = CreateFrame("Button", "FocusKick-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusKick']:SetAttribute("type", "macro")
	buttons['FocusKick']:RegisterForClicks("AnyDown")
	buttons['FocusKick']:SetAttribute("macrotext", "/cast [@focus] Kick")

	buttons['FocusDeadlyThrow'] = CreateFrame("Button", "FocusDeadlyThrow-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusDeadlyThrow']:SetAttribute("type", "macro")
	buttons['FocusDeadlyThrow']:RegisterForClicks("AnyDown")
	buttons['FocusDeadlyThrow']:SetAttribute("macrotext", "/cast [@focus] Deadly Throw")

	buttons['FocusCheapShot'] = CreateFrame("Button", "FocusCheapShot-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusCheapShot']:SetAttribute("type", "macro")
	buttons['FocusCheapShot']:RegisterForClicks("AnyDown")
	buttons['FocusCheapShot']:SetAttribute("macrotext", "/cast [@focus] Cheap Shot")

	buttons['FocusGarrote'] = CreateFrame("Button", "FocusGarrote-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusGarrote']:SetAttribute("type", "macro")
	buttons['FocusGarrote']:RegisterForClicks("AnyDown")
	buttons['FocusGarrote']:SetAttribute("macrotext", "/cast [@focus] Garrote")

	buttons['FocusKidney'] = CreateFrame("Button", "FocusKidney-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusKidney']:SetAttribute("type", "macro")
	buttons['FocusKidney']:RegisterForClicks("AnyDown")
	buttons['FocusKidney']:SetAttribute("macrotext", "/cast [@focus] Kidney Shot")

	buttons['FocusGouge'] = CreateFrame("Button", "FocusGouge-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusGouge']:SetAttribute("type", "macro")
	buttons['FocusGouge']:RegisterForClicks("AnyDown")
	buttons['FocusGouge']:SetAttribute("macrotext", "/cast [@focus] Gouge")

	buttons['FocusShiv'] = CreateFrame("Button", "FocusShiv-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusShiv']:SetAttribute("type", "macro")
	buttons['FocusShiv']:RegisterForClicks("AnyDown")
	buttons['FocusShiv']:SetAttribute("macrotext", "/cast [@focus] Shiv")

	buttons['FocusPremed'] = CreateFrame("Button", "FocusPremed-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusPremed']:SetAttribute("type", "macro")
	buttons['FocusPremed']:RegisterForClicks("AnyDown")
	buttons['FocusPremed']:SetAttribute("macrotext", "/cast [@focus] Premeditation")

	buttons['FocusPremedRecup'] = CreateFrame("Button", "FocusPremedRecup-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusPremedRecup']:SetAttribute("type", "macro")
	buttons['FocusPremedRecup']:RegisterForClicks("AnyDown")
	buttons['FocusPremedRecup']:SetAttribute("macrotext", "/cast [@focus] Premeditation\n/cast Recuperate")

	buttons['FocusPremedSlice'] = CreateFrame("Button", "FocusPremedSlice-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusPremedSlice']:SetAttribute("type", "macro")
	buttons['FocusPremedSlice']:RegisterForClicks("AnyDown")
	buttons['FocusPremedSlice']:SetAttribute("macrotext", "/cast [@focus] Premeditation\n/cast Slice and Dice")

	buttons['FocusRedirect'] = CreateFrame("Button", "FocusRedirect-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusRedirect']:SetAttribute("type", "macro")
	buttons['FocusRedirect']:RegisterForClicks("AnyDown")
	buttons['FocusRedirect']:SetAttribute("macrotext", "/cast [@focus] Redirect")

	buttons['FocusRedirectKidney'] = CreateFrame("Button", "FocusRedirectKidney-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusRedirectKidney']:SetAttribute("type", "macro")
	buttons['FocusRedirectKidney']:RegisterForClicks("AnyDown")
	buttons['FocusRedirectKidney']:SetAttribute("macrotext", "/cast [@focus] Redirect\n/cast [@focus] Kidney Shot")

	buttons['FocusShadowstep'] = CreateFrame("Button", "FocusShadowstep-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusShadowstep']:SetAttribute("type", "macro")
	buttons['FocusShadowstep']:RegisterForClicks("AnyDown")
	buttons['FocusShadowstep']:SetAttribute("macrotext", "/cast [@focus] Shadowstep")
	
	buttons['FocusShadowstepKick'] = CreateFrame("Button", "FocusShadowstepKick-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusShadowstepKick']:SetAttribute("type", "macro")
	buttons['FocusShadowstepKick']:RegisterForClicks("AnyDown")
	buttons['FocusShadowstepKick']:SetAttribute("macrotext", "/cast [@focus] Shadowstep\n/cast [@focus] Kick")

	buttons['FocusShadowstepKidney'] = CreateFrame("Button", "FocusShadowstepKidney-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusShadowstepKidney']:SetAttribute("type", "macro")
	buttons['FocusShadowstepKidney']:RegisterForClicks("AnyDown")
	buttons['FocusShadowstepKidney']:SetAttribute("macrotext", "/cast [@focus] Shadowstep\n/cast [@focus] Kidney Shot")

	buttons['FocusDismantle'] = CreateFrame("Button", "FocusDismantle-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusDismantle']:SetAttribute("type", "macro")
	buttons['FocusDismantle']:RegisterForClicks("AnyDown")
	buttons['FocusDismantle']:SetAttribute("macrotext", "/cast [@focus] Dismantle")

	buttons['MouseoverTricks'] = CreateFrame("Button", "MouseoverTricks-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverTricks']:SetAttribute("type", "macro")
	buttons['MouseoverTricks']:RegisterForClicks("AnyDown")
	buttons['MouseoverTricks']:SetAttribute("macrotext", "/cast [@mouseover] Tricks of the Trade")

	buttons['MouseoverSap'] = CreateFrame("Button", "MouseoverSap-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverSap']:SetAttribute("type", "macro")
	buttons['MouseoverSap']:RegisterForClicks("AnyDown")
	buttons['MouseoverSap']:SetAttribute("macrotext", "/cast [@mouseover] Sap")

	buttons['MouseoverBlind'] = CreateFrame("Button", "MouseoverBlind-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverBlind']:SetAttribute("type", "macro")
	buttons['MouseoverBlind']:RegisterForClicks("AnyDown")
	buttons['MouseoverBlind']:SetAttribute("macrotext", "/cast [@mouseover] Blind")

	buttons['MouseoverKick'] = CreateFrame("Button", "MouseoverKick-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverKick']:SetAttribute("type", "macro")
	buttons['MouseoverKick']:RegisterForClicks("AnyDown")
	buttons['MouseoverKick']:SetAttribute("macrotext", "/cast [@mouseover] Kick")

	buttons['MouseoverDeadlyThrow'] = CreateFrame("Button", "MouseoverDeadlyThrow-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverDeadlyThrow']:SetAttribute("type", "macro")
	buttons['MouseoverDeadlyThrow']:RegisterForClicks("AnyDown")
	buttons['MouseoverDeadlyThrow']:SetAttribute("macrotext", "/cast [@mouseover] Deadly Throw")

	buttons['MouseoverGouge'] = CreateFrame("Button", "MouseoverGouge-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverGouge']:SetAttribute("type", "macro")
	buttons['MouseoverGouge']:RegisterForClicks("AnyDown")
	buttons['MouseoverGouge']:SetAttribute("macrotext", "/cast [@mouseover] Gouge")

	buttons['MouseoverShadowstep'] = CreateFrame("Button", "MouseoverShadowstep-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverShadowstep']:SetAttribute("type", "macro")
	buttons['MouseoverShadowstep']:RegisterForClicks("AnyDown")
	buttons['MouseoverShadowstep']:SetAttribute("macrotext", "/cast [@mouseover] Shadowstep")

	buttons['MouseoverShadowstepKick'] = CreateFrame("Button", "MouseoverShadowstepKick-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverShadowstepKick']:SetAttribute("type", "macro")
	buttons['MouseoverShadowstepKick']:RegisterForClicks("AnyDown")
	buttons['MouseoverShadowstepKick']:SetAttribute("macrotext", "/cast [@mouseover] Shadowstep\n/cast [@mouseover] Kick")

	buttons['MouseoverShadowstepKidney'] = CreateFrame("Button", "MouseoverShadowstepKidney-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverShadowstepKidney']:SetAttribute("type", "macro")
	buttons['MouseoverShadowstepKidney']:RegisterForClicks("AnyDown")
	buttons['MouseoverShadowstepKidney']:SetAttribute("macrotext", "/cast [@mouseover] Shadowstep\n/cast [@mouseover] Kidney Shot")
	
	buttons['MouseoverShiv'] = CreateFrame("Button", "MouseoverShiv-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverShiv']:SetAttribute("type", "macro")
	buttons['MouseoverShiv']:RegisterForClicks("AnyDown")
	buttons['MouseoverShiv']:SetAttribute("macrotext", "/cast [@mouseover] Shiv")

	for i = 1,5 do
		buttons['SapArena'..i] = CreateFrame("Button", "SapArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SapArena'..i]:SetAttribute("type", "macro")
		buttons['SapArena'..i]:RegisterForClicks("AnyDown")
		buttons['SapArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Sap")

		buttons['BlindArena'..i] = CreateFrame("Button", "BlindArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['BlindArena'..i]:SetAttribute("type", "macro")
		buttons['BlindArena'..i]:RegisterForClicks("AnyDown")
		buttons['BlindArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Blind")

		buttons['KickArena'..i] = CreateFrame("Button", "KickArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['KickArena'..i]:SetAttribute("type", "macro")
		buttons['KickArena'..i]:RegisterForClicks("AnyDown")
		buttons['KickArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Kick")

		buttons['DeadlyThrowArena'..i] = CreateFrame("Button", "DeadlyThrowArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['DeadlyThrowArena'..i]:SetAttribute("type", "macro")
		buttons['DeadlyThrowArena'..i]:RegisterForClicks("AnyDown")
		buttons['DeadlyThrowArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Deadly Throw")

		buttons['CheapShotArena'..i] = CreateFrame("Button", "CheapShotArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['CheapShotArena'..i]:SetAttribute("type", "macro")
		buttons['CheapShotArena'..i]:RegisterForClicks("AnyDown")
		buttons['CheapShotArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Cheap Shot")

		buttons['GarroteArena'..i] = CreateFrame("Button", "GarroteArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['GarroteArena'..i]:SetAttribute("type", "macro")
		buttons['GarroteArena'..i]:RegisterForClicks("AnyDown")
		buttons['GarroteArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Garrote")

		buttons['KidneyArena'..i] = CreateFrame("Button", "KidneyArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['KidneyArena'..i]:SetAttribute("type", "macro")
		buttons['KidneyArena'..i]:RegisterForClicks("AnyDown")
		buttons['KidneyArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Kidney Shot")

		buttons['GougeArena'..i] = CreateFrame("Button", "GougeArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['GougeArena'..i]:SetAttribute("type", "macro")
		buttons['GougeArena'..i]:RegisterForClicks("AnyDown")
		buttons['GougeArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Gouge")

		buttons['ShivArena'..i] = CreateFrame("Button", "ShivArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ShivArena'..i]:SetAttribute("type", "macro")
		buttons['ShivArena'..i]:RegisterForClicks("AnyDown")
		buttons['ShivArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Shiv")

		buttons['PremedArena'..i] = CreateFrame("Button", "PremedArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['PremedArena'..i]:SetAttribute("type", "macro")
		buttons['PremedArena'..i]:RegisterForClicks("AnyDown")
		buttons['PremedArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Premeditation")

		buttons['PremedRecupArena'..i] = CreateFrame("Button", "PremedRecupArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['PremedRecupArena'..i]:SetAttribute("type", "macro")
		buttons['PremedRecupArena'..i]:RegisterForClicks("AnyDown")
		buttons['PremedRecupArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Premeditation\n/cast [@arena"..i.."] Recuperate")

		buttons['PremedSliceArena'..i] = CreateFrame("Button", "PremedSliceArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['PremedSliceArena'..i]:SetAttribute("type", "macro")
		buttons['PremedSliceArena'..i]:RegisterForClicks("AnyDown")
		buttons['PremedSliceArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Premeditation\n/cast [@arena"..i.."] Slice and Dice")

		buttons['RedirectArena'..i] = CreateFrame("Button", "RedirectArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['RedirectArena'..i]:SetAttribute("type", "macro")
		buttons['RedirectArena'..i]:RegisterForClicks("AnyDown")
		buttons['RedirectArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Redirect")

		buttons['RedirectKidneyArena'..i] = CreateFrame("Button", "RedirectKidneyArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['RedirectKidneyArena'..i]:SetAttribute("type", "macro")
		buttons['RedirectKidneyArena'..i]:RegisterForClicks("AnyDown")
		buttons['RedirectKidneyArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Redirect\n/cast [@arena"..i.."] Kidney Shot")

		buttons['ShadowstepArena'..i] = CreateFrame("Button", "ShadowstepArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ShadowstepArena'..i]:SetAttribute("type", "macro")
		buttons['ShadowstepArena'..i]:RegisterForClicks("AnyDown")
		buttons['ShadowstepArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Shadowstep")

		buttons['ShadowstepKickArena'..i] = CreateFrame("Button", "ShadowstepKickArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ShadowstepKickArena'..i]:SetAttribute("type", "macro")
		buttons['ShadowstepKickArena'..i]:RegisterForClicks("AnyDown")
		buttons['ShadowstepKickArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Shadowstep\n/cast [@arena"..i.."] Kick")

		buttons['ShadowstepKidneyArena'..i] = CreateFrame("Button", "ShadowstepKidneyArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ShadowstepKidneyArena'..i]:SetAttribute("type", "macro")
		buttons['ShadowstepKidneyArena'..i]:RegisterForClicks("AnyDown")
		buttons['ShadowstepKidneyArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Shadowstep\n/cast [@arena"..i.."] Kidney Shot")

		buttons['DismantleArena'..i] = CreateFrame("Button", "DismantleArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['DismantleArena'..i]:SetAttribute("type", "macro")
		buttons['DismantleArena'..i]:RegisterForClicks("AnyDown")
		buttons['DismantleArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Dismantle")
	end

	for i = 1,5 do
		x = i-1

		if x ~= 0 then
			buttons['TricksParty'..x] = CreateFrame("Button", "TricksParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
			buttons['TricksParty'..x]:SetAttribute("type", "macro")
			buttons['TricksParty'..x]:RegisterForClicks("AnyDown")
			buttons['TricksParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Tricks of the Trade")
		end
	end

	
	-- Hunter
	buttons['CancelTrapLauncher'] = CreateFrame("Button", "CancelTrapLauncher-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['CancelTrapLauncher']:SetAttribute("type", "macro")
	buttons['CancelTrapLauncher']:RegisterForClicks("AnyDown")
	buttons['CancelTrapLauncher']:SetAttribute("macrotext", "/cancelaura Trap Launcher")

	buttons['AspectHawk'] = CreateFrame("Button", "AspectHawk-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['AspectHawk']:SetAttribute("type", "macro")
	buttons['AspectHawk']:RegisterForClicks("AnyDown")
	buttons['AspectHawk']:SetAttribute("macrotext", "/cast !Aspect of the Hawk")

	buttons['AspectCheetah'] = CreateFrame("Button", "AspectCheetah-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['AspectCheetah']:SetAttribute("type", "macro")
	buttons['AspectCheetah']:RegisterForClicks("AnyDown")
	buttons['AspectCheetah']:SetAttribute("macrotext", "/cast !Aspect of the Cheetah")

	buttons['AspectFox'] = CreateFrame("Button", "AspectFox-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['AspectFox']:SetAttribute("type", "macro")
	buttons['AspectFox']:RegisterForClicks("AnyDown")
	buttons['AspectFox']:SetAttribute("macrotext", "/cast !Aspect of the Fox")

	buttons['AspectPack'] = CreateFrame("Button", "AspectPack-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['AspectPack']:SetAttribute("type", "macro")
	buttons['AspectPack']:RegisterForClicks("AnyDown")
	buttons['AspectPack']:SetAttribute("macrotext", "/cast !Aspect of the Pack")

	buttons['AspectWild'] = CreateFrame("Button", "AspectWild-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['AspectWild']:SetAttribute("type", "macro")
	buttons['AspectWild']:RegisterForClicks("AnyDown")
	buttons['AspectWild']:SetAttribute("macrotext", "/cast !Aspect of the Wild")

	buttons['AbilitiesCCPet'] = CreateFrame("Button", "AbilitiesCCPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['AbilitiesCCPet']:SetAttribute("type", "macro")
	buttons['AbilitiesCCPet']:RegisterForClicks("AnyDown")
	buttons['AbilitiesCCPet']:SetAttribute("macrotext", "/use Bad Manner\n/use Sting\n/use Sonic Blast\n/use Web Wrap\n/use Web\n/use Venom Web Spray\n/use Lock Jaw\n/use Pin\n/use Snatch\n/use Clench")

	buttons['AbilitiesInterruptPet'] = CreateFrame("Button", "AbilitiesInterruptPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['AbilitiesInterruptPet']:SetAttribute("type", "macro")
	buttons['AbilitiesInterruptPet']:RegisterForClicks("AnyDown")
	buttons['AbilitiesInterruptPet']:SetAttribute("macrotext", "/use Serenity Dust\n/use Nether Shock\n/use Pummel\n/use Horn Toss")

	buttons['FocusScatter'] = CreateFrame("Button", "FocusScatter-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusScatter']:SetAttribute("type", "macro")
	buttons['FocusScatter']:RegisterForClicks("AnyDown")
	buttons['FocusScatter']:SetAttribute("macrotext", "/cast [@focus] Scatter Shot")

	buttons['FocusSilencingShot'] = CreateFrame("Button", "FocusSilencingShot-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusSilencingShot']:SetAttribute("type", "macro")
	buttons['FocusSilencingShot']:RegisterForClicks("AnyDown")
	buttons['FocusSilencingShot']:SetAttribute("macrotext", "/cast [@focus] Silencing Shot")

	buttons['FocusWyvern'] = CreateFrame("Button", "FocusWyvern-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusWyvern']:SetAttribute("type", "macro")
	buttons['FocusWyvern']:RegisterForClicks("AnyDown")
	buttons['FocusWyvern']:SetAttribute("macrotext", "/cast [@focus] Wyvern Sting")

	buttons['FocusIntimidation'] = CreateFrame("Button", "FocusIntimidation-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusIntimidation']:SetAttribute("type", "macro")
	buttons['FocusIntimidation']:RegisterForClicks("AnyDown")
	buttons['FocusIntimidation']:SetAttribute("macrotext", "/cast [@focus] Intimidation")

	buttons['FocusSilencingShotWyvernIntimidation'] = CreateFrame("Button", "FocusSilencingShotWyvernIntimidation-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusSilencingShotWyvernIntimidation']:SetAttribute("type", "macro")
	buttons['FocusSilencingShotWyvernIntimidation']:RegisterForClicks("AnyDown")
	buttons['FocusSilencingShotWyvernIntimidation']:SetAttribute("macrotext", "/cast [@focus] Silencing Shot\n/cast [@focus] Wyvern Sting\n/cast [@focus] Intimidation")

	buttons['FocusConcussive'] = CreateFrame("Button", "FocusConcussive-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusConcussive']:SetAttribute("type", "macro")
	buttons['FocusConcussive']:RegisterForClicks("AnyDown")
	buttons['FocusConcussive']:SetAttribute("macrotext", "/cast [@focus] Concussive Shot")

	buttons['FocusWingClip'] = CreateFrame("Button", "FocusWingClip-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusWingClip']:SetAttribute("type", "macro")
	buttons['FocusWingClip']:RegisterForClicks("AnyDown")
	buttons['FocusWingClip']:SetAttribute("macrotext", "/cast [@focus] Wing Clip")

	buttons['FocusAbilitiesCCPet'] = CreateFrame("Button", "FocusAbilitiesCCPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusAbilitiesCCPet']:SetAttribute("type", "macro")
	buttons['FocusAbilitiesCCPet']:RegisterForClicks("AnyDown")
	buttons['FocusAbilitiesCCPet']:SetAttribute("macrotext", "/use [@focus]Bad Manner\n/use [@focus]Sting\n/use [@focus]Sonic Blast\n/use [@focus]Web Wrap\n/use [@focus]Web\n/use [@focus]Venom Web Spray\n/use [@focus]Lock Jaw\n/use [@focus]Pin\n/use [@focus]Snatch\n/use [@focus]Clench")

	buttons['FocusAbilitiesInterruptPet'] = CreateFrame("Button", "FocusAbilitiesInterruptPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusAbilitiesInterruptPet']:SetAttribute("type", "macro")
	buttons['FocusAbilitiesInterruptPet']:RegisterForClicks("AnyDown")
	buttons['FocusAbilitiesInterruptPet']:SetAttribute("macrotext", "/use [@focus]Serenity Dust\n/use [@focus]Nether Shock\n/use [@focus]Pummel\n/use [@focus]Horn Toss")

	buttons['FocusMark'] = CreateFrame("Button", "FocusMark-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusMark']:SetAttribute("type", "macro")
	buttons['FocusMark']:RegisterForClicks("AnyDown")
	buttons['FocusMark']:SetAttribute("macrotext", "/cast [@focus] Hunter's Mark")

	buttons['FocusWidowVenom'] = CreateFrame("Button", "FocusWidowVenom-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusWidowVenom']:SetAttribute("type", "macro")
	buttons['FocusWidowVenom']:RegisterForClicks("AnyDown")
	buttons['FocusWidowVenom']:SetAttribute("macrotext", "/cast [@focus] Widow Venom")

	buttons['FocusTranq'] = CreateFrame("Button", "FocusTranq-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusTranq']:SetAttribute("type", "macro")
	buttons['FocusTranq']:RegisterForClicks("AnyDown")
	buttons['FocusTranq']:SetAttribute("macrotext", "/cast [@focus] Tranquilizing Shot")

	buttons['FocusScareBeast'] = CreateFrame("Button", "FocusScareBeast-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusScareBeast']:SetAttribute("type", "macro")
	buttons['FocusScareBeast']:RegisterForClicks("AnyDown")
	buttons['FocusScareBeast']:SetAttribute("macrotext", "/cast [@focus] Scare Beast")

	buttons['FocusKillShot'] = CreateFrame("Button", "FocusKillShot-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusKillShot']:SetAttribute("type", "macro")
	buttons['FocusKillShot']:RegisterForClicks("AnyDown")
	buttons['FocusKillShot']:SetAttribute("macrotext", "/cast [@focus] Kill Shot")

	buttons['FocusDistracting'] = CreateFrame("Button", "FocusDistracting-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusDistracting']:SetAttribute("type", "macro")
	buttons['FocusDistracting']:RegisterForClicks("AnyDown")
	buttons['FocusDistracting']:SetAttribute("macrotext", "/cast [@focus] Distracting Shot")

	buttons['FocusGrowlPet'] = CreateFrame("Button", "FocusGrowlPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['FocusGrowlPet']:SetAttribute("type", "macro")
	buttons['FocusGrowlPet']:RegisterForClicks("AnyDown")
	buttons['FocusGrowlPet']:SetAttribute("macrotext", "/cast [@focus] Growl")

	buttons['MouseoverScatter'] = CreateFrame("Button", "MouseoverScatter-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverScatter']:SetAttribute("type", "macro")
	buttons['MouseoverScatter']:RegisterForClicks("AnyDown")
	buttons['MouseoverScatter']:SetAttribute("macrotext", "/cast [@mouseover] Scatter Shot")

	buttons['MouseoverSilencingShot'] = CreateFrame("Button", "MouseoverSilencingShot-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverSilencingShot']:SetAttribute("type", "macro")
	buttons['MouseoverSilencingShot']:RegisterForClicks("AnyDown")
	buttons['MouseoverSilencingShot']:SetAttribute("macrotext", "/cast [@mouseover] Silencing Shot")

	buttons['MouseoverWyvern'] = CreateFrame("Button", "MouseoverWyvern-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverWyvern']:SetAttribute("type", "macro")
	buttons['MouseoverWyvern']:RegisterForClicks("AnyDown")
	buttons['MouseoverWyvern']:SetAttribute("macrotext", "/cast [@mouseover] Wyvern Sting")

	buttons['MouseoverIntimidation'] = CreateFrame("Button", "MouseoverIntimidation-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverIntimidation']:SetAttribute("type", "macro")
	buttons['MouseoverIntimidation']:RegisterForClicks("AnyDown")
	buttons['MouseoverIntimidation']:SetAttribute("macrotext", "/cast [@mouseover] Intimidation")

	buttons['MouseoverSilencingShotWyvernIntimidation'] = CreateFrame("Button", "MouseoverSilencingShotWyvernIntimidation-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverSilencingShotWyvernIntimidation']:SetAttribute("type", "macro")
	buttons['MouseoverSilencingShotWyvernIntimidation']:RegisterForClicks("AnyDown")
	buttons['MouseoverSilencingShotWyvernIntimidation']:SetAttribute("macrotext", "/cast [@mouseover] Silencing Shot\n/cast [@mouseover] Wyvern Sting\n/cast [@mouseover] Intimidation")

	buttons['MouseoverConcussive'] = CreateFrame("Button", "MouseoverConcussive-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverConcussive']:SetAttribute("type", "macro")
	buttons['MouseoverConcussive']:RegisterForClicks("AnyDown")
	buttons['MouseoverConcussive']:SetAttribute("macrotext", "/cast [@mouseover] Concussive Shot")

	buttons['MouseoverWingClip'] = CreateFrame("Button", "MouseoverWingClip-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverWingClip']:SetAttribute("type", "macro")
	buttons['MouseoverWingClip']:RegisterForClicks("AnyDown")
	buttons['MouseoverWingClip']:SetAttribute("macrotext", "/cast [@mouseover] Wing Clip")

	buttons['MouseoverAbilitiesCCPet'] = CreateFrame("Button", "MouseoverAbilitiesCCPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverAbilitiesCCPet']:SetAttribute("type", "macro")
	buttons['MouseoverAbilitiesCCPet']:RegisterForClicks("AnyDown")
	buttons['MouseoverAbilitiesCCPet']:SetAttribute("macrotext", "/use [@mouseover]Bad Manner\n/use [@mouseover]Sting\n/use [@mouseover]Sonic Blast\n/use [@mouseover]Web Wrap\n/use [@mouseover]Web\n/use [@mouseover]Venom Web Spray\n/use [@mouseover]Lock Jaw\n/use [@mouseover]Pin\n/use [@mouseover]Snatch\n/use [@mouseover]Clench")

	buttons['MouseoverAbilitiesInterruptPet'] = CreateFrame("Button", "MouseoverAbilitiesInterruptPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverAbilitiesInterruptPet']:SetAttribute("type", "macro")
	buttons['MouseoverAbilitiesInterruptPet']:RegisterForClicks("AnyDown")
	buttons['MouseoverAbilitiesInterruptPet']:SetAttribute("macrotext", "/use [@mouseover]Serenity Dust\n/use [@mouseover]Nether Shock\n/use [@mouseover]Pummel\n/use [@mouseover]Horn Toss")

	buttons['MouseoverMark'] = CreateFrame("Button", "MouseoverMark-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverMark']:SetAttribute("type", "macro")
	buttons['MouseoverMark']:RegisterForClicks("AnyDown")
	buttons['MouseoverMark']:SetAttribute("macrotext", "/cast [@mouseover] Hunter's Mark")

	buttons['MouseoverWidowVenom'] = CreateFrame("Button", "MouseoverWidowVenom-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverWidowVenom']:SetAttribute("type", "macro")
	buttons['MouseoverWidowVenom']:RegisterForClicks("AnyDown")
	buttons['MouseoverWidowVenom']:SetAttribute("macrotext", "/cast [@mouseover] Widow Venom")

	buttons['MouseoverTranq'] = CreateFrame("Button", "MouseoverTranq-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverTranq']:SetAttribute("type", "macro")
	buttons['MouseoverTranq']:RegisterForClicks("AnyDown")
	buttons['MouseoverTranq']:SetAttribute("macrotext", "/cast [@mouseover] Tranquilizing Shot")

	buttons['MouseoverScareBeast'] = CreateFrame("Button", "MouseoverScareBeast-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverScareBeast']:SetAttribute("type", "macro")
	buttons['MouseoverScareBeast']:RegisterForClicks("AnyDown")
	buttons['MouseoverScareBeast']:SetAttribute("macrotext", "/cast [@mouseover] Scare Beast")

	buttons['MouseoverKillShot'] = CreateFrame("Button", "MouseoverKillShot-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverKillShot']:SetAttribute("type", "macro")
	buttons['MouseoverKillShot']:RegisterForClicks("AnyDown")
	buttons['MouseoverKillShot']:SetAttribute("macrotext", "/cast [@mouseover] Kill Shot")

	buttons['MouseoverMisdirection'] = CreateFrame("Button", "MouseoverMisdirection-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverMisdirection']:SetAttribute("type", "macro")
	buttons['MouseoverMisdirection']:RegisterForClicks("AnyDown")
	buttons['MouseoverMisdirection']:SetAttribute("macrotext", "/cast [@mouseover] Misdirection")

	buttons['MouseoverDistracting'] = CreateFrame("Button", "MouseoverDistracting-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverDistracting']:SetAttribute("type", "macro")
	buttons['MouseoverDistracting']:RegisterForClicks("AnyDown")
	buttons['MouseoverDistracting']:SetAttribute("macrotext", "/cast [@mouseover] Distracting Shot")

	buttons['MouseoverGrowlPet'] = CreateFrame("Button", "MouseoverGrowlPet-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverGrowlPet']:SetAttribute("type", "macro")
	buttons['MouseoverGrowlPet']:RegisterForClicks("AnyDown")
	buttons['MouseoverGrowlPet']:SetAttribute("macrotext", "/cast [@mouseover] Growl")

	buttons['MouseoverRoarOfSacrifice'] = CreateFrame("Button", "MouseoverRoarOfSacrifice-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverRoarOfSacrifice']:SetAttribute("type", "macro")
	buttons['MouseoverRoarOfSacrifice']:RegisterForClicks("AnyDown")
	buttons['MouseoverRoarOfSacrifice']:SetAttribute("macrotext", "/cast [@mouseover] Roar of Sacrifice")

	buttons['MouseoverPetIntervene'] = CreateFrame("Button", "MouseoverPetIntervene-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverPetIntervene']:SetAttribute("type", "macro")
	buttons['MouseoverPetIntervene']:RegisterForClicks("AnyDown")
	buttons['MouseoverPetIntervene']:SetAttribute("macrotext", "/cast [@mouseover] Intervene")

	buttons['MouseoverRoSPetIntervene'] = CreateFrame("Button", "MouseoverRoSPetIntervene-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
	buttons['MouseoverRoSPetIntervene']:SetAttribute("type", "macro")
	buttons['MouseoverRoSPetIntervene']:RegisterForClicks("AnyDown")
	buttons['MouseoverRoSPetIntervene']:SetAttribute("macrotext", "/cast [@mouseover] Roar of Sacrifice\n/cast [@mouseover] Intervene")
	
	for i = 1,5 do
		buttons['ScatterArena'..i] = CreateFrame("Button", "ScatterArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ScatterArena'..i]:SetAttribute("type", "macro")
		buttons['ScatterArena'..i]:RegisterForClicks("AnyDown")
		buttons['ScatterArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Scatter Shot")

		buttons['SilencingShotArena'..i] = CreateFrame("Button", "SilencingShotArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SilencingShotArena'..i]:SetAttribute("type", "macro")
		buttons['SilencingShotArena'..i]:RegisterForClicks("AnyDown")
		buttons['SilencingShotArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Silencing Shot")

		buttons['WyvernArena'..i] = CreateFrame("Button", "WyvernArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['WyvernArena'..i]:SetAttribute("type", "macro")
		buttons['WyvernArena'..i]:RegisterForClicks("AnyDown")
		buttons['WyvernArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Wyvern Sting")

		buttons['IntimidationArena'..i] = CreateFrame("Button", "IntimidationArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['IntimidationArena'..i]:SetAttribute("type", "macro")
		buttons['IntimidationArena'..i]:RegisterForClicks("AnyDown")
		buttons['IntimidationArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Intimidation")

		buttons['SilencingShotWyvernIntimidationArena'..i] = CreateFrame("Button", "SilencingShotWyvernIntimidationArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SilencingShotWyvernIntimidationArena'..i]:SetAttribute("type", "macro")
		buttons['SilencingShotWyvernIntimidationArena'..i]:RegisterForClicks("AnyDown")
		buttons['SilencingShotWyvernIntimidationArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Silencing Shot\n/cast [@arena"..i.."] Wyvern Sting\n/cast [@arena"..i.."] Intimidation")

		buttons['AbilitiesCCPetArena'..i] = CreateFrame("Button", "AbilitiesCCPetArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['AbilitiesCCPetArena'..i]:SetAttribute("type", "macro")
		buttons['AbilitiesCCPetArena'..i]:RegisterForClicks("AnyDown")
		buttons['AbilitiesCCPetArena'..i]:SetAttribute("macrotext", "/use [@arena"..i.."]Bad Manner\n/use [@arena"..i.."]Sting\n/use [@arena"..i.."]Sonic Blast\n/use [@arena"..i.."]Web Wrap\n/use [@arena"..i.."]Web\n/use [@arena"..i.."]Venom Web Spray\n/use [@arena"..i.."]Lock Jaw\n/use [@arena"..i.."]Pin\n/use [@arena"..i.."]Snatch\n/use [@arena"..i.."]Clench")

		buttons['AbilitiesInterruptPetArena'..i] = CreateFrame("Button", "AbilitiesInterruptPetArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['AbilitiesInterruptPetArena'..i]:SetAttribute("type", "macro")
		buttons['AbilitiesInterruptPetArena'..i]:RegisterForClicks("AnyDown")
		buttons['AbilitiesInterruptPetArena'..i]:SetAttribute("macrotext", "/use [@arena"..i.."]Serenity Dust\n/use [@arena"..i.."]Nether Shock\n/use [@arena"..i.."]Pummel\n/use [@arena"..i.."]Horn Toss")

		buttons['ConcussiveArena'..i] = CreateFrame("Button", "ConcussiveArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ConcussiveArena'..i]:SetAttribute("type", "macro")
		buttons['ConcussiveArena'..i]:RegisterForClicks("AnyDown")
		buttons['ConcussiveArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Concussive Shot")

		buttons['MarkArena'..i] = CreateFrame("Button", "MarkArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['MarkArena'..i]:SetAttribute("type", "macro")
		buttons['MarkArena'..i]:RegisterForClicks("AnyDown")
		buttons['MarkArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Hunter's Mark")

		buttons['TranqArena'..i] = CreateFrame("Button", "TranqArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['TranqArena'..i]:SetAttribute("type", "macro")
		buttons['TranqArena'..i]:RegisterForClicks("AnyDown")
		buttons['TranqArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Tranquilizing Shot")

		buttons['ScareBeastArena'..i] = CreateFrame("Button", "ScareBeastArena"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ScareBeastArena'..i]:SetAttribute("type", "macro")
		buttons['ScareBeastArena'..i]:RegisterForClicks("AnyDown")
		buttons['ScareBeastArena'..i]:SetAttribute("macrotext", "/cast [@arena"..i.."] Scare Beast")

		buttons['ScareBeastArenaPet'..i] = CreateFrame("Button", "ScareBeastArenaPet"..i.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['ScareBeastArenaPet'..i]:SetAttribute("type", "macro")
		buttons['ScareBeastArenaPet'..i]:RegisterForClicks("AnyDown")
		buttons['ScareBeastArenaPet'..i]:SetAttribute("macrotext", "/cast [@arenapet"..i.."] Scare Beast")
	end

	
	for i = 1,5 do
		x = i-1

		buttons['MastersCallParty'..x] = CreateFrame("Button", "MastersCallParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['MastersCallParty'..x]:SetAttribute("type", "macro")
		buttons['MastersCallParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['MastersCallParty'..x]:SetAttribute("macrotext", "/cast [@player] Master's Call")
		else
			buttons['MastersCallParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Master's Call")
		end

		buttons['RoarOfSacrificeParty'..x] = CreateFrame("Button", "RoarOfSacrificeParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['RoarOfSacrificeParty'..x]:SetAttribute("type", "macro")
		buttons['RoarOfSacrificeParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['RoarOfSacrificeParty'..x]:SetAttribute("macrotext", "/cast [@player] Roar of Sacrifice")
		else
			buttons['RoarOfSacrificeParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Roar of Sacrifice")
		end

		buttons['PetInterveneParty'..x] = CreateFrame("Button", "PetInterveneParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['PetInterveneParty'..x]:SetAttribute("type", "macro")
		buttons['PetInterveneParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['PetInterveneParty'..x]:SetAttribute("macrotext", "/cast [@player] Intervene")
		else
			buttons['PetInterveneParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Intervene")
		end

		buttons['SpiritMendParty'..x] = CreateFrame("Button", "SpiritMendParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['SpiritMendParty'..x]:SetAttribute("type", "macro")
		buttons['SpiritMendParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['SpiritMendParty'..x]:SetAttribute("macrotext", "/cast [@player] Spirit Mend")
		else
			buttons['SpiritMendParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Spirit Mend")
		end

		buttons['AbilitiesPetParty'..x] = CreateFrame("Button", "AbilitiesPetParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
		buttons['AbilitiesPetParty'..x]:SetAttribute("type", "macro")
		buttons['AbilitiesPetParty'..x]:RegisterForClicks("AnyDown")
		if x == 0 then
			buttons['AbilitiesPetParty'..x]:SetAttribute("macrotext", "/cast [@player] Roar of Sacrifice\n/cast [@player] Intervene\n/cast [@player] Spirit Mend")
		else
			buttons['AbilitiesPetParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Roar of Sacrifice\n/cast [@party"..x.."] Intervene\n/cast [@party"..x.."] Spirit Mend")
		end

		if x ~= 0 then
			buttons['MisdirectionParty'..x] = CreateFrame("Button", "MisdirectionParty"..x.."-Btn", AdditionalBinds_EventFrame, "SecureActionButtonTemplate")
			buttons['MisdirectionParty'..x]:SetAttribute("type", "macro")
			buttons['MisdirectionParty'..x]:RegisterForClicks("AnyDown")
			buttons['MisdirectionParty'..x]:SetAttribute("macrotext", "/cast [@party"..x.."] Misdirection")
		end

	end
end